/*
 * PRC-Tools ֺ ץץ 4
 *
 * Copyright (c) 2002 WATANABE, Yoshiki
 */

#include <PalmOS.h>
#include "BitmapHelloWorldRsc.h"

UInt32 RomVersion;				  /* OS ΥС */
#define PalmOS35 0x03503000	  /* PalmOS 3.5  RomVersion */
UInt32 SavedDepth;

/*
 * StartApplication -- ץꥱνԤʤ
 * 
 * MainForm 򳫤
 */
static Err StartApplication(void)
{
    FtrGet(sysFtrCreator, sysFtrNumROMVersion, &RomVersion);
    if (RomVersion >= PalmOS35) {
	WinScreenMode(winScreenModeGet, NULL, NULL, &SavedDepth, NULL);
    }
    FrmGotoForm(MainForm); // MainForm 򳫤
    return errNone;
}

/*
 * OpenAboutDialog -- About ɽ
 * 
 * AboutDialog 򳫤, OK 줿Ȥ˾õ
 */
static void OpenAboutDialog(void)
{
    FormPtr form = FrmInitForm(AboutDialog);
    FrmDoDialog(form);
    FrmDeleteForm(form);
}

/*
 * ChangeColorDepth -- ѹ
 * 
 * PalmOS 3.5 ʾǤпѹ
 */
static void ChangeColorDepth(UInt32 depth)
{
    if (RomVersion >= PalmOS35) {
	WinScreenMode(winScreenModeSet, NULL, NULL, &depth, NULL);
	FrmUpdateForm(MainForm, frmRedrawUpdateCode);
    }
}

/*
 * MainFormHandleEvent -- MainForm ˴ؤ륤٥Ȥ
 * 
 * MainForm ν˴ؤ륤٥Ȥ
 */
static Boolean MainFormHandleEvent(EventPtr event)
{
    Boolean handled = false;

    switch (event->eType) {
    case frmOpenEvent: // MainForm 줿
	FrmDrawForm(FrmGetActiveForm()); // MainForm ɽ
	handled = true;
	break;
    case menuEvent: // ˥塼Ф줿
	switch (event->data.menu.itemID) {
	case MainFormScreenDepth1Cmd: // "B/W" 򤵤줿
	    ChangeColorDepth(1);
	    handled = true;
	    break;
	case MainFormScreenDepth2Cmd: // "2 Bit Grayscale" 򤵤줿
	    ChangeColorDepth(2);
	    handled = true;
	    break;
	case MainFormScreenDepth4Cmd: // "4 Bit Grayscale" 򤵤줿
	    ChangeColorDepth(4);
	    handled = true;
	    break;
	case MainFormScreenDepth8Cmd: // "256 Colors" 򤵤줿
	    ChangeColorDepth(8);
	    handled = true;
	    break;
	case MainFormAboutCmd: // "About..." 򤵤줿
	    OpenAboutDialog(); // About ̤ɽ
	    handled = true;
	    break;
	}
	break;
    }

    return handled;
}

/*
 * ApplicationHandleEvent -- ץꥱΤ˴ؤ륤٥Ȥ
 * 
 * 줿ե򥢥ƥ֤ˤ٥ȥϥɥꤹ
 */
static Boolean ApplicationHandleEvent(EventPtr event)
{
    Boolean handled = false;

    if (event->eType == frmLoadEvent) { // եɤ
	UInt16 formId = event->data.frmLoad.formID; // ɤե ID
						    //  (ǤϾ
						    // MainForm)
	FormPtr form =  FrmInitForm(formId); // եɤƽ

	FrmSetActiveForm(form); // ɤե򥢥ƥ֤ˤ

	switch (formId) {
	case MainForm:
	    // ΥեФ륤٥Ȥ MainFormHandleEvent 
	    // 褦ꤹ
	    FrmSetEventHandler(form, MainFormHandleEvent);
	    break;
	}
	handled = true;
    }

    return handled;
}

/*
 * EventLoop -- ٥ȤɬפʽԤʤ
 * 
 * ٥Ȥ API, ؿŬƤӽФ
 */
static void EventLoop(void)
{
    EventType event;

    do {
	EvtGetEvent(&event, evtWaitForever); // Υ٥Ȥ
	if (!SysHandleEvent(&event)) { // ƥϢΥ٥Ȥ
	    Err error;
	    if (!MenuHandleEvent(NULL, &event, &error)) { // ˥塼ϢΥ
							  // ٥Ȥ
							  // (ǤϽ
							  // ٤٥ȤϤ
							  // )
		if (!ApplicationHandleEvent(&event)) {
		    // ߤΥեǥ٥ȥϥɥȤꤵƤؿ
		    // ƤӽФ (Ǥ MainFormHandleEvent ƤФ)
		    FrmDispatchEvent(&event);
	      }
	   }
	}
    } while (event.eType != appStopEvent); // λΥ٥ȤޤǷ֤
}


/*
 * StopApplication -- ץꥱνλνԤʤ
 * 
 * Ƥե frmSave , ΥեĤ
 */
static void StopApplication(void)
{
    FrmSaveAllForms();
    FrmCloseAllForms();
    if (RomVersion >= PalmOS35) {
	WinScreenMode(winScreenModeSet, NULL, NULL, &SavedDepth, NULL);
    }
}

/*
 * PilotMain -- ΥץꥱΥᥤؿǤ
 * 
 * ΥץǤ̾εưˡ (sysAppLaunchCmdNormalLaunch) ǤΤư
 */
UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
    Err error = errNone;

    switch (cmd) {
    case sysAppLaunchCmdNormalLaunch:
	error = StartApplication();
	EventLoop();
	StopApplication();
	break;
    }

    return error;
}
