#include "jdoc.h"

void 
CreateFileListInDirectory(UInt16 volRefNum, MemHandle *dbListH, int*size)
{
	UInt32 iterator;
	int numFiles;
	FileInfoType finfo;
	FileRef dir_file;
	char file_name[256],path_name[256];
//	char database_name[33];
	MSFileType *dbP;
//	Err err;
//	UInt32 type,creator;
	
	iterator = 0;
	numFiles =0;
	
	*dbListH = MemHandleNew(1);
	
	while(1){
		finfo.nameP = file_name;
		finfo.nameBufLen = 255;
		if ( SearchForFilesInDirectory( volRefNum, &dir_file, card_path,
							&iterator, &finfo) == false)
			break;

		StrCopy( path_name, card_path);
		StrCat( path_name, finfo.nameP);
										
		numFiles++;
		if ( MemHandleResize( *dbListH, numFiles * sizeof( MSFileType)) != 0) // If failed
			break;
		dbP = MemHandleLock( *dbListH);
		StrCopy( (dbP + (numFiles-1))->file_name, finfo.nameP);
		MemHandleUnlock (*dbListH);
	}
	
	*size = numFiles;


	return;
}

void
CreateMSFileList(MemHandle *file_listHP, int *num_filesP)
{
	FormType *form;
	MSFileType *fileList;
	
	if ( *file_listHP)
		MemHandleFree( *file_listHP);	

	form = ShowWaitWindow();

	CreateFileListInDirectory( volumeRefNum, file_listHP, num_filesP);
	fileList = MemHandleLock( *file_listHP);
	
// Sort documents
//	SysInsertionSort ( fileList, *num_filesP, sizeof( MSFileType), CompFunc,0);

	MemHandleUnlock( *file_listHP);

	EraseWaitWindow( form);
}

Err NotifyDisplayChanged(SysNotifyParamType *notifyParamsP) 
{
	RectangleType rect;
	EventType ev;
	char buf[128];

	DisplayStateChanged  = true;

//	ev.eType =displayExtentChangedEvent;
//	EvtAddEventToQueue( &ev);

	return errNone;
}

Err NotifyMounted (SysNotifyParamType *notifyParamsP) 
{
	MediaExists = true;
	NeedResearchDocumentList = true;
	if ( prefs.currentView == MainForm){ // If it'S main form , need refreshing
		CardStateChanged	= true;
	}

// Disable App switching in PalmOS4.0
	notifyParamsP->handled |= vfsHandledUIAppSwitch;

	{
		EventType fake;
		fake.eType = nilEvent;
		EvtAddEventToQueue( &fake);		
	}

	return errNone;
}

Err NotifyUnmounted (SysNotifyParamType *notifyParamsP) 
{
//	if ( (FrmGetActiveFormID() != MainForm) &&  (prefs.storage_mode == STORAGE_MS) )
//		FrmGotoForm( MainForm);
	MediaExists = false;
	
	if ( (prefs.storage_mode == STORAGE_CARD) || ( prefs.currentView == MainForm ) ){
		CardStateChanged	= true;
	}
	
	{
		EventType fake;
		fake.eType = nilEvent;
		EvtAddEventToQueue( &fake);		
	}
	
	return errNone;
}

static Boolean
CheckForStorage()
{
	int numVols ;
	VolumeInfoType info;
//	ExpCardInfoType cardInfo;
	static Boolean MultiCardAlerted=false; // Already alerted.

	if (! MachineFunctionality.supportExternalMedia)
		return false;	
	
	numVols = MSGetNumVolumes();

	if ( numVols == 0){
		MediaExists = false;
		return false;
	} else if ( numVols > 1 && (!MultiCardAlerted)){
		FrmAlert( MultiCardNotSupportedAlert);
		MultiCardAlerted = true;
	}
	
	MediaExists = true;
	volumeRefNum = MSGetVolumeRefNum( 0);
	MemSet(&info, sizeof(info), 0);
	VFSVolumeInfo(volumeRefNum, &info);
	if ((info.attributes & vfsVolumeAttrReadOnly) != 0 ){
//	    || ExpCardInfo(info.slotRefNum, &cardInfo) != 0 ||
//		(cardInfo.capabilityFlags & expCapabilityReadOnly) != 0) {
		MediaWritable = false;
	} else {
		MediaWritable = true;
	}

	if ( MediaExists)
	{
		FileRef dir;
		UInt32  attr;
		Boolean deleteFirst= false;
		Boolean notFound= false;
		Err err;
		UInt16 buf_len;
		if ( MachineFunctionality.vfsManagerVersion >= 2){
			buf_len = 128;
			VFSGetDefaultDirectory( volumeRefNum , ".txt", card_path , &buf_len);
			if ( *(card_path + StrLen( card_path) -1) != '/')
				StrCat ( card_path , "/");

		}
		else
			StrCopy( card_path, MS_TEXT_PATH);
				
		err = VFSFileOpen( volumeRefNum, card_path, vfsModeRead , &dir);
		if ( err == errNone){
			err =  VFSFileAttributesGet(dir, &attr);
			if ( attr & vfsFileAttrDirectory == 0){ // It's  not directory
				deleteFirst = true;
			}
			VFSFileClose( dir);
		} else if ( err == vfsErrFileNotFound) { 
			notFound = true;
		} else {
			return false; // Unknown error
		}
		
		if ( notFound || deleteFirst){ // if there's none or it's file. Let's ask and make directory
			
			if ( MediaWritable ){		
				if ( MachineFunctionality.vfsManagerVersion == 1){
					VFSFileDelete( volumeRefNum, "/palm/programs/text");
					CheckCreate(  volumeRefNum, "/palm");
					CheckCreate( volumeRefNum, "/palm/programs");
					CheckCreate( volumeRefNum, "/palm/programs/text");
				} else
					VFSFileDelete ( volumeRefNum, card_path);
					CheckCreate( volumeRefNum, card_path );
			}
		}
	}

	
	
	return true;
		
}

static void GetDocumentList(Boolean search_previous, UInt16 *find_cardNo, LocalID *find_dbID)
{
	Err		err;			// P5. error code
	UInt		cardNo;			// P5. card containing the application database
	LocalID	dbID,localID;				// P5. handle for application database
	VoidPtr p;
//	int i; 
	Boolean newSearch;
	DmSearchStateType stateInfo;
	char	name[33];
	ULong crDate;
	ULong bytes,pages;
//	Word prefs_size;
	int hide_private;
	DmOpenRef doc_db;
	UInt attr;
	
// Read system preference Hide Private
	hide_private = PrefGetPreference (	prefHidePrivateRecordsV33 );

// now let's search DOC type databases

	newSearch = true;
	TotalDocuments = 0;
	CurrentDBNumber = noSelected;
	localID = noSelected;
	
	while ( TotalDocuments < MAX_DOCUMENTS ){
// Search for next document
		err = DmGetNextDatabaseByTypeCreator (newSearch, &stateInfo, DocDBType, DocDBCreator, false, &cardNo, &dbID);
		newSearch = false;	
		if ( err == dmErrCantFind )
			break;

// Let's see is record 0 is SECRET.( this means this document is secret )
		doc_db = DmOpenDatabase ( cardNo, dbID, dmModeReadOnly);
		DmRecordInfo (doc_db,0,  &attr, nil, nil); 
		DmCloseDatabase( doc_db);

// if it's marked as SECRET and mode is Hide Private, let's pass it
		if ( ( attr & dmRecAttrSecret ) && hide_private) 
			continue;
			
// Get name and creat Date
		err = DmDatabaseInfo (cardNo, dbID, name, nil, nil,&crDate, nil, nil, nil, nil, nil, nil,nil);
		ErrFatalDisplayIf(err, "Fatal error in DmDatabaseInfo");

		p = MemPtrNew( sizeof ( document_infoType));
		doc_infos[ TotalDocuments] =  (document_infoP)p;
		doc_infos[ TotalDocuments] ->card_no = cardNo;
		doc_infos[ TotalDocuments] ->local_id = dbID;
		DmDatabaseSize(cardNo, dbID, &pages,nil, &bytes ); 
		doc_infos[ TotalDocuments]->size = (bytes+999) / 1000; // round up 

// is this formerly reading document? Check ID,CardNo and Creation Date. and remember it's LocalID
		if ( search_previous)
			if ( (prefs.storage_mode == STORAGE_INTERNAL) && (CurrentDBlocalId == dbID) && (CurrentDBcard == cardNo) && ( CurrentCreateDate == crDate ))
				*find_dbID  = dbID; // Found the formerly reading Database

		StrCopy ( doc_infos[ TotalDocuments] ->name, name);
		TotalDocuments++;
	}

// Sort documents
	SysInsertionSort ( &doc_infos, TotalDocuments, sizeof( document_infoP), CompFunc,0);


}

FontID HDFontChoose( FontID current_font)
{
	FormType *font_form;
	Int16 result;
	FormActiveStateType state;
	FontID choose = current_font;
	UInt16 id;
	
	FrmSaveActiveState (&state) ;

	font_form = FrmInitForm( HDFontChooseForm);
	FrmSetActiveForm( font_form);

	switch ( current_font){
	 	case hrTinyFont:
			id = HDFontChooseTinyPushButton;
			break;
	 	case hrSmallFont:
			id = HDFontChooseSmallPushButton;
			break;
	 	case hrStdFont:
			id = HDFontChooseStandardPushButton;
			break;
	 	case hrLargeFont:
			id = HDFontChooseLargePushButton;
			break;
		default:
		id = HDFontChooseStandardPushButton;
			break;
	}
	
	FrmSetControlGroupSelection (font_form ,1,  id );

	FrmDrawForm( font_form);
	
	result = FrmDoDialog( font_form);
	if ( result == HDFontChooseOkButton ){
		id = FrmGetObjectId( FrmGetActiveForm() , FrmGetControlGroupSelection (font_form ,1 ));
		switch ( id ){
		 	case HDFontChooseTinyPushButton:
				choose = hrTinyFont;
				break;
		 	case HDFontChooseSmallPushButton:
				choose = hrSmallFont;
				break;
		 	case HDFontChooseStandardPushButton:
				choose = hrStdFont;
				break;
		 	case HDFontChooseLargePushButton:
				choose = hrLargeFont;
				break;
		}
	}

	FrmEraseForm( font_form);
	FrmDeleteForm( font_form);
	
	FrmRestoreActiveState (&state) ;
	return choose;
}

static void GetScreenExtent(void)
{
	Coord x,y;

	WinGetDisplayExtent( &x,&y);
	screenWidth = x ;
	screenHeight = y;
/*
	if ( MachineFunctionality.supportHiResolution){
		screenWidth = x ;
 		screenHeight = y;
	} else if ( MachineFunctionality.supportHighDensity){
		UInt32 width, height;

		WinScreenGetAttribute(winScreenWidth, &width);
		WinScreenGetAttribute(winScreenHeight, &height);

		screenWidth = width;
 		screenHeight = height;
	} else { 
		screenWidth = x;
		screenHeight = y;
	}
*/
}

static Int16 MyGetFontHeight( FontID font )
{
	Int16 result;
	FontID f;
	Int16 scale;
	
	if ( (  MachineFunctionality.supportHighDensity  && ( MachineFunctionality.nativeDensity == kDensityDouble )   )   || MachineFunctionality.supportHiResolution  ){
		if ( font == hrLargeFont){
			scale = 2;
			f = largeFont;
		} else if ( font == hrStdFont ){
			scale = 2;
			f  = stdFont;
		} else if ( font == hrTinyFont ){
			scale = 1;
			f = stdFont;
		} else if ( font == hrSmallFont ){
			scale = 1;
			f = largeFont;
		}

 		FntSetFont( f );
		if ( scale == 2)
			result = FntCharHeight();
		else 
			result = ( FntCharHeight() + 1 ) / 2;	
	} else {
 		FntSetFont( DisplayFont);
		result = FntCharHeight();
	}
	
	return result;
}

static void AdjustCampusSize(void)
{
	GetScreenExtent();
	gScale = 1;
	
	if ( !MachineFunctionality.supportHandEraHiRes){
		if ( ( prefs.orientation == 0 ) ||( prefs.orientation == 2 ) ){
			campusWidth =  screenWidth;
			campusHeight = screenHeight;
		} else {
			campusWidth =  screenHeight;
			campusHeight = screenWidth;
		} 
	} else { // HandEra always campus=screen
			campusWidth =  screenWidth;
			campusHeight = screenHeight;
	}
	
	if ( MachineFunctionality.supportHiResolution ){ // Clie Hi Reso
		gScale = 2;
	} else if (   (  MachineFunctionality.supportHighDensity  && ( MachineFunctionality.nativeDensity == kDensityDouble )   ) ){
		gScale = 2;
	}
	
// set constants to display page.

	LineSpace = MyGetFontHeight( DisplayFont);
//	FntSetFont( DisplayFont);
//	LineSpace = FntCharHeight();

//	if ( MachineFunctionality.supportHiResolution ){
//		PageLine = (campusHeight-10 ) / LineSpace ;
//	} else {
		PageLine = (campusHeight- 5) / LineSpace ;
//	}
	
	ScrollLines = PageLine - 1;

	{
	char buf[256];
	StrPrintF(buf," SCR(%d,%d) CMP(%d,%d)  DotsLine=%d PageLine=%d", screenWidth, screenHeight, campusWidth, campusHeight, LineSpace, PageLine);
//	FrmCustomAlert(Debu\gAlert,"Screen Changed", buf,"");
	}
}

void
HDDrawChars(char *c ,int len, int x, int y, FontID font)
{
	FontID f = stdFont;
	Boolean scale = 1;
	UInt32 free, max;
	
	MemHeapFreeBytes (0, &free, &max) ;


	if ( font == hrLargeFont){
		scale = 2;
		f  = largeFont;
	} else if ( font == hrStdFont ){
		scale = 2;
		f = stdFont;
	} else if ( font == hrTinyFont ){
		scale = 1;
		f = stdFont;
	} else if ( font == hrSmallFont ){
		scale = 1;
		f = largeFont;
	}
	
	if ( scale == 2){
		FntSetFont( f );
		WinDrawChars( c, len, x, y);
	} else {
		Err err;
		BitmapType *bitmap;
		BitmapTypeV3 *bitmap3;
		WindowType *offscreen;
		WindowType *current;
		RectangleType rect;

		current= WinGetDrawWindow();
		WinPushDrawState();
		WinSetCoordinateSystem( kCoordinatesDouble );
		
		bitmap  = BmpCreate( 480,32,1,(ColorTableType *)&mono_clut,&err);
		bitmap3 = BmpCreateBitmapV3( bitmap, kCoordinatesStandard, BmpGetBits( bitmap), (ColorTableType *)&mono_clut);
//		BmpSetDensity( bitmap, kCoordinatesStandard );
		offscreen = WinCreateBitmapWindow( (BitmapType *)bitmap3, &err);
//		offscreen = WinCreateOffscreenWindow( 320,32,genericFormat, &err);
		FntSetFont( f );

		WinSetDrawWindow(offscreen);
		WinSetBackColor( 0 );
		WinSetForeColor( 1 );
		WinSetTextColor(1 );
				
		WinDrawChars( c, len, 0,0);

		WinDeleteWindow( offscreen, false);
		BmpSetDensity( (BitmapType *)bitmap3 , kCoordinatesDouble);
		offscreen = WinCreateBitmapWindow( (BitmapType *)bitmap3, &err);

		RctSetRectangle( &rect,0,0,480,(  ( FntCharHeight() + 2) / 2 + 1 ) / 2 * 2);
		WinCopyRectangle( offscreen, current, &rect, x*2,y*2, winPaint);
		
		WinDeleteWindow( offscreen, false);
		BmpDelete( (BitmapType *)bitmap3);
		BmpDelete( bitmap);
		WinPopDrawState();
		WinSetDrawWindow(current);
	}

	MemHeapFreeBytes(0, &free, &max) ;
}


static Boolean StartApplication(void)
{
	Err		err;			// P5. error code
	UInt		cardNo;			// P5. card containing the application database
	LocalID	dbID,localID;				// P5. handle for application database
	int i; 
	Boolean newSearch;
	DmSearchStateType stateInfo;
	char	name[33];
	ULong crDate;
	ULong bytes,pages;
	Word prefs_size;
	int hide_private;
	DmOpenRef doc_db;
	UInt attr;
	Err error;

//	screenWidth =  screenHeight = 160;
	MainFormFont = stdFont;
	
	IsColorOS = MachineFunctionality.supportColorDrawing;

// Read system preference Hide Private
	hide_private = PrefGetPreference (	prefHidePrivateRecordsV33 );
	
// Check for CLIE HiRes
	if ( MachineFunctionality.supportHiResolution){
		error = SysLibFind(sonySysLibNameHR, &hrRefNum);
		if ( error ){
			ErrFatalDisplay("Can't get reference number for HiRes library");
		}
		ChangeToHiResMode(hrRefNum);

// Check for HandEra HiRes
	} else if ( MachineFunctionality.supportHandEraHiRes){
		VgaSetScreenMode( screenMode1To1 , rotateModeNone);
		MainFormFont = largeFont;
	}	

// Check for CLIE Soft Silk
	if ( MachineFunctionality.supportClieSoftSilk){
//		SndPlaySystemSound( sndAlarm);
	        if (SysLibFind("Sony Silk Library", (UInt16*)&SLKref) != errNone){
	                if(SysLibLoad('libr', 'SlSi', (UInt16*)&SLKref)!=errNone){
	                        return 0;
	                }
	        }
	        if(SilkLibOpen (SLKref)==errNone){
	                SilkLibEnableResize(SLKref);
	        }

		{
			UInt16 cardNo;
			LocalID dbID;
			
			SysCurAppDatabase (&cardNo, &dbID);

			SysNotifyRegister( cardNo, dbID, sysNotifyDisplayChangeEvent, NotifyDisplayChanged,  sysNotifyNormalPriority, 0) ;
		}
	}


// Check for Jog Assist on CLIE 2
	if ( MachineFunctionality.hasJogAssist ){	
		UInt16 **maskPP;

		if(!FtrGet(sonySysFtrCreator, sonySysFtrNumJogAstMaskP,(UInt32 *)&maskPP)) {
			saveJogAsisstMaskPtr =*maskPP;
			*maskPP = (UInt16 *)jogAsisstMask;
		}
	}


// Get the preference. If not initialize it.
	prefs_size= sizeof (JDocPreferenceType);
	if (( noPreferenceFound == PrefGetAppPreferences (JDocAppType, 0, &prefs, &prefs_size, false )) || ( prefs_size != sizeof( JDocPreferenceType)) ){
		prefs.currentView = MainForm;
		CurrentDBlocalId = noSelected;
		CurrentDBcard = noSelected;
		CurrentRecord = noSelected;
		topOfPage =noSelected;	// View form
		prefs.orientation = 0; // normal

		button_action[BUTTON_TAP_UPPER]=ACTION_PREVIOUS_SCREEN; 
		button_action[BUTTON_TAP_LOWER]=ACTION_NEXT_SCREEN;
		button_action[BUTTON_UP_BUTTON]=ACTION_PREVIOUS_SCREEN; 
		button_action[BUTTON_DOWN_BUTTON]=ACTION_NEXT_SCREEN;
		button_action[BUTTON_DATE_BUTTON] = ACTION_PREVIOUS_DOCUMENT; 
		button_action[BUTTON_ADDRESS_BUTTON] = ACTION_PREVIOUS_TOPIC;
		button_action[BUTTON_TODO_BUTTON] = ACTION_NEXT_TOPIC;
		button_action[BUTTON_JOG_UP] = ACTION_NEXT_TOPIC;
		button_action[BUTTON_JOG_DOWN] = ACTION_NEXT_SCREEN;
		button_action[BUTTON_JOG_PAGE_UP] = ACTION_PREVIOUS_TOPIC;
		button_action[BUTTON_JOG_PAGE_DOWN] = ACTION_PREVIOUS_SCREEN;
		button_action[BUTTON_JOG_RELEASE] = ACTION_CLOSE_DOCUMENT;
		
		if ( MachineFunctionality.supportHiResolution || (  MachineFunctionality.supportHighDensity  && ( MachineFunctionality.nativeDensity == kDensityDouble )   ) ){
			DisplayFont =  hrSmallFont ;
		} else {
			 DisplayFont =  stdFont;
		}
		
		prefs.storage_mode = STORAGE_INTERNAL;
		
		InitialUse(); // Show Splash Screen, Install Initial document
	} else {
		CurrentDBlocalId = prefs.currentDBlocalId;
		CurrentDBcard = prefs.currentDBcard;
		CurrentCreateDate = prefs.currentCreateDate;
		CurrentRecord = prefs.currentRecord;
		topOfPage =prefs.topVisibleLine ;	
//		Orientation = prefs.orientation ;

		for ( i= 0; i < NUM_BUTTON ;i++)
			button_action[i]=prefs.button_action[i];

		DisplayFont = prefs.font;
	}

// Now for Storage related

	GetDocumentList(true, &cardNo, &localID);	

	CurrentDBNumber = noSelected;
// Let's search for the formerly reading document by LocalID
	for ( i =0; i < TotalDocuments; i++)
		if ( doc_infos[ i]->local_id == localID)
			CurrentDBNumber = i;

	CheckForStorage(); // Check memory card
	
	if ( ( prefs.storage_mode == STORAGE_INTERNAL) && (CurrentDBNumber == noSelected) ){  // can't find formerly readingdatabase
		prefs.currentView = MainForm;
	}

	if ( prefs.storage_mode == STORAGE_CARD && !MediaExists){
		prefs.storage_mode = STORAGE_INTERNAL;
		prefs.currentView = MainForm;
	}

	if ( prefs.storage_mode == STORAGE_CARD){
		int i;

		CreateMSFileList(&MSFileListH, &numMSFiles);
		MSFileListP = MemHandleLock ( MSFileListH);

		for ( i = 0 ; i  < numMSFiles; i++){
			if ( StrCompare( (MSFileListP+i)->file_name , prefs.file_name ) == 0)
				 CurrentDBNumber = i;		
		}
		
		if ( CurrentDBNumber == noSelected)
			prefs.currentView = MainForm;
				
	}		


// Invalidate Tail Buffer
	TailBufferRecordNum=-99;
	TailBuffer=0; // 0 means not allocated yet

	NextOpenDocument=-1;
	GotoBottomFlag=0;
	DeleteDBNumber = noSelected;	

// Void displayed data
	displayedTopOfPage= -1;
	displayedRecord = -1;

// Initialize Data handle. They'll be allocated after when necessary.
	dataHandle = nil;
	lineInfoHandle = nil;

	mono_clut.clut.numEntries = 2;
	mono_clut.rgb[0].index = 0;
	mono_clut.rgb[0].index = 1;

	if ( MachineFunctionality.supportHighDensity ) {
		UIColorGetTableEntryRGB(UIFieldText, &mono_clut.rgb[1]);	
		UIColorGetTableEntryRGB(UIFormFill,&mono_clut.rgb[0]);
//		mono_clut.rgb[0].r = mono_clut.rgb[0].g = mono_clut.rgb[0].b = 0;
//		mono_clut.rgb[0].r = mono_clut.rgb[0].g = mono_clut.rgb[0].b = 0xff;
	} else {	
		mono_clut.rgb[0].r = mono_clut.rgb[0].g = mono_clut.rgb[0].b = 0;
		mono_clut.rgb[0].r = mono_clut.rgb[0].g = mono_clut.rgb[0].b = 0xff;
	}
		
	if (!(MachineFunctionality.supportColorDrawing )){
		ChangeToMonochromeMode();
		BackWindow = WinCreateOffscreenWindow( 160,160,genericFormat, &err );
		WorkWindow = WinCreateOffscreenWindow( 16,16,genericFormat, &err );
		ChangeToDefaultMode();
	} else { // PalmOS3.5 or later
		if ( MachineFunctionality.supportHiResolution){ // CLIE HiRes
			BackBitmap= HRBmpCreate( hrRefNum, 480,480,1,(ColorTableType *)&mono_clut,&err);
			BackWindow = HRWinCreateBitmapWindow( hrRefNum, BackBitmap, &err);
			WorkBitmap= HRBmpCreate(hrRefNum,  16,16,1,0,&err);
			WorkWindow = HRWinCreateBitmapWindow( hrRefNum, WorkBitmap, &err);
		} else if ( (  MachineFunctionality.supportHighDensity  && ( MachineFunctionality.nativeDensity == kDensityDouble )   ) ){ // OS 5 Double Density
			BitmapType *temp, *temp2;
			temp= BmpCreate( 480,480,1, 0,&err);
//			temp= BmpCreate( 480,480,1,(ColorTableType *)&mono_clut,&err);
//			BackBitmap = (BitmapType *)BmpCreateBitmapV3( temp, kCoordinatesStandard, BmpGetBits( temp ), (ColorTableType *)&mono_clut);
			BackBitmap = (BitmapType *)BmpCreateBitmapV3( temp, kCoordinatesStandard, BmpGetBits( temp ), 0 );
			BmpSetDensity( BackBitmap, kCoordinatesDouble);
			BackWindow = WinCreateBitmapWindow(  BackBitmap, &err);

//			temp2= BmpCreate( 16,16,1,(ColorTableType *)&mono_clut,&err);
			temp2= BmpCreate( 16,16,1,(ColorTableType *)0,&err);
//			WorkBitmap =   (BitmapType *)BmpCreateBitmapV3( temp2, kCoordinatesStandard, BmpGetBits( temp2 ), 0 );
			WorkBitmap =   (BitmapType *)BmpCreateBitmapV3( temp2, kCoordinatesStandard, BmpGetBits( temp2 ),(ColorTableType *) &mono_clut);
			BmpSetDensity( WorkBitmap, kCoordinatesDouble);
			WorkWindow = WinCreateBitmapWindow( WorkBitmap, &err);
		} else {
			BackBitmap= BmpCreate(160,160,1,0,&err);
			BackWindow = WinCreateBitmapWindow( BackBitmap, &err);
			WorkBitmap= BmpCreate(16,16,1,0,&err);
			WorkWindow = WinCreateBitmapWindow( WorkBitmap, &err);
		}		
	}

	if ( MachineFunctionality.supportExternalMedia){
		UInt16 cardNo;
		LocalID dbID;
		SysCurAppDatabase (&cardNo, &dbID);
		SysNotifyRegister( cardNo, dbID, sysNotifyVolumeMountedEvent, NotifyMounted, sysNotifyNormalPriority, 0) ;
		SysNotifyRegister( cardNo, dbID, sysNotifyVolumeUnmountedEvent, NotifyUnmounted, sysNotifyNormalPriority, 0) ;

		VFSRegisterDefaultDirectory( ".txt", ExpMediaType_Any , "/texts");
		VFSRegisterDefaultDirectory( ".text", ExpMediaType_Any , "/texts");

	}

// To show handle is free
	MSFileListH= 0;

	CardStateChanged	= false;
	DisplayStateChanged  = false;

// Must do after read preference because this use display font and screen rotate
	AdjustCampusSize();
	
	return false;
}

static void StopApplication(void)
{	int i;
	
	FrmCloseAllForms ();

	if ( MachineFunctionality.supportHiResolution)
		RevertToNormalMode(hrRefNum);

	if ( MachineFunctionality.hasJogAssist ){	
		UInt16 **maskPP;

		if(!FtrGet(sonySysFtrCreator, sonySysFtrNumJogAstMaskP,(UInt32 *)&maskPP)) {
			*maskPP = saveJogAsisstMaskPtr ;
		}
	}
		
	if ( dataHandle != nil ){
		MemHandleFree( dataHandle);
		dataHandle = nil;
	}

	if ( lineInfoHandle != nil ){
		MemHandleFree( lineInfoHandle);
		lineInfoHandle = nil;
	}
	
	if ( TailBuffer)
		MemPtrFree(TailBuffer);
	
	WinDeleteWindow(BackWindow,false);

	if ( IsColorOS)
		BmpDelete( BackBitmap);
	WinDeleteWindow(WorkWindow,false);
	if ( IsColorOS)
		BmpDelete( WorkBitmap);

	// Write the preferences / saved-state information.
	prefs.currentDBlocalId = CurrentDBlocalId;
	prefs.currentDBcard = CurrentDBcard;
	prefs.currentRecord = CurrentRecord;
	prefs.currentCreateDate = CurrentCreateDate  ;
	prefs.topVisibleLine = topOfPage;	
//	prefs.orientation = Orientation;
	for ( i = 0 ; i < NUM_BUTTON; i++)
		prefs.button_action[i] = button_action[i];
	prefs.font = DisplayFont;

// Save to the Unsaved Preference.		
	PrefSetAppPreferences (JDocAppType, 0,JDocVersionNum, &prefs, sizeof (JDocPreferenceType), false);

	while ( TotalDocuments ){
		MemPtrFree( doc_infos[ TotalDocuments - 1]);
		TotalDocuments--;
	}	
	
	if ( MSFileListP)
		MemPtrUnlock( MSFileListP);

	if (MSFileListH)
		MemHandleFree( MSFileListH);		

	if ( MachineFunctionality.supportExternalMedia ){
		UInt16 cardNo;
		LocalID dbID;
		SysCurAppDatabase (&cardNo, &dbID);
		SysNotifyUnregister( cardNo, dbID, sysNotifyVolumeMountedEvent, sysNotifyNormalPriority); 
		SysNotifyUnregister( cardNo, dbID, sysNotifyVolumeUnmountedEvent,  sysNotifyNormalPriority); 
	}

	if ( MachineFunctionality.supportClieSoftSilk){
		{
			UInt16 cardNo;
			LocalID dbID;
			
			SysCurAppDatabase (&cardNo, &dbID);
			SysNotifyUnregister( cardNo, dbID, sysNotifyDisplayChangeEvent,  sysNotifyNormalPriority) ;
		}

	        SilkLibClose (SLKref);
	}

}

static int ChangeToMonochromeMode()
{
	unsigned long depth;
	depth = 0x01;
    ScrDisplayMode(scrDisplayModeSet, NULL, NULL, &depth, NULL);

	return 0;
}

static int ChangeToDefaultMode()
{
    ScrDisplayMode(scrDisplayModeSetToDefaults, NULL, NULL, NULL, NULL);
	return 0;
}

// Document Name Compare Function. Used to Sort Document order
Int CompFunc( void *p1,void *p2,long other)
{
	return StrCaselessCompare( (*((document_infoP*)p1))->name,  (*((document_infoP*)p2))->name);
}

void HandEraRotateScreen( orientation)
{
	int rotate;
	
	if ( orientation == 0)
		rotate = rotateModeNone;
	else if ( orientation == 1)
		rotate = rotateMode90;
	else if ( orientation == 2)
		rotate = rotateMode180;
	else if ( orientation == 3)
		rotate = rotateMode270;

	VgaSetScreenMode( screenMode1To1, rotate);
}

void DrawCenter( char *message, int y)
{
	int x;
	x= FntCharsWidth( message, StrLen( message));
	if (  MachineFunctionality.supportHiResolution ){
		HRWinDrawChars( hrRefNum, message, StrLen(message), (screenWidth* gScale-x)/2,y);
	} else {
		WinDrawChars( message, StrLen(message), (screenWidth-x)/2,y);
	}
}

void InitialUse(void)
{
	Handle h;
	VoidPtr p;
	
// Install About J-DOC Reader Document.

	h = DmGetResource('Dimg',1000);
	if ( h){
		p = MemHandleLock(h);
		DmCreateDatabaseFromImage( p );
		MemHandleUnlock( h);
		DmReleaseResource( h);
	}
	FrmAlert( WelcomeAlert);

	return;
}

Boolean DeleteConfirm()
{
	RectangleType r;
	FontID font;
	EventType	event;
	Boolean result;
	char msg1[64], msg2[64],msg3[64];

	WinPushDrawState();
	
	SysCopyStringResource( msg1, Delete1String);
	SysCopyStringResource( msg2, Delete2String);
	SysCopyStringResource( msg3, Delete3String);
	
	if ( prefs.orientation != 0)
		WinSetDrawWindow( BackWindow);

	if (  MachineFunctionality.supportHiResolution ){
		font = HRFntSetFont( hrRefNum, hrStdFont);

		RctSetRectangle( &r,30*2,60*2,100*2,40*2);
		HRWinEraseRectangle( hrRefNum, &r,0);
		HRWinDrawRectangleFrame(hrRefNum, simpleFrame,&r);
		DrawCenter(msg1, 62*2);
		DrawCenter(msg2, 75*2);
		DrawCenter(msg3, 87*2);
		if ( prefs.orientation != 0){
			TransferWindow(3);
			TransferWindow(4);
			TransferWindow(5);
			TransferWindow(6);
		}

	} else {
		font = FntSetFont( stdFont);
		if (    MachineFunctionality.supportHighDensity   ){
			if ( prefs.orientation != 0){
				WinSetForeColor(1);
				WinSetTextColor(1);
				WinSetBackColor(0);
			} else {
				WinSetForeColor(UIColorGetTableEntryIndex(UIFieldText));
				WinSetTextColor(UIColorGetTableEntryIndex(UIFieldText));
				WinSetBackColor(UIColorGetTableEntryIndex(UIFormFill));
			}			
		}

		RctSetRectangle( &r,30,60,100,40);
		WinEraseRectangle(&r,0);
		WinDrawRectangleFrame( simpleFrame,&r);
		DrawCenter(msg1, 62);
		DrawCenter(msg2, 75);
		DrawCenter(msg3, 87);
		if ( prefs.orientation != 0){
			TransferWindow(3);
			TransferWindow(4);
			TransferWindow(5);
			TransferWindow(6);
		}

	}


	result = false;
	do	{
		EvtGetEvent(&event, evtWaitForever);
	
		if (   IsHardKeyReserved(&event) || SysHandleEvent(&event) )
			continue;
		
		if ( event.eType == appStopEvent){
			EvtAddEventToQueue( &event);
			break;
		}
		if ( event.eType == keyDownEvent){
			if ( (event.data.keyDown.chr == vchrPageUp) || event.data.keyDown.chr == vchrJogUp){
				result = true;
				break;
			} else if ( (event.data.keyDown.chr == vchrPageDown) || (event.data.keyDown.chr == vchrJogDown)){
				result = false;
				break;
			} 
		}
	}	while (true);

	FntSetFont( font);
	WinSetDrawWindow( WinGetDisplayWindow());

	WinPopDrawState();
	TotalDraw();
			
	return result;
}

void TotalDraw()
{
	int i,j;
	RectangleType rect;	
	CharPtr top;
	int written;
	int endline;
	char * bits;
	WindowType *dispWin;
	IndexedColorType color;

	written = 0;
/*
	{
	char buf[64];
	FntSetFont( stdFont);
	StrPrintF(buf, "sc(%d,%d) campus(%d,%d) line %d   ",screenWidth, screenHeight, campusWidth, campusHeight, PageLine);
	WinDrawChars(buf,StrLen(buf),0,120);
	SysTaskDelay(100);
	}
*/		
	WinPushDrawState();

	WinSetForeColor(  UIColorGetTableEntryIndex(UIFieldText));
	WinSetTextColor(  UIColorGetTableEntryIndex(UIFieldText));
	WinSetBackColor(  UIColorGetTableEntryIndex(UIFormFill));
	
	if ( ( prefs.orientation != 0 ) && (! MachineFunctionality.supportHandEraHiRes) ){
		if ( !MachineFunctionality.supportColorDrawing ){
//			bits = BackWindow->displayAddrV20;
		} else {
			bits = BmpGetBits( BackBitmap);
		}
// Draw to virtual Campus
		dispWin = WinSetDrawWindow( BackWindow);

		if ( MachineFunctionality.supportHighDensity){
			WinSetTextColor( 1 );
			WinSetBackColor( 0);
			WinSetForeColor(1 );
		}
//	} else {
//		WinSetForeColor(UIColorGetTableEntryIndex(UIFieldText));
//		WinSetTextColor(UIColorGetTableEntryIndex(UIFieldText));
//		WinSetBackColor(UIColorGetTableEntryIndex(UIFormFill));
	}

	
	

	if ( MachineFunctionality.supportHiResolution ){
		RctSetRectangle( &rect, 0,0,campusWidth * gScale ,campusHeight* gScale );
		HRWinEraseRectangle( hrRefNum, &rect, 0);	
	} else {
		RctSetRectangle( &rect, 0,0,campusWidth,campusHeight);
		WinEraseRectangle( &rect, 0);	
	}

	DrawPosition();

	endline = 0;
	j = 0;
	lineInfoPtr = MemHandleLock( (MemHandle)lineInfoHandle);
	top= MemHandleLock( dataHandle);

	for ( i = 0 ; i < PageLine;i++){
		if ( i+topOfPage > PageLines){
			if ( !endline ){
				endline = 1; // already written end of line;
				if ( MachineFunctionality.supportHiResolution)
					HRWinDrawLine( hrRefNum, 10 * 2 , ( j+5) * 2,campusWidth *2 - 20, (j+5)*2);
				else
					WinDrawLine( 10,j+5,campusWidth - 10,j+5);
// Is this last record? If so draw another line to make it Double line
				if ( CurrentRecord+1 == TotalRecords )
					if ( MachineFunctionality.supportHiResolution)
						HRWinDrawLine(  hrRefNum,  10 * 2,( j+7)*2 ,campusWidth*2 - 20 ,(j+7)*2);
					else
						WinDrawLine( 10,j+7, campusWidth - 10,j+7);				
			}
		} else { // There's line
			if ( MachineFunctionality.supportHiResolution){
				FntSetFont( DisplayFont);
				HRWinDrawChars( hrRefNum, top+(lineInfoPtr+topOfPage+i)->start , (lineInfoPtr+topOfPage+i)->chars , 0 ,j*2 );
			} else if (  (  MachineFunctionality.supportHighDensity  && ( MachineFunctionality.nativeDensity == kDensityDouble )   ) ){
				HDDrawChars( top+(lineInfoPtr+topOfPage+i)->start , (lineInfoPtr+topOfPage+i)->chars , 0 ,j , DisplayFont  );
			} else {
				FntSetFont( DisplayFont);
				WinDrawChars( top+(lineInfoPtr+topOfPage+i)->start , (lineInfoPtr+topOfPage+i)->chars , 0,j );
			}
		}

// If campus is filled enough to transfer, Let's copy it to Display	by ( campusWidth, 16)	
//		while ( ((j+10)/16 > written) && ( prefs.orientation != 0) && (! MachineFunctionality.supportHandEraHiRes) ){
//			TransferWindow( written++);
//		}
		
		j+= LineSpace;
	}

	WinPopDrawState();
	WinPushDrawState();

	if ( (prefs.orientation != 0) && (! MachineFunctionality.supportHandEraHiRes)){
// Transfer the rest if any
		while ( written < campusHeight / 16)
			TransferWindow( written++); 

// Rever the draw Window
		WinSetDrawWindow( dispWin);
	}

/*	{
		RectangleType rect;
		RctSetRectangle( &rect,0,0,160,160);
		WinCopyRectangle( BackWindow, dispWin , &rect,0,0,winPaint);
	}
*/
	MemHandleUnlock( dataHandle);
	MemHandleUnlock( lineInfoHandle);
	
	WinPopDrawState();

	if ( 0 ){
		UInt32 free, max;
		char buf[32];
		MemHeapFreeBytes (0, &free, &max) ;
		StrPrintF(buf,"F:%dKBytes", (Int16)(free / 1024));
		WinDrawChars( buf, StrLen(buf),0,0);
	}
}

void TransferWindow(int row)
{
	RectangleType r;
	int i, j, b;
	UInt16 *s;
	UInt16 m,pat,p;
	UInt16 mask[]={0x8000,0x4000,0x2000,0x1000,0x0800,0x0400,0x0200,0x0100,
					 0x0080,0x0040,0x0020,0x0010,0x0008,0x0004,0x0002,0x0001};
//	BitmapType *bitmap;
	UInt16 *bits,*src_bits;
	WindowType *dispWin ,*save;
	Int blocks ,blocks_y;
	Int wordsPerLine ;
	UInt16 src[16];

	WinPushDrawState();

	
	dispWin = WinGetDisplayWindow();
	save = WinGetDrawWindow();

	WinSetDrawWindow( dispWin);

	WinSetForeColor(UIColorGetTableEntryIndex(UIFieldText));
	WinSetTextColor(UIColorGetTableEntryIndex(UIFieldText));
	WinSetBackColor(UIColorGetTableEntryIndex(UIFormFill));

	WinSetDrawWindow( save);

	WinSetDrawMode( winPaint);

// Transfer blocks( each block is 16x16)
	blocks = campusWidth * gScale / 16;
	blocks_y = campusHeight * gScale / 16;

//	if ( !MachineFunctionality.supportColorDrawing ){
/*
//		win = WinCreateOffscreenWindow( 16,16,genericFormat, &err );
//		win->bitmapP->pixelSize =1 ;
//		win->bitmapP->width = 16;
//		win->bitmapP->rowBytes = 2;
//		win->bitmapP->height = 16;
		bits = WorkWindow->displayAddrV20;
		src_bits = BackWindow->displayAddrV20;
		wordsPerLine = screenWidth / 16;
*/
//	} else { // OS3.5
	{
		Coord dummy1,dummy2;
//		bitmap = BmpCreate(16,16,1,0,&err);
//		win= WinCreateBitmapWindow( bitmap,&err);
		bits = BmpGetBits( WorkBitmap);
		src_bits = BmpGetBits( BackBitmap );
		BmpGlueGetDimensions ( BackBitmap,   &dummy1,&dummy2,(UInt16 *)&wordsPerLine);
              wordsPerLine = wordsPerLine / 2; //Bytes to Word
;	}

//	if( (  MachineFunctionality.supportHighDensity  && ( MachineFunctionality.nativeDensity == kDensityDouble )   )){
	if(   MachineFunctionality.supportHighDensity  ){
		WinSetCoordinateSystem( kCoordinatesNative);
	}
	
	RctSetRectangle( &r, 0, 0, 16, 16);	

	for ( i = 0; i < gScale; i++){	
	
		for ( j = 0 ; j < blocks ; j++){
			s = src_bits + ( row *gScale + i )* wordsPerLine*16+ j;
			if ( prefs.orientation == 1){
				int l;
				
				for ( l = 0 ; l < 16; l++){
					src[l] =*s;
					s += wordsPerLine;
				} 

				for ( b= 0 ; b < 16; b++){
					m = mask[b];
					pat = 0;

					if  ( src[0] & m )
						pat += 0x1;
					if ( src[1] & m)
						pat += 0x2;
					if ( src[2] & m)
						pat += 0x4;
					if ( src[3] & m)
						pat += 0x8;
					if ( src[4] & m)
						pat += 0x10;
					if ( src[5] & m)
						pat += 0x20;
					if ( src[6] & m)
						pat += 0x40;
					if ( src[7] & m)
						pat += 0x80;
					if ( src[8] & m)
						pat += 0x100;
					if ( src[9] & m)
						pat += 0x200;
					if ( src[10] & m)
						pat += 0x400;
					if ( src[11] & m)
						pat += 0x800;
					if ( src[12] & m)
						pat += 0x1000;
					if ( src[13] & m)
						pat += 0x2000;
					if ( src[14] & m)
						pat += 0x4000;
					if ( src[15] & m)
						pat += 0x8000;

					*(bits+b) = pat;
				}

				if ( MachineFunctionality.supportHiResolution)
					HRWinCopyRectangle ( hrRefNum, WorkWindow, dispWin, &r, ( blocks_y - 1- ( row *gScale + i ) )*16, j*16,winPaint);
				else	
					WinCopyRectangle (WorkWindow, dispWin, &r, ( blocks_y - 1 - ( row *gScale + i ) )*16, j*16, winPaint);
			} else if ( prefs.orientation == 2){
				for ( b= 0 ; b < 16; b++){
					p = *(s+b*wordsPerLine);
					pat = 0;
					if (p & 0x8000 )
						pat += 1; 
					if (p & 0x4000 )
						pat += 2; 
					if (p & 0x2000 )
						pat += 4; 
					if (p & 0x1000 )
						pat += 8; 
					if (p & 0x800 )
						pat += 0x10; 
					if (p & 0x400 )
						pat += 0x20; 
					if (p & 0x200 )
						pat += 0x40; 
					if (p & 0x100 )
						pat += 0x80; 
					if (p & 0x80 )
						pat += 0x100; 
					if (p & 0x40 )
						pat += 0x200; 
					if (p & 0x20 )
						pat += 0x400; 
					if (p & 0x10 )
						pat += 0x800; 
					if (p & 0x8 )
						pat += 0x1000; 
					if (p & 0x4)
						pat += 0x2000; 
					if (p & 0x2 )
						pat += 0x4000; 
					if (p & 0x1 )
						pat += 0x8000; 
					*( bits+(15-b)) = pat;
				}

				if ( MachineFunctionality.supportHiResolution)
					HRWinCopyRectangle (hrRefNum, WorkWindow, dispWin, &r, ( blocks - 1 -j)*16, ( blocks_y - 1- ( row *gScale + i ) )*16,winPaint);
				else
					WinCopyRectangle (WorkWindow, dispWin, &r, ( blocks - 1-j)*16, ( blocks_y - 1- ( row *gScale + i ) )*16,winPaint);
			} else if ( prefs.orientation == 3){
				int l;
				
				for ( l = 0 ; l < 16; l++){
					src[l] =*s;
					s += wordsPerLine;
				} 

				for ( b= 0 ; b < 16; b++){

					m = mask[15-b];
					pat = 0;

					if  (src[0] & m )
						pat += 0x8000;
					if  ( src[1] & m )
						pat += 0x4000;
					if  ( src[2] & m )
						pat += 0x2000;
					if  ( src[3] & m )
						pat += 0x1000;
					if  ( src[4] & m )
						pat += 0x800;
					if  ( src[5] & m )
						pat += 0x400;
					if  ( src[6] & m )
						pat += 0x200;
					if  ( src[7] & m )
						pat += 0x100;
					if  ( src[8] & m )
						pat += 0x80;
					if  ( src[9] & m )
						pat += 0x40;
					if  ( src[10] & m )
						pat += 0x20;
					if  ( src[11] & m )
						pat += 0x10;
					if  ( src[12] & m )
						pat += 0x8;
					if  ( src[13] & m )
						pat += 0x4;
					if  ( src[14] & m )
						pat += 0x2;
					if  ( src[15] & m )
						pat += 0x1;
					*(bits+b) = pat;
				}

				if ( MachineFunctionality.supportHiResolution)
					HRWinCopyRectangle (hrRefNum, WorkWindow, dispWin, &r, ( row *gScale + i ) *16, ( blocks - 1-j)*16,winPaint);
				else
					WinCopyRectangle (WorkWindow, dispWin, &r, ( row *gScale + i ) *16, ( blocks - 1-j)*16,winPaint);
			}

		}
	}	

//	WinSetDrawWindow(save);
	if(   MachineFunctionality.supportHighDensity  ){
		WinSetCoordinateSystem( kCoordinatesStandard );
	}

	WinPopDrawState();
}

int DrawPosition()
{
	int percent;
	RectangleType r;
	char buf[32];
	
	percent = 100 * (CurrentRecord-1) / ( TotalRecords-1);
	if ( PageLines <= PageLine)
		percent += 100/(TotalRecords-1);
	else
		percent += 100/(TotalRecords-1)*topOfPage/ (PageLines-PageLine);

	if ( percent > 100)
		percent = 100;
//	StrPrintF(buf,"%3d \%",percent);
//	WinDrawChars( buf, StrLen(buf), 120,150);

	if ( MachineFunctionality.supportHiResolution){
		RctSetRectangle(&r,1*2,campusHeight*2 - 8,100*2,3*2);
		HRWinDrawRectangleFrame( hrRefNum, simpleFrame, &r);
		RctSetRectangle(&r,1*2, campusHeight*2 - 8, percent*2,3*2);
		HRWinPaintRectangle( hrRefNum, &r,0);
	} else{
		RctSetRectangle(&r,1,campusHeight - 4 ,100,3);
		WinDrawRectangleFrame( simpleFrame, &r);
	
		RctSetRectangle(&r,1,campusHeight - 4,percent,3);
		if (IsColorOS)
			WinPaintRectangle( &r,0);
		else		
			WinDrawRectangle( &r,0);
	}

	
	return percent;
}


unsigned int
Decompress(unsigned char * in_buf,unsigned char * out_buf, int len)
{
  // we "know" that all decompresses fit within 4096, right?


  int i,j;
  for (j=i=0; j<len; )
  {
    int c;

    // take a char from the input buffer
    c = in_buf[j++];
    // separate the char into zones: 0, 1...8, 9...0x7F, 0x80...0xBF, 0xC0...0xFF

    // codes 1...8 mean copy that many bytes; for accented chars & binary
    if (c>0 && c<9){
      while(c--) out_buf[i++] = in_buf[j++];
	}
    // codes 0, 9...0x7F represent themselves
    else if (c<0x80)
      out_buf[i++] = c;

    // codes 0xC0...0xFF represent "space   ascii char"
    else if (c>=0xC0){
        out_buf[i++] = ' ';
        out_buf[i++] = c & 0x7f;
	}
	
#define COUNT_BITS 3

    // codes 0x80...0xBf represent sequences
    else
    {
      int m,n;
      c <<= 8;
      c  |= in_buf[j++];
      m = (c & 0x3FFF) >> COUNT_BITS;
      n = c & ((1<<COUNT_BITS) - 1);
      n += 3;
      while (n--)
      {
        out_buf[i] = out_buf[i-m];
        i++;
      }
    }
  }

  return i;
}

#define PAGESIZE 4096

int ExtractPage( Handle from, CharPtr to , int size)
{
	CharPtr f,t,c,t2;
//	Handle h;
//	CharPtr dummy;
	int len;
//	RectangleType r;
	
	c = f = MemHandleLock(from);
	t2 = t = to;
	
	if ( CompressionMode == 1 ){		
		len = Decompress((unsigned char *) f,(unsigned char *)t, size);

		c = f = t;
		size = len;
	}

// Copy the original to the buffer with End of Line conversion. (CR,CR/LF->LF)
	while	( c< f + size){
		if ( *c == '\015'){ // cr
			if ( *(c+1) != '\012' ) // if next if lf then skip cr, if next is not, then add lf
				*(t++) = '\012';
			c++;
		} else {
			*(t++) = *(c++);
		}
	}

	*(t++) = 0; // put the end of string
	MemHandleUnlock( from);
	return (t - t2); // return Total Bytes after Decompress and EOL conversion
}

void 	GetAndSaveTailer(unsigned char* p){
	unsigned char* pos,*end;

// Get End of current buffer
	pos = end = p +StrLen((char *)p);
	
// Search for the last NewLine
	while ( (*pos != '\012' ) && ( pos >p) && ( pos+1024>end)){
		pos--;
	}
	if (  pos+1024 == end) { // If can't find newline. Search for the Kanji break;
		while ( IsSJIS1( (*pos) )  &&  IsSJIS2( *(pos+1) ) && ( pos < end) ){
			pos++;
		}
	}
	
	
// If already allocated, Free it
	if ( TailBuffer){
		MemPtrFree( TailBuffer);
		TailBuffer = 0;
	}
		
// Allocate one and Copy the trailer
	TailBuffer = MemPtrNew( (end-pos)+3);
	StrCopy( TailBuffer, (char *)pos+1);
	TailBufferRecordNum = CurrentRecord;
// Remove the trailer
	*(pos+1) = '\0';

	return;
}

void AvoidPageLimit() // Check if user is approaching page break. If so read another page
{

}

MemHandle MSReadRecord( FileRef file, int rec)
{
	MemHandle h  = MemHandleNew( 4100);
	UInt8 *p = MemHandleLock( h);
	UInt32 readBytes;
	
	MemSet( p,4100,0);
	VFSFileSeek( file, fsOriginBeginning,(UInt32)( rec - 1 ) * 0x1000);
	VFSFileRead( file,  0x1000 , p, &readBytes);
	return h;
}

void
ReadOneRecord()
{
	FormPtr frm;
	CharPtr p,top;
	int i;
	short textLen, textWidth;
	CharPtr chp,current;
	ULong	EndOfPage;
	Handle h,h2;
	RectangleType r;
	int scale;

	RctSetRectangle( &r, 0,0,10,10);
	WinDrawRectangle( &r, 0);

	if ( dataHandle != nil ){
		MemHandleFree( dataHandle);
		dataHandle = nil;
	}

	dataHandle = MemHandleNew( PAGESIZE+2000);
	p = MemHandleLock( dataHandle);
	StrCopy( p, "");


	if ( CurrentRecord !=1){
		if ( TailBufferRecordNum == CurrentRecord - 1){ // if we need tailer of last record and find it
			StrCopy( p, TailBuffer);
		}	else {  // get the previous record and get tailer
			if ( prefs.storage_mode == STORAGE_INTERNAL){
				h2 = DmQueryRecord( CurrentDB, CurrentRecord - 1);
			} else {
				h2 = MSReadRecord( CurrentTextFile, CurrentRecord - 1);
			}
			ExtractPage( h2, p, MemHandleSize(h2));
			
			if ( prefs.storage_mode == STORAGE_INTERNAL){
//				DmReleaseRecord( CurrentDB, CurrentRecord - 1, false);
			} else {
				MemHandleFree( h2);
			}
			
			GetAndSaveTailer( (unsigned char *)p);
			TailBufferRecordNum = CurrentRecord - 1;
			StrCopy( p, TailBuffer);
		}
	}

	if ( prefs.storage_mode == STORAGE_INTERNAL){
		h = DmQueryRecord( CurrentDB, CurrentRecord);
	} else {
		h = MSReadRecord( CurrentTextFile, CurrentRecord );
	}
	
	{
		char *pp = p+ StrLen(p);
		int size = MemHandleSize(h);
		ExtractPage( h, pp, size);
	}

	if ( prefs.storage_mode == STORAGE_INTERNAL){
//		DmReleaseRecord( CurrentDB, CurrentRecord, false);
	} else {
		MemHandleFree( h);
	}
	
	if ( CurrentRecord != TotalRecords - 1) // if not last record
		GetAndSaveTailer(  (unsigned char *)p);
	
	MemHandleUnlock( dataHandle);

	frm = FrmGetActiveForm ();
	
	top = p = MemHandleLock( dataHandle ) ;
	EndOfPage = StrLen( top ); 
	chp = p+ EndOfPage;

	if ( lineInfoHandle != nil ){
		MemHandleFree( (MemHandle)lineInfoHandle);
		lineInfoHandle = nil;
	}

	lineInfoHandle = MemHandleNew(150*sizeof( struct lineinfo));
	lineInfoPtr = MemHandleLock( (MemHandle)lineInfoHandle);

	scale = 1;
	
	if (   (  MachineFunctionality.supportHighDensity  && ( MachineFunctionality.nativeDensity == kDensityDouble )   ) || (  MachineFunctionality.supportHiResolution ) ){
		if ( DisplayFont == hrTinyFont){
			scale = 2;
			FntSetFont( stdFont);
		} else if ( DisplayFont == hrSmallFont){
			scale = 2;
			FntSetFont( largeFont);
		} else if ( DisplayFont == hrStdFont){
			scale = 1;
			FntSetFont( stdFont);
		} else if ( DisplayFont == hrLargeFont){
			scale = 1;
			FntSetFont( largeFont);
		}
	}		
//	screenWidth = ( MachineFunctionality.supportHiResolution)?320:160;

	current = top;

	textWidth = campusWidth;

	for ( i = 0 ;; i++){

		textLen = FldWordWrap( current, textWidth*scale );
		if ( textLen == 0)
			textLen =1;
		if ( MemHandleSize( lineInfoHandle ) < (i+2) * sizeof( struct lineinfo) ){
			MemHandleUnlock( lineInfoHandle);
			MemHandleResize( lineInfoHandle ,MemHandleSize( lineInfoHandle)+ 50*sizeof(struct lineinfo));
			lineInfoPtr = MemHandleLock( lineInfoHandle);
		} 
		
		if (current + textLen > top + EndOfPage)
			textLen = ( top + EndOfPage - current );
		(lineInfoPtr + i)->start = current-top;
		(lineInfoPtr + i)->chars = textLen;
		if ( (textLen) && ( *(current+ textLen-1) == '\012') )
			((lineInfoPtr + i)->chars)--;

		current += textLen;
		if ( current >= top + EndOfPage  )
			break;
	}
	
	PageLines = i;
	MemHandleUnlock( dataHandle );
	MemHandleUnlock( lineInfoHandle);

//	AdjustCampusSize();
}

void EditCopyScreenToClipboard(void)
{
	int i;
	CharPtr top;
	int tail,head;
		
	lineInfoPtr = MemHandleLock( lineInfoHandle);
	top= MemHandleLock( dataHandle);

	head = (lineInfoPtr+topOfPage)->start;
	tail = (lineInfoPtr+topOfPage)->start+(lineInfoPtr+topOfPage)->chars;

	for ( i = 0 ; i < PageLine;i++){
		if ( (i+topOfPage) > PageLines)
			break;
		tail= (lineInfoPtr+topOfPage+i)->start + (lineInfoPtr+topOfPage+i)->chars;
	}
	
	ClipboardAddItem (clipboardText,top+head,tail-head);
	
	MemHandleUnlock( dataHandle);
	MemHandleUnlock( lineInfoHandle);

	FrmAlert( CopyScreenDoneAlert);

	return;
}

void
GotoBottom()
{
		CurrentRecord = TotalRecords - 1;
		ReadOneRecord();
		topOfPage = PageLines- PageLine+1;
		if ( topOfPage < 0)
			topOfPage = 0;
		TotalDraw();
}


char * GetNewMSFileName( 	char *oldpath, char *  newpath, Boolean *need_extension)
{
	FormType *form, *oldform;
	int ans ;
	char *result=0;
	
	oldform = FrmGetActiveForm();
	form = FrmInitForm( FileNameMSForm);
	FrmSetActiveForm( form);
	SetTextOnField( GetObjectPtr( FileNameMSFileNameField) , oldpath);
	FldSetSelection( GetObjectPtr( FileNameMSFileNameField) , 0, StrLen( oldpath));
	CtlSetValue( GetObjectPtr( FileNameMSExtensionCheckbox ), (*need_extension)?1:0 );
	
	FrmDrawForm( form);

 	ans = FrmDoDialog( form);
	if ( ans ==  FileNameMSOkButton ){// ok
		StrCopy( newpath, FldGetTextPtr(GetObjectPtr( FileNameMSFileNameField)));
		*need_extension = CtlGetValue( GetObjectPtr( FileNameMSExtensionCheckbox));
	 	result = newpath;
	 } else {
	 	result = 0;
	 }
	 
	 FrmEraseForm(form);
	 FrmDeleteForm(form);
	 FrmSetActiveForm( oldform);
	 return result;
}

char * GetNewDatabaseName( 	char *oldpath, char *  newpath)
{
	FormType *form, *oldform;
	int ans ;
	char *result=0;
	
	oldform = FrmGetActiveForm();
	form = FrmInitForm( FileNameDBForm);
	FrmSetActiveForm( form);
	SetTextOnField( GetObjectPtr( FileNameDBFileNameField) , oldpath);
	FldSetSelection( GetObjectPtr( FileNameDBFileNameField) , 0, StrLen( oldpath));
	
	FrmDrawForm( form);

 	ans = FrmDoDialog( form);
	if ( ans ==  FileNameDBOkButton ){// ok
		StrCopy( newpath, FldGetTextPtr(GetObjectPtr( FileNameDBFileNameField)));
	 	result = newpath;
	 } else {
	 	result = 0;
	 }
	 
	 FrmEraseForm(form);
	 FrmDeleteForm(form);
	 FrmSetActiveForm( oldform);
	 return result;
}


static void CopyDocument()
{
	char *buf=0;
	char old_name[256],new_name[256];
	FormType *form;
	
	if ( prefs.storage_mode == STORAGE_INTERNAL){ // Copy to MS
		char path[256];
		Err err;
		FileRef file;
		int i;
		Boolean need_extension=true;
		
		if (!CheckForStorage() ){
			FrmAlert(NoMSAlert);
			goto ERROR;
		}

		if ( !MediaWritable){
			FrmAlert(WriteProtectedAlert);
			goto ERROR;
		}

//		StrCat( old_name, DocumentName);
		DatabaseNameToFileName( (UInt8 *)old_name, (UInt8 *)DocumentName);
//		RemoveExtension( old_name);
		
		while ( true){	
			if ( GetNewMSFileName( old_name, new_name, &need_extension)== 0) { // canceld
				goto ERROR;
			}

			StrCopy( path, card_path);
			StrCat( path, new_name);
			if ( need_extension)
				StrCat( path, ".txt");
//			FrmCustomAlert(DebugAlert,"Now to create ", path, "");

			err = VFSFileCreate( volumeRefNum, path);
			if ( err == errNone){ // Success
//				FrmCustomAlert(DebugAlert,"Create ", path, " success.");
				break;
			} else if ( err == vfsErrFileAlreadyExists){
				int ans;
				ans = FrmCustomAlert( OverwriteMSFileAlert , path , "","");
				if ( ans == 0){ // Cancel
					goto ERROR;
				} else if ( ans == 1){ // Overwrite
					break;
				} else if ( ans == 2){ // New Name
					StrCopy( old_name, new_name);	
					continue;				
				}		
			} else if ( err == vfsErrVolumeFull) {
				FrmAlert( MemoryFullAlert);	
				goto ERROR;		
			} else{
				char buf[32];
				StrIToA( buf, err- vfsErrorClass);
				FrmCustomAlert(DebugAlert,"Can't create new file Error no.", buf,"");
				goto ERROR;
			}
		}
		
		err = VFSFileOpen( volumeRefNum, path, vfsModeWrite, &file);
		if ( err != errNone){
			FrmCustomAlert(DebugAlert,"Can't open file for write ",new_name,"");
			goto ERROR;
		}

		buf = MemPtrNew(6000);

		form = ShowWaitWindow();
		
		for ( i = 1; i < TotalRecords; i ++){		
			UInt32 numBytes, leftBytes;
			MemHandle h2;
			
			h2 = DmQueryRecord( CurrentDB, i);
			ExtractPage( h2, buf, MemHandleSize(h2));
			leftBytes = StrLen( buf);

			while ( leftBytes){
				err = VFSFileWrite(file, leftBytes ,buf, &numBytes);
				leftBytes -= numBytes;
				if ( err){
					if ( err == vfsErrVolumeFull){
						FrmAlert( MemoryFullAlert);	
					} else {
						char buf[32];
						StrIToA(buf, err - vfsErrorClass);
						FrmCustomAlert( DebugAlert,"Write to file error. No. ",buf," ");
					}
					VFSFileClose(  file);
					VFSFileDelete( volumeRefNum,  path);
					
					EraseWaitWindow( form);
					goto ERROR;
				}
			}
		}

		EraseWaitWindow( form);

		VFSFileClose( file);
		FrmCustomAlert(CopyDoneAlert, new_name  ," "," ");

	} else { // Copy to Internal
		char dbName[33];

		Record0Type rec0;
		MemHandle h;
		MemPtr p;
		DmOpenRef db;
		UInt16 at;
		int i;
		UInt32 leftBytes, left, readBytes;
		UInt32 offset;
		Err err;
		
		FileNameToDatabaseName	( old_name, DocumentName); // Remove extension and shrink to 32 byte

//		FrmCustomAlert( DebugAlert, old_name, "","");

		while ( true){	
			if ( GetNewDatabaseName( old_name, new_name)== 0) { // canceld
				goto ERROR;
			}

//			FrmCustomAlert(DebugAlert,"Now to create ", new_name, "");

			err =  DmCreateDatabase( 0, new_name , 'REAd','TEXt', false);

			if ( err == errNone){ // Success
//				FrmCustomAlert(DebugAlert,"Create ", new_name, " success.");
				break;
			} else if ( err == dmErrAlreadyExists ){
				int ans;
				ans = FrmCustomAlert( OverwriteMSFileAlert , new_name , "","");
				if ( ans == 0){ // Cancel
					goto ERROR;
				} else if ( ans == 1){ // Overwrite
					break;
				} else if ( ans == 2){ // New Name
					StrCopy( old_name, new_name);	
					continue;				
				}		
			} else if ( err == memErrNotEnoughSpace  ) {
				FrmAlert( MemoryFullAlert);	
				goto ERROR;		
			} else{
				char buf[32];
				FrmCustomAlert(DebugAlert,"Can't create new db","","");
				goto ERROR;
			}
		}
		
		db = DmOpenDatabase( 0, DmFindDatabase( 0, new_name), dmModeReadWrite);
		if ( !db)
			goto ERROR;
		
//		FrmCustomAlert(DebugAlert, "Create",new_name," success");

		form = ShowWaitWindow();
	
		rec0.compression_type = 1; // Uncompressed
		rec0.spare = 0;
		rec0.story_length = TotalBytes;
		rec0.num_records = TotalRecords-1;
		rec0.reclen = 0x1000;
		rec0.dummy = 0;
		
		at = dmMaxRecordIndex;
		h = DmNewRecord( db, &at , sizeof( rec0));
		p = MemHandleLock (h);
		DmWrite( p,0, &rec0, sizeof (rec0));
		MemHandleUnlock(h);
		DmReleaseRecord( db, at, true);
		
		leftBytes = TotalBytes;
		VFSFileSeek( CurrentTextFile ,fsOriginBeginning, 0);
		for ( i = 1; i < TotalRecords; i++){
			at = dmMaxRecordIndex;
			left = ( leftBytes > 0x1000)? 0x1000: leftBytes ; 
			leftBytes -=left;
			h = DmNewRecord( db, &at ,left);
			p = MemHandleLock (h);
			offset = 0;
			while (left){
				VFSFileReadData( CurrentTextFile, left, p, offset,& readBytes);
				if (readBytes == 0)
					break;
				left -= readBytes;
				offset += readBytes;
			}
			
			MemHandleUnlock( h);
			DmReleaseRecord( db, at,true);
		}

		DmCloseDatabase( db);

		EraseWaitWindow( form);
		
		FrmCustomAlert(CopyDoneAlert, new_name  ," "," ");

	}

	NeedResearchDocumentList = true; // Show need document search again

ERROR:
	if ( buf)
		MemPtrFree( buf);
		
	return;
	
}	


Boolean MatchNifty( CharPtr line)
{
	int i;
	
	for ( i = 0 ; i < 5; i++)
		if (  (*(line+i) < '0') || (*(line+i) > '9'))
			return false;
			
	return ( *( line+5 ) == '/' );
}

Boolean MatchLine( CharPtr line, CharPtr pattern, int mode)// mode 0 head mode 1..any
{
	int i,j,line_len, pattern_len;

// first, calculate line length
	if( mode == 0)
		return (ByteCompare( line,pattern, StrLen( pattern)) == 0 );

	for ( line_len = 0; (*(line+line_len) != '\n') && (*(line+line_len) != '\0'); line_len++)
		;

	pattern_len = StrLen( pattern);

	for ( i = 0; i < line_len - pattern_len; i++){
		for ( j = 0 ; j < pattern_len; j++){
			if ( *(line+i+j) != *( pattern+j))
				break;
		}
		if ( j == pattern_len ){ // fully matched
			return true;
		}
	}
	
// searched for the last
	return false;
}


CharPtr SearchTopOfLineForward( CharPtr p)
{
	while (true){
		if ( *p == 0)
			return p;
		if ( *p == '\n')
			return p+1;
		p++;
	}
}

CharPtr SearchTopOfLineBackward( CharPtr p,CharPtr top)
{
	if ( p-2  <= top)
		return top;

	p-=2;

	while (true){
		if ( p == top)
			return p;
		if ( *p == '\n')
			return p+1;
		p--;
	}
}


#define TOPIC_TAG "[LINK]"
#define TOPIC_TAG2 "e"
#define TOPIC_TAG3 ""
#define TOPIC_TAG4 ""
#define TOPIC_TAG5 ""
#define TOPIC_TAG6 "Subject"

void GotoNextTopic(void)
{
	CharPtr top,line_top;
	int i;
	int pages;
//	FormPtr frm;

	lineInfoPtr = MemHandleLock( lineInfoHandle);
	top= MemHandleLock( dataHandle);

	line_top = top + (lineInfoPtr+topOfPage)->start; // left upper char's pointer

	pages = 2; // searches for 2pages.
	
	while( 1 ){
		line_top = SearchTopOfLineForward( line_top);	
//		WinDrawChars( line_top,10,0,0);
//		SysTaskDelay(50);
		
		if ( *line_top != 0){ // if it's bottom, don't search and goto next record
			if ( MatchLine( line_top, TOPIC_TAG,0) == true)	// find!
				break;
			if ( MatchLine( line_top, TOPIC_TAG2,1) == true)	// find!
				break;
			if ( MatchLine( line_top, TOPIC_TAG3,0) == true)	// find!
				break;
			if ( MatchLine( line_top, TOPIC_TAG4,0) == true)	// find!
				break;
			if ( MatchLine( line_top, TOPIC_TAG5,0) == true)	// find!
				break;
			if ( MatchLine( line_top, TOPIC_TAG6,0) == true)	// find!
				break;
			if ( MatchNifty( line_top) == true)	// find!
				break;
		} else {  // it's bottom of record

			if ( pages-- == 0){
				SndPlaySystemSound( sndError );
				topOfPage = PageLines;// the real last line 
				TotalDraw();
				return;		
			}				

			MemHandleUnlock( dataHandle);
			MemHandleUnlock( lineInfoHandle);

			if ( CurrentRecord+1 < TotalRecords ){ // Are there next record?
				CurrentRecord ++;
				ReadOneRecord();
				topOfPage= 0; // add 1 later so make it -1
				lineInfoPtr = MemHandleLock( lineInfoHandle);	
				line_top = top= MemHandleLock( dataHandle);

			} else {	// This is last record. Go to bottom.
				topOfPage = PageLines;// the real last line 
//				if ( topOfPage < 0) // if there's not enough lines to fill screen
//					topOfPage = 0;	
				TotalDraw();
				return;
			}
		}
	}

	for ( i = 0 ; i <= PageLines; i++)
		if ( (lineInfoPtr+i)->start >= line_top - top){
			topOfPage = i;
			break;
		}

	MemHandleUnlock( dataHandle);
	MemHandleUnlock( lineInfoHandle);

	TotalDraw();
}

void GotoPreviousTopic(void)
{
	CharPtr top,line_top;
	int i;
	int pages;
	
	lineInfoPtr = MemHandleLock( lineInfoHandle);
	top= MemHandleLock( dataHandle);

	line_top = top + (lineInfoPtr+topOfPage)->start; // left upper char's pointer
	
	pages = 2;
	
	while( 1 ){
		line_top = SearchTopOfLineBackward( line_top,top);	

		if ( line_top != top){ // if it's bottom, don't search and goto next record
			if ( MatchLine( line_top, TOPIC_TAG,0) == true)	// find!
				break;
			if ( MatchLine( line_top, TOPIC_TAG2,1) == true)	// find!
				break;
			if ( MatchLine( line_top, TOPIC_TAG3,0) == true)	// find!
				break;
			if ( MatchLine( line_top, TOPIC_TAG4,0) == true)	// find!
				break;
			if ( MatchLine( line_top, TOPIC_TAG5,0) == true)	// find!
				break;
			if ( MatchLine( line_top, TOPIC_TAG6,0) == true)	// find!
				break;
			if ( MatchNifty( line_top) == true)	// find!
				break;
		} else {  // it's Top of record
			if ( pages-- == 0){
				SndPlaySystemSound( sndError );
				topOfPage = 0;

				MemHandleUnlock( dataHandle);
				MemHandleUnlock( lineInfoHandle);

				TotalDraw();

				return;		
			}
			
			MemHandleUnlock( dataHandle);
			MemHandleUnlock( lineInfoHandle);

			if ( CurrentRecord != 1 ){ // Are there previous record?
				CurrentRecord --;
				ReadOneRecord();
				topOfPage = PageLines-1; // add 1 bacause it'll be decrement
				lineInfoPtr = MemHandleLock( lineInfoHandle);
				top= MemHandleLock( dataHandle);

				line_top = top + (lineInfoPtr+topOfPage+1)->start+1; // left upper char's pointer
				
			} else {	// This is first record. Go to top.
				topOfPage = 0;
				TotalDraw();
				return;
				break;
			}
		}
	}

	for ( i = 0 ; i <= PageLines; i++)
		if ( (lineInfoPtr+i)->start >= line_top - top){
			topOfPage = i;
			break;
		}

	MemHandleUnlock( dataHandle);
	MemHandleUnlock( lineInfoHandle);

	TotalDraw();
}


void LineUp(void)
{
	if ( topOfPage <= PageLines){
		topOfPage += 1;
//		if ( topOfPage > PageLines- PageLine+1)
//			topOfPage = PageLines- PageLine+1;
		TotalDraw();
		AvoidPageLimit(); // Check page break;
	} else {
		if ( CurrentRecord+1 < TotalRecords ){
			CurrentRecord ++;
			ReadOneRecord();
			topOfPage= 0;
			TotalDraw();
/*		} else if (ProceedConfirmation() == 1){
			GotoBottomFlag=0;
			DeleteDBNumber = noSelected;	
			NextOpenDocument = CurrentDBNumber+1;
			FrmGotoForm( MainForm);
*/		}

	}
}


void LineDown(void)
{
  	if ( topOfPage != 0){
		topOfPage -= 1;
		if ( topOfPage < 0)
			topOfPage = 0;
		TotalDraw();
		AvoidPageLimit(); // Check page break;

	} else {
		if ( CurrentRecord != 1){
			CurrentRecord --;
			ReadOneRecord();
			topOfPage = PageLines- PageLine+1;
			if ( topOfPage < 0)
				topOfPage = 0;
			TotalDraw();
/*		} else {
			if (ProceedConfirmation() == 1){
				GotoBottomFlag=1;
				DeleteDBNumber = noSelected;	
				NextOpenDocument = CurrentDBNumber-1;
				FrmGotoForm( MainForm);
			}
*/		}
	}
}
void ScrollUp(void)
{
	if ( topOfPage < PageLines- PageLine+1){
		topOfPage += ScrollLines;
//		if ( topOfPage > PageLines- PageLine+1)
//			topOfPage = PageLines- PageLine+1;
		TotalDraw();
		AvoidPageLimit(); // Check page break;

	} else {
		if ( CurrentRecord+1 < TotalRecords ){
			CurrentRecord ++;
			ReadOneRecord();
			topOfPage= 0;
			TotalDraw();
		} else {
			GotoBottomFlag=0;
			DeleteDBNumber = noSelected;	
			NextOpenDocument = CurrentDBNumber+1;
			FrmGotoForm( MainForm);
		}

	}
}


void ScrollDown(void)
{
  	if ( topOfPage != 0){
		topOfPage -= ScrollLines;
		if ( topOfPage < 0)
			topOfPage = 0;
		TotalDraw();
		AvoidPageLimit(); // Check page break;

	} else {
		if ( CurrentRecord != 1){
			CurrentRecord --;
			ReadOneRecord();
			topOfPage = PageLines- PageLine+1;
			if ( topOfPage < 0)
				topOfPage = 0;
			TotalDraw();
		} else {
			GotoBottomFlag=1;
			DeleteDBNumber = noSelected;	
			NextOpenDocument = CurrentDBNumber-1;
			FrmGotoForm( MainForm);
		}
	}
}

void NextDocument(void)
{
	GotoBottomFlag=0;
	DeleteDBNumber = noSelected;	
	NextOpenDocument = CurrentDBNumber+1;
	FrmGotoForm( MainForm);
}

void PreviousDocument(void)
{
	GotoBottomFlag=0;
	DeleteDBNumber = noSelected;	
	NextOpenDocument = CurrentDBNumber-1;
	FrmGotoForm( MainForm);
}

void CloseDocument(void)
{
	NextOpenDocument = -1;
	DeleteDBNumber = noSelected;
	GotoBottomFlag = 0;
	FrmGotoForm(MainForm);
}

void DeleteDocument(Boolean confirm)
{
}

void MoveDocument(Boolean forward)
{
}


int ConvertPenPosition( int o, int *x,int *y)
{
	int  tempx = *x;
	int  tempy = *y;
	
	switch ( o){
		case 0 : break;
		case 1 : *x = tempy;	*y = 159 - tempx; break;
		case 2 : *x = 159 - tempx; *y = 159 - tempy;break;
		case 3 : *x = 159 - tempy; *y = tempx; break;
	}
	return 0;
}

void
HandleKey( int key_index)
{
	switch( button_action[key_index]){
		case ACTION_PREVIOUS_LINE:
			LineDown();
			break;

		case ACTION_NEXT_LINE:
			LineUp();
			break;

		case ACTION_PREVIOUS_SCREEN:
			ScrollDown();
			break;

		case ACTION_NEXT_SCREEN:
			ScrollUp();
			break;

		case ACTION_PREVIOUS_TOPIC:
			GotoPreviousTopic();
			break;

		case ACTION_NEXT_TOPIC:	
			GotoNextTopic(); 
			break;

		case ACTION_PREVIOUS_DOCUMENT:
			PreviousDocument();
			break;

		case ACTION_NEXT_DOCUMENT:
			NextDocument();
			break;

		case ACTION_DELETE_WITHOUT_CONFIRM:
			if ( (prefs.storage_mode == STORAGE_CARD) &&  !MediaWritable ){
				FrmAlert( ProtectedCantDeleteAlert);
				break;
			}
			GotoBottomFlag=0;
			DeleteDBNumber = CurrentDBNumber;	
			NextOpenDocument = CurrentDBNumber; // open next. next will be current db number
			FrmGotoForm( MainForm);
			break;

		case ACTION_DELETE_WITH_CONFIRM:
			if ( (prefs.storage_mode == STORAGE_CARD) &&  !MediaWritable ){
				FrmAlert( ProtectedCantDeleteAlert);
				break;
			}

			if ( DeleteConfirm()== true){
				GotoBottomFlag=0;
				DeleteDBNumber = CurrentDBNumber;	
				NextOpenDocument = CurrentDBNumber; // open next. next will be current db number
				FrmGotoForm( MainForm);
			}				
			break;

		case ACTION_CLOSE_DOCUMENT:
			CloseDocument();
			break;

	}
}
/*
static Boolean DummyHandleEvent(EventPtr event)
{
	return false;
}
*/
/***********************************************************************
 *
 * FUNCTION:		

 *
 * DESCRIPTION:	P5. Retrieves the data from the first record of a database 
 *						and places it in a field.
 *
 * PARAMETERS:		fld - the field to contain the text.
 *
 * RETURNED:		Nothing.
 *
 ***********************************************************************/
static Boolean EditViewRetrieveData()
{
	Record0Type *dbtypep;
	Handle h;

	if (prefs.storage_mode == STORAGE_INTERNAL){
		CurrentDBlocalId = doc_infos[ CurrentDBNumber]->local_id;
		CurrentDBcard = doc_infos[ CurrentDBNumber]->card_no;
		DmDatabaseInfo (CurrentDBcard, CurrentDBlocalId, DocumentName , nil, nil,&CurrentCreateDate, nil, nil, nil, nil, nil, nil,nil);
	
		CurrentDB =  DmOpenDatabase ( CurrentDBcard,CurrentDBlocalId, dmModeReadOnly);	
	
	// Get info about this DOC
		h = DmQueryRecord( CurrentDB, 0);
		dbtypep = (struct trecord0 *)MemHandleLock( h);
	
		CompressionMode = ( dbtypep->compression_type & 0xff ) - 1;
		TotalBytes = dbtypep->story_length;
		TotalRecords = dbtypep->num_records+1;
		MemHandleUnlock( h );
		
//		DmReleaseRecord( CurrentDB, 0,false);
	} else { // Text on MS
		char path[256];
		Err err;

		StrCopy( DocumentName, (MSFileListP+ CurrentDBNumber)->file_name);
		StrCopy( prefs.file_name , (MSFileListP+ CurrentDBNumber)->file_name);
		StrCopy( path, card_path);
		StrCat( path, prefs.file_name);
	
		err = VFSFileOpen( volumeRefNum, path, vfsModeRead, &CurrentTextFile );
		err = VFSFileSize(CurrentTextFile, &TotalBytes);
		TotalRecords = (TotalBytes + 0xfff) / 0x1000 +1;

		if ( TotalRecords == 1){
			return false;
		}
	
		CompressionMode = 0;
	}
	
// Invalidate Tail Buffer 	
	TailBufferRecordNum = -99;

	if ( GotoBottomFlag){
// Go to last record.
		CurrentRecord = TotalRecords - 1;
		ReadOneRecord();
// Go to last line
		topOfPage = PageLines- PageLine+1;
	   	if ( topOfPage < 0 ){
	   		topOfPage = 0;
	   	}
	} else { 
		ReadOneRecord();
	}
	
	return true;
}

static void EditViewDoMenuCommand(Int command)
{
	FormPtr	frm,alert;
	int buttonHit;
	int i,j;
	FontID new_font;
	// Do the appropriate action for the menu command selected.
	switch (command)
		{
		case ViewOptionsAboutJDOCReader:		// Display the info form.
			// Load the info form, then display it.
			frm = FrmInitForm(InfoForm);
			if ( MachineFunctionality.supportHandEraHiRes){
				VgaFormModify( frm, vgaFormModify160To240 );
			}
			FrmDoDialog(frm);
			
			// Delete the info form.
	 		FrmDeleteForm(frm);
			break;
		
		case ViewBrowseGotoTop:		// Go to the top of the field.	
			CurrentRecord = 1;
			ReadOneRecord();
			topOfPage = 0;
			TotalDraw();
			break;
		
		case ViewBrowseGotoBottom:	// Go to the bottom of the field.
			GotoBottom();
			break;

		case ViewBrowseNextTopic:
			GotoNextTopic();
			break;
			
		case ViewBrowsePreviousTopic:
			GotoPreviousTopic();
			break;

		case ViewBrowseChooseFont:
			lineInfoPtr = MemHandleLock( lineInfoHandle);
			i = (lineInfoPtr+topOfPage)->start;  // Get Current Top of page index
			MemHandleUnlock( lineInfoHandle);

/*			if ( MachineFunctionality.supportHiResolution ){
				if ( 	DisplayFont == hrTinyFont)
					new_font = hrStdFont;
				else	if ( DisplayFont == hrSmallFont)
					new_font = hrBoldFont;
				else	if ( DisplayFont == hrStdFont)
					new_font = hrLargeFont;
				else	if ( DisplayFont == hrLargeFont)
					new_font = hrLargeBoldFont;

				new_font = HRFontSelect(hrRefNum, new_font);
						
				if ( new_font == hrStdFont)
					DisplayFont = hrTinyFont;
				else	if ( new_font == hrBoldFont)
					DisplayFont = hrSmallFont;
				else	if ( new_font == hrLargeFont)
					DisplayFont = hrStdFont;
				else	if ( new_font == hrLargeBoldFont)
					DisplayFont = hrLargeFont;
			} else  */
			 if (MachineFunctionality.supportHandEraHiRes ){
				DisplayFont = VgaFontSelect(vgaFontSelectVgaText , DisplayFont);
			}else if (   MachineFunctionality.supportHighDensity  && ( MachineFunctionality.nativeDensity == kDensityDouble )    ){
				DisplayFont  = HDFontChoose( DisplayFont);
			}else if (   MachineFunctionality.supportHiResolution ){
				if ( 	DisplayFont == hrTinyFont)
					new_font = stdFont;
				else	if ( DisplayFont == hrSmallFont)
					new_font = boldFont;
				else	if ( DisplayFont == hrStdFont)
					new_font = largeFont;
				else	if ( DisplayFont == hrLargeFont)
					new_font = largeBoldFont;

				new_font = FontSelect(new_font);
						
				if ( new_font == stdFont)
					DisplayFont = hrTinyFont;
				else	if ( new_font == boldFont)
					DisplayFont = hrSmallFont;
				else	if ( new_font == largeFont)
					DisplayFont = hrStdFont;
				else	if ( new_font == largeBoldFont)
					DisplayFont = hrLargeFont;
			} else{
				DisplayFont = FontSelect(DisplayFont);
			}

// Change line/page or so ...
			AdjustCampusSize();

// Re-arrange line info. It's slow because it de-compress again. But I don't care...
			ReadOneRecord();

			lineInfoPtr = MemHandleLock( lineInfoHandle);
			for ( j = 0; j < PageLines; j++)
				if (  (lineInfoPtr+j)->start +  (lineInfoPtr+j)->chars >= i ){
					topOfPage = j;
					break;
				}
			MemHandleUnlock(lineInfoHandle);

			AvoidPageLimit(); // Check page break;
			
			if ( j == PageLines )
				topOfPage = PageLines-1;
			
//			if ( topOfPage > PageLines- PageLine+1) // when last of page
//				topOfPage = PageLines- PageLine+1;

			TotalDraw();
			break;

		case ViewDocumentCloseDocument:
			CloseDocument();
			break;

		case ViewDocumentPreviousDocument:
			PreviousDocument();
			break;

		case ViewDocumentNextDocument:
			NextDocument();
			break;

		case ViewDocumentCopyDocument:
			if ( MachineFunctionality.supportExternalMedia )
				CopyDocument();
			else 
				FrmAlert( NoMediaSupportedAlert);
			break;

		case ViewOptionsOperations:
			FrmPopupForm(OptionForm);
			break;

		case ViewOptionsScreenRotate:
//			FrmAlert( RotateOnlyAlert);
			FrmPopupForm(ScreenForm);
			break;

		case ViewBrowseCopyScreen:
			EditCopyScreenToClipboard();
			break;
			
		case ViewDocumentDeleteDocument:
			if ( (prefs.storage_mode == STORAGE_CARD) && !MediaWritable ){
				FrmAlert( ProtectedCantDeleteAlert);
				break;
			}

			alert = FrmInitForm (DeleteForm);
			if ( MachineFunctionality.supportHandEraHiRes){
				VgaFormModify( alert, vgaFormModify160To240 );
			}
			buttonHit = FrmDoDialog (alert);
			FrmDeleteForm (alert);
		
			if (buttonHit == deleteDeleteButton){
				NextOpenDocument=-1; // don't open next
				GotoBottomFlag=0;
				DeleteDBNumber = CurrentDBNumber;
				FrmGotoForm( MainForm);
				break;
			}
		}	
}


static void EditViewInit()
{
	FormType *frm = FrmGetActiveForm();
	RectangleType rect;

	AdjustCampusSize();

// Get current Display Extent. Necessasr
	if ( MachineFunctionality.supportHandEraHiRes){
		VgaFormModify( frm, vgaFormModify160To240 );
		RctSetRectangle( &rect , 0, 0, screenWidth, screenHeight);
		WinSetWindowBounds(FrmGetWindowHandle(FrmGetActiveForm()),&rect);
	}

	if( MachineFunctionality.supportClieSoftSilk){
		RctSetRectangle( &rect , 0, 0, screenWidth , screenHeight );
		WinSetWindowBounds(FrmGetWindowHandle(FrmGetActiveForm()),&rect);
	}

}


/***********************************************************************
 *
 * FUNCTION:		EditViewHandleEvent
 *
 * DESCRIPTION:	P3. Handles processing of events for the edit form.
 *
 * PARAMETERS:		event	- the most recent event.
 *
 * RETURNED:		True if the event is handled, false otherwise.
 *
 ***********************************************************************/
static Boolean EditViewHandleEvent(EventPtr event)
{
	Boolean	handled = false;
//	RectangleType rect;
	int i;
	int x,y;
	int key_index;
//	int dir;
	FontID new_font;
	
	switch (event->eType)
	{
   	case keyDownEvent:  // P13. User used Graffiti or a physical button
   		key_index = -1;
			switch (event->data.keyDown.chr){
				case  pageUpChr:
					key_index = BUTTON_UP_BUTTON ;
					break;
				case  pageDownChr:
					key_index = BUTTON_DOWN_BUTTON;
					break;
				case	hard1Chr :
					key_index = BUTTON_DATE_BUTTON;
					break;
				case	hard2Chr :
					key_index = BUTTON_ADDRESS_BUTTON;
					break;
				case	hard3Chr :
					key_index = BUTTON_TODO_BUTTON;
					break;
				case	hard4Chr :
					key_index = BUTTON_MEMO_BUTTON;
					break;

				case 	vchrJogPress:
					SkipJogRelease = false;
					break;
					
					
				case	TRGJogUpChar:
				case	vchrJogUp :
					key_index = BUTTON_JOG_UP;
					break;

				case	TRGJogDownChar:
				case	vchrJogDown:
					key_index = BUTTON_JOG_DOWN;
					break;

				case	vchrJogPageUp:
					key_index = BUTTON_JOG_PAGE_UP;
					SkipJogRelease = true;
					break;
				case	vchrJogPageDown:
					key_index = BUTTON_JOG_PAGE_DOWN;
					SkipJogRelease = true;
					break;

				case TRGJogPressChar:
					SkipJogRelease = false;
				case	vchrJogRelease:
					if ( 	SkipJogRelease == false)
						key_index = BUTTON_JOG_RELEASE;
					break;
				case vchrJogBack:
					CloseDocument();
					break;
					
			}				
			if ( key_index != -1)
				HandleKey( key_index);
			handled = true;
			break;
   	
   	case penDownEvent:

			x =event->screenX;
			y =event->screenY;
			
			if ( !MachineFunctionality.supportHandEraHiRes)
				ConvertPenPosition( prefs.orientation, &x,&y);
//			if ( MachineFunctionality.supportHiResolution){	
//				y = y* 2;
//			}
			
			if ( y < campusHeight * 19 / 20){
				if (y < campusHeight / 2 )
		    		HandleKey( BUTTON_TAP_UPPER );
	 			else
		    		HandleKey( BUTTON_TAP_LOWER );
 			} else if ( x < 102){
				if ( x > 98 )
					GotoBottom();
				else {
	 				i =  x * (TotalRecords-1) / 100 +1;
					if ( i > TotalRecords-1)
						i = TotalRecords-1;
					if ( i != CurrentRecord ){
						CurrentRecord = i;
						ReadOneRecord();
						topOfPage = 0;
						TotalDraw();
					}
				}
			}

 						
	   		handled = true;
			break;
							
  		case frmUpdateEvent:	// P11. The form must update it's presentation
			if ( event->data.frmUpdate.updateCode == frmRedrawUpdateCode ){ // Norma redraw
				TotalDraw();
			} else if ( event->data.frmUpdate.updateCode == jdocScreenRotate ){ // Screen Rotated 
				prefs.orientation = new_orientation;

				GetScreenExtent();
				AdjustCampusSize();
				if ( MachineFunctionality.supportHandEraHiRes){
					HandEraRotateScreen( prefs.orientation);
				}

// Remenber where I am looking now
				{
				int i,j;
				lineInfoPtr = MemHandleLock( lineInfoHandle);
				i = (lineInfoPtr+topOfPage)->start;  // Get Current Top of page index
				MemHandleUnlock( lineInfoHandle);

// Recalculate wrapping information.
				ReadOneRecord();

// Search for the pointer again
				lineInfoPtr = MemHandleLock( lineInfoHandle);
				for ( j = 0; j < PageLines; j++)
					if (  (lineInfoPtr+j)->start +  (lineInfoPtr+j)->chars >= i ){
						topOfPage = j;
						break;
					}
				MemHandleUnlock(lineInfoHandle);
				}


				TotalDraw();
			} else { // Size Changed
				AdjustCampusSize();
				TotalDraw();			
			}
			handled =true;
			break;
			
		case -1:
			break;


  		case frmOpenEvent:	// The form was told to open.
			// Assume Record and topOfPage is already set.
			EditViewInit();
			FrmDrawForm(FrmGetActiveForm());
   			if ( EditViewRetrieveData()){
//				FrmDrawForm(FrmGetActiveForm());
				TotalDraw();
				prefs.currentView = ViewForm;
			} else {
//				FrmDrawForm(FrmGetActiveForm());
				FrmCustomAlert( DebugAlert,"Empty Document","","");
				FrmGotoForm( MainForm);
			}
			handled = true;
			break;
			
		case displayExtentChangedEvent:
		
// Get current Display Extent. Necessasr
			if ( MachineFunctionality.supportHandEraHiRes){
				RectangleType rect;
				RctSetRectangle( &rect,0,0,1024,1024);
				WinEraseRectangle( &rect,0);
				WinGetDisplayExtent(&screenWidth, &screenHeight);
				RctSetRectangle( &rect , 0, 0, screenWidth, screenHeight);
				WinSetWindowBounds(FrmGetWindowHandle(FrmGetActiveForm()),&rect);
				PageLine = (campusHeight- 5) / LineSpace ;
				ScrollLines = PageLine - 1;
				TotalDraw();

				DisplayStateChanged = false;
	
			} else { // CLIE ?
// Fit the Current Window to Full Screen
  				Coord x,y;
				RectangleType rect;

				GetScreenExtent();
				AdjustCampusSize();
				
				RctSetRectangle( &rect,0,0, screenWidth, screenHeight);
// Make DrawWindow to full screen
				WinSetWindowBounds(FrmGetWindowHandle(FrmGetActiveForm()),&rect);
//				RctSetRectangle( &rect,0,0,480,480);
				WinEraseRectangle( &rect,0);

// Remenber where I am looking now
				{
				int i,j;
				lineInfoPtr = MemHandleLock( lineInfoHandle);
				i = (lineInfoPtr+topOfPage)->start;  // Get Current Top of page index
				MemHandleUnlock( lineInfoHandle);

// Recalculate wrapping information.
				ReadOneRecord();

// Search for the pointer again
				lineInfoPtr = MemHandleLock( lineInfoHandle);
				for ( j = 0; j < PageLines; j++)
					if (  (lineInfoPtr+j)->start +  (lineInfoPtr+j)->chars >= i ){
						topOfPage = j;
						break;
					}
				MemHandleUnlock(lineInfoHandle);
				}
				TotalDraw();

				DisplayStateChanged = false;
			}
			handled =true;
			break;
			
						
		case menuEvent:		// P4. A menu item was selected.
			// First clear the menu status from the display.
			MenuEraseStatus(0);
			
			// Process menu commands for the edit form.
			EditViewDoMenuCommand(event->data.menu.itemID);
			handled = true;
			break;

  		case frmCloseEvent:
			if ( prefs.storage_mode == STORAGE_INTERNAL){
	  			DmCloseDatabase( CurrentDB);
	  		} else {
	  			VFSFileClose( CurrentTextFile);
	  		}
	  		
			if ( lineInfoHandle !=nil){
				MemHandleFree( lineInfoHandle);
				lineInfoHandle= nil;
			}
			if ( dataHandle != nil){
				MemHandleFree( dataHandle);
				dataHandle = nil;
			}
			
			break;
	}
	return(handled);
}

static Boolean ScreenHandleEvent (EventPtr event)
{
	FormPtr 				frm;
	Boolean 				handled = false;
	int i;
	
	if (event->eType == ctlSelectEvent)
		{
		switch (event->data.ctlSelect.controlID)
			{
			case ScreenOkButton:
				frm = FrmGetActiveForm ();
// Get the current orientation setting 
				new_orientation = FrmGetObjectId(frm,FrmGetControlGroupSelection (frm, ScreenGroupID))-ScreenOrien1PushButton;
				FrmReturnToForm (0);
// Update is necesarry because Screen maybe rotated;
				FrmUpdateForm (ViewForm,  jdocScreenRotate); // 1 means screen rotated
				handled = true;
				break;

			case ScreenCancelButton:
				FrmReturnToForm (0);
				handled = true;
				break;			
			}
	}	else if (event->eType == frmOpenEvent){
// Set Current Screen Orientation
		if ( MachineFunctionality.supportHandEraHiRes &&(prefs.orientation != 1) && (prefs.orientation != 3)){
			VgaFormModify(FrmGetActiveForm(), vgaFormModify160To240 );
		}
		FrmDrawForm( FrmGetActiveForm());
		FrmSetControlGroupSelection (FrmGetActiveForm(), ScreenGroupID,ScreenOrien1PushButton+prefs.orientation);
		handled = true;
	}

	return (handled);
}

static Boolean OptionHandleEvent (EventPtr event)
{
	FormPtr 				frm;
	Boolean 				handled = false;
	int i;
	
	if (event->eType == ctlSelectEvent)
		{
		switch (event->data.ctlSelect.controlID)
			{
			case optionOkButton:
				frm = FrmGetActiveForm ();
// Get the setting 
//				Orientation = FrmGetObjectId(frm,FrmGetControlGroupSelection (frm, FormGroupID))-optionOrien1PushButton;
				for ( i = 0 ; i <NUM_BUTTON; i++)
					button_action[i] = LstGetSelection( GetObjectPtr (optionFirstList+i));

				MemHandleUnlock(operation);

				MemHandleUnlock (parrayH);
				MemHandleFree( parrayH);
				FrmReturnToForm (0);
// Update is necesarry because Screen maybe rotated;
				FrmUpdateForm (ViewForm, 0);
				handled = true;
				break;

			case optionCancelButton:
				MemHandleUnlock(operation);

				MemHandleUnlock (parrayH);
				MemHandleFree( parrayH);
				FrmReturnToForm (0);
				handled = true;
				break;			
			}
	}	else if (event->eType == frmOpenEvent){
		OptionFormInit();
		handled = true;
	}

	return (handled);
}


void OptionFormInit()
{
	ListPtr lst;
	CharPtr label;
	FormPtr frm;
	ControlPtr ctl;
	int i;
	CharPtr operation_lists;
	int num_ops = NUM_ACTION;
	int x,y;
	RectangleType rect;
	
	frm = FrmGetActiveForm ();

	if ( MachineFunctionality.supportHandEraHiRes && (prefs.orientation != 1) && (prefs.orientation != 3)){
		WinGetDisplayExtent(&screenWidth, &screenHeight);
		VgaFormModify( frm, vgaFormModify160To240 );
	}

	operation = DmGetResource('tSTR',2000);
	operation_lists = MemHandleLock( operation);
	
	parrayH =  SysFormPointerArrayToStrings(operation_lists, num_ops );
	parray = MemHandleLock( parrayH);


	if ( ( MachineFunctionality.hasHandEraJog) || ( MachineFunctionality.hasTreoJog) ){ // HandEra type Jog. Hide for press+move

		ShowObject( optionJogTitleLabel );

		ShowObject( optionJogUpLabel );
		ShowObject( optionJogUpPopTrigger );

		ShowObject( optionJogDownLabel );
		ShowObject( optionJogDownPopTrigger );

		ShowObject( optionJogPressLabel );
		ShowObject( optionJogPressPopTrigger);

	} else if ( MachineFunctionality.hasJogDial ){ // No Jog Dial hide all jog related object

		ShowObject( optionJogTitleLabel );

		ShowObject( optionJogUpLabel );
		ShowObject( optionJogUpPopTrigger );

		ShowObject( optionJogDownLabel );
		ShowObject( optionJogDownPopTrigger );

		ShowObject( optionJogPressLabel );
		ShowObject( optionJogPressPopTrigger);

		ShowObject( optionJogPageUpLabel );
		ShowObject( optionJogPageUpPopTrigger);

		ShowObject( optionJogPageDownLabel );
		ShowObject( optionJogPageDownPopTrigger );

	} else if ( MachineFunctionality.has5WayNavigator) {
		ShowObject( optionNavigatorTitleLabel );
	} else if ( MachineFunctionality.hasOnly2Button){
		HideObject( optionTodoLabel);
		HideObject( optionTodoPopTrigger);

		HideObject( optionMemoLabel);
		HideObject( optionMemoPopTrigger);
	}

// Set Current Functions
	for ( i = 0 ; i < NUM_BUTTON ; i++){
		lst = GetObjectPtr (optionFirstList+i);		
		ctl = GetObjectPtr (optionFirstPopTrigger+i);
//		SndPlaySystemSound( sndError);
//		SysTaskDelay(30);
		
		FrmGetObjectBounds( frm, FrmGetObjectIndex( frm, optionFirstPopTrigger+i), &rect);
//		rect = ctl->bounds;

		x =rect.topLeft.x+12;
		y = rect.topLeft.y - 11*num_ops/2;
		if ( y + 11*num_ops > 157)
			y = 157 - 11*num_ops;

		LstSetListChoices( lst, parray,num_ops);
		LstSetSelection (lst, button_action[i]);
		LstSetHeight( lst, num_ops);
		LstSetPosition( lst, x, y);
		
		label = LstGetSelectionText (lst, button_action[i]);
		CtlSetLabel (ctl, label);
	}

	FrmDrawForm (frm);
	
	return;
}

static Int16 MainViewDocumentsInTable(void)
{
	TableType	*tableP;
	Word			rowsInTable;

	// Get the table and it's number of rows
//	tableP = FrmGetObjectPtr (FrmGetActiveForm(), FrmGetObjectIndex (FrmGetActiveForm(), mainDocumentTable));
//	rowsInTable = TblGetNumberOfRows (tableP);

	rowsInTable = TableRows;
	
	return rowsInTable;
}

static void MainViewDrawRecordInBounds( CharPtr doc, RectanglePtr bounds)
{
	short			textLen,width;
	Boolean		fits;
	FontID 		currFont;
	int x,y;
	char ch;
	
	// Set the standard font.  Save the current font.
	// It is a Pilot convention to not destroy the current font
	// but to save and restore it.
	
	x = bounds->topLeft.x + 1;
	y = bounds->topLeft.y;
	currFont = FntSetFont (symbolFont);
	ch = symbolMemo;
	WinDrawChars (&ch, 1, x, y  );
	x += FntCharWidth (ch) + 4;

	FntSetFont ( MainFormFont);

	// Determine the length of text that will fit within the bounds.
	width = bounds->extent.x - (FntCharWidth(ch)+4) - 4;
	textLen = StrLen(doc);
	FntCharsInWidth(doc, &width, &textLen, &fits);
	
	// Now draw the text from the record.
	if ( fits){
		WinDrawChars(doc, textLen, x,y);
	} else {
		width = bounds->extent.x - (FntCharWidth(ch)+4) - 4- FntCharsWidth("...",3);;
		textLen = StrLen(doc);

		FntCharsInWidth(doc, &width, &textLen, &fits);
		WinDrawChars(doc, textLen, x,y);
		WinDrawChars("...",3, x + width,y);
	}
	// Restore the font.
	FntSetFont (currFont);
}


static void MainViewDrawRecordName(VoidPtr tableP, Int16 row, Int16 column, 
	RectanglePtr bounds)
{
	UInt			docNum = 0;
	

	// Get the record number that corresponds to the table item to draw.
	// The record number is stored in the "intValue" field of the item.
	docNum = TblGetItemInt (tableP, row, column) + TopVisibleRecord;

	// P14. Draw the record
	if ( prefs.storage_mode == STORAGE_INTERNAL)
		MainViewDrawRecordInBounds(doc_infos[ docNum]->name , bounds);
	else
		MainViewDrawRecordInBounds( ( MSFileListP + docNum)->file_name , bounds);
}

static void MainViewDrawRecordSize(VoidPtr tableP, Int16 row, Int16 column, 
	RectanglePtr bounds)
{
	UInt			docNum = 0;
	ULong 	bytes;	
	char buf[10];

	// Get the record number that corresponds to the table item to draw.
	// The record number is stored in the "intValue" field of the item.
	docNum = TblGetItemInt (tableP, row, column) + TopVisibleRecord;

// MS FIles can't display size
	if ( prefs.storage_mode != STORAGE_INTERNAL)
		return;
		
	bytes = doc_infos[ docNum ]->size;
	StrIToA( buf,bytes);
	StrCat( buf,"k");
	FntSetFont(stdFont);
	WinDrawChars(buf,StrLen(buf),bounds->topLeft.x, bounds->topLeft.y);
	return;
}


/***********************************************************************
 *
 * FUNCTION:    MainViewLoadTable
 *
 * DESCRIPTION: P12. Loads the database records into the main table.
 *
 * PARAMETERS:  frm - form containing table to load
 *					 recordNum - index of the first record to display.
 *
 * RETURNED:    nothing
 *
 ***********************************************************************/
static void MainViewLoadTable (FormPtr frm, UInt recordNum)
{
	Word			row;
	Word			lastRecordNum;
	Word			numRows;
	TablePtr 	tableP;

	
	tableP = FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, mainDocumentTable));

	// For each row in the table, store the record number in the 
	// table item that will display the record.  
	numRows = TblGetNumberOfRows (tableP);
//	numRows = TableRows;
	
	FntSetFont( MainFormFont );
	for (row = 0; row < numRows; row++, recordNum++)
		{		
		
		// If the record was found, store the record number in the table item,
		// otherwise set the table row unusable.
		if ((  row < ((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles)) && ( row < TableRows) )
			{
			// Set customTableItem to indicate that we want to be called
			// to draw the record.  The callback set in MainViewLoadRecords
			// will be called to draw the record.
			TblSetItemStyle (tableP, row, 0, customTableItem);
			TblSetItemStyle (tableP, row, 1, customTableItem);
			TblSetItemInt (tableP, row, 0, row);
			TblSetItemInt (tableP, row, 1, row);
			TblSetRowUsable (tableP, row, true);
			TblSetRowHeight ( tableP, row , FntCharHeight());
			lastRecordNum = row;
			}
		else
			{
			// Sometimes there are more table rows than records.
			// If this happens mark those unused table rows as
			// not usable.
			TblSetRowUsable (tableP, row, false);
			}

		// Mark the row invalid so that it will draw when we call the 
		// draw routine.
		TblMarkRowInvalid (tableP, row);

		}

//	TopVisibleRecord = 0;
}


/***********************************************************************
 *
 * FUNCTION:		MainViewLoadRecords
 *
 * DESCRIPTION:	P12. Loads the table object with records.
 *
 * PARAMETERS:		frm - form containing table to load
 *
 * RETURNED:		Nothing.
 *
 ***********************************************************************/
static void MainViewLoadRecords(FormPtr frm)
{
	TablePtr 	tableP;
	Word			rowsInTable;
	RectangleType rect;
	
	// Get the table and it's number of rows
	tableP = FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, mainDocumentTable));

	FntSetFont( MainFormFont);
	FrmGetObjectBounds(  frm, FrmGetObjectIndex (frm, mainDocumentTable) , &rect);
	TableRows = rect.extent.y / FntCharHeight();

//	TableRows = tableP->bounds.extent.y / FntCharHeight();


//	rowsInTable = TblGetNumberOfRows (tableP);
	rowsInTable = TableRows;

	// Now that the table is in position load the records.
	MainViewLoadTable (frm, TopVisibleRecord);

	// Set the callback routine that will draw the records.
	TblSetCustomDrawProcedure (tableP, 0, MainViewDrawRecordName);
	TblSetCustomDrawProcedure (tableP, 1, MainViewDrawRecordSize);

	// Set the column usable so that it draws and accepts user input.
	TblSetColumnUsable (tableP, 0, true);	
	TblSetColumnUsable (tableP, 1, true);	

	MainViewUpdateScrollers ();
}

void
MainViewUpdateScrollers()
{
	Word pos;
	Word rows;
	Word maxValue;

//	rows = TblGetNumberOfRows (GetObjectPtr(mainDocumentTable));
	rows = TableRows;
	if (((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles) > rows){
		pos = TopVisibleRecord;
		maxValue = ((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles) - rows;
	} else {
		pos = 0;
		maxValue = 0;
	}

	SclSetScrollBar (GetObjectPtr (mainDocumentScrollBar), pos, 0, maxValue, rows);
}

void MainViewRedrawDocumentList()
{
	Word			row;
	Word			numRows;
	TablePtr 	tableP;

// Get Scroll Position
	tableP = GetObjectPtr (mainDocumentTable);
	numRows = TblGetNumberOfRows (tableP);

	for (row = 0; row < numRows; row++)
		TblMarkRowInvalid (tableP, row);
	
	TblRedrawTable(GetObjectPtr (mainDocumentTable));	
}

void
MainViewLiveScroll()
{
	Short pos;
	Int16 dum1,dum2,dum3;
// Get Scroll Position
	SclGetScrollBar (GetObjectPtr (mainDocumentScrollBar),&pos, &dum1, &dum2, &dum3);
	TopVisibleRecord=	pos;

	MainViewRedrawDocumentList();

	if ( CurrentDBNumber < TopVisibleRecord){
		CurrentDBNumber = TopVisibleRecord;
	} else if ( CurrentDBNumber > TopVisibleRecord + MainViewDocumentsInTable() - 1) {
		CurrentDBNumber = TopVisibleRecord + MainViewDocumentsInTable()  - 1;
	}
	if ( CursorDisplayed){
		MainViewSetDocumentChoice( CurrentDBNumber);
	}

	return;
}

static void MainViewScroll (WinDirectionType direction, Boolean oneLine)
{
	Short pos,min,max,page;
	Short oldpos;
	SclGetScrollBar (GetObjectPtr (mainDocumentScrollBar),&pos, &min, &max,&page);
	oldpos = pos;
	
	if ( direction == winUp){
		pos -= page;
		if ( pos < min)
			pos = min;
	} else if ( direction == winDown){
		pos += page;
		if ( pos > max)
			pos = max;
	}
	
	if ( pos != oldpos){
		SclSetScrollBar (GetObjectPtr (mainDocumentScrollBar),pos, min, max,page);
		MainViewLiveScroll();
	}
}

static void MainViewAdjustPosition(Int16 choice)
{
	Int16 row =  MainViewDocumentsInTable();
	
// When out of screen
	if ( TopVisibleRecord > choice){
		TopVisibleRecord = choice;
		MainViewRedrawDocumentList();
	} else if ( TopVisibleRecord + row-1 < choice) {
		TopVisibleRecord = choice -  row +1;
		MainViewRedrawDocumentList();
	}

	if (( ((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles) > row) && (  TopVisibleRecord > ((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles) - row ))
		 TopVisibleRecord = ((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles) - row;
}

static void MainViewSetDocumentChoice(int choice )
{
	char buf[32];
	TablePtr 	tableP;
	Int16 rowsInTable;
	
	if ( ((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles) == 0)
		return;
	
	rowsInTable = MainViewDocumentsInTable();

//	StrPrintF(buf,"row %d  ",choice);
//	WinDrawChars( buf,StrLen(buf),0,0);

	TblUnhighlightSelection(GetObjectPtr (mainDocumentTable));
	
// adjust Table position so that cursor in in the screen
	MainViewAdjustPosition( choice);
	
	TblSelectItem(GetObjectPtr (mainDocumentTable),choice - TopVisibleRecord,0);	
	MainViewUpdateScrollers();
	CursorDisplayed	= true;
}


/***********************************************************************
 *
 * FUNCTION:		MainViewInit
 *
 * DESCRIPTION:	P7. Initializes the main form and the list object.
 *
 * PARAMETERS:		frm - pointer to the main form.
 *
 * RETURNED:		Nothing.
 *
 ***********************************************************************/
static void MainViewInit(void)
{
	FormPtr			frm;
//	ScrollBarPtr bar;
	int i;
	RectangleType rect;

	// Get a pointer to the main form.
	frm = FrmGetActiveForm();

// Get Screen Extent and Campus Size
	AdjustCampusSize();

	if ( MachineFunctionality.supportHandEraHiRes){
		TableType *tbl = GetObjectPtr( mainDocumentTable);
		ScrollBarType *scl = GetObjectPtr( mainDocumentScrollBar);
		RectangleType r;
		
		RctSetRectangle( &rect , 0, 0, screenWidth, screenHeight);
		WinSetWindowBounds(FrmGetWindowHandle(FrmGetActiveForm()),&rect);
		VgaFormModify( frm, vgaFormModify160To240 );
		VgaTableUseBaseFont( GetObjectPtr(mainDocumentTable), true);

		TblGetBounds( tbl, &r);
		RctSetRectangle( &r , r.topLeft.x ,r.topLeft.y ,screenWidth - 10 , screenHeight - r.topLeft.y);  
		TblSetBounds (tbl , &r);

		FrmGetObjectBounds ( frm , GetObjectIndexFromID( mainDocumentScrollBar),&r);
		RctSetRectangle( &r ,screenWidth - 10 ,r.topLeft.y ,r.extent. x , screenHeight - r.topLeft.y);  
		FrmSetObjectBounds ( frm,  GetObjectIndexFromID( mainDocumentScrollBar), &r);
	}


	if ( MachineFunctionality.supportClieSoftSilk){
		Coord x,y;
		TableType *tbl = GetObjectPtr( mainDocumentTable);
		ScrollBarType *scl = GetObjectPtr( mainDocumentScrollBar);
		RectangleType r;
		x =screenWidth ;
		y = screenHeight ;
		RctSetRectangle( &rect , 0, 0,x, y);
		WinSetWindowBounds(FrmGetWindowHandle(FrmGetActiveForm()),&rect);

		TblGetBounds( tbl, &r);
		RctSetRectangle( &r , r.topLeft.x ,r.topLeft.y ,screenWidth - 10 , screenHeight - r.topLeft.y);  
		TblSetBounds (tbl , &r);

		FrmGetObjectBounds ( frm , GetObjectIndexFromID( mainDocumentScrollBar),&r);
		RctSetRectangle( &r ,screenWidth - 10 ,r.topLeft.y ,r.extent. x , screenHeight - r.topLeft.y);  
		FrmSetObjectBounds ( frm,  GetObjectIndexFromID( mainDocumentScrollBar), &r);
	}

	
// Temporary Disable Table
	FrmHideObject( frm ,FrmGetObjectIndex( frm, mainDocumentTable));

// Check for the existance of Memory Card
	CheckForStorage();

// when DELETE is selected in View menu, Let's delete it		
	if ( DeleteDBNumber != noSelected){ 
		if ( prefs.storage_mode == STORAGE_INTERNAL){
			DmDeleteDatabase (doc_infos[ DeleteDBNumber]->card_no,doc_infos[ DeleteDBNumber]->local_id);
			TotalDocuments --;
			if ( ((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles)  != 0 ){
	// Delete Document Info block
				MemPtrFree(doc_infos[ DeleteDBNumber]);
	// Delete info management
				for ( i =  DeleteDBNumber; i < ((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles); i++)
					doc_infos[ i] = doc_infos[ i+1];
			}
		} else { // MS
			char path[256];

			StrCopy( path, card_path);
			StrCat( path , (MSFileListP+ DeleteDBNumber)->file_name);

			VFSFileDelete( volumeRefNum, path);
			numMSFiles--;

			for ( i =  DeleteDBNumber; i < numMSFiles; i++){
				*(MSFileListP + i) = *(MSFileListP + i+1) ;
			}
/*
			if ( MSFileListP){
				MemPtrUnlock( MSFileListP);
				MSFileListP=0;
			}
			CreateMSFileList(&MSFileListH, &numMSFiles);
			MSFileListP = MemHandleLock ( MSFileListH);
*/	
		}
		
		DeleteDBNumber = noSelected;

		if ( CurrentDBNumber >= ((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles))
			CurrentDBNumber = ((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles) -1;

	}
	
// Check is Media Select trigger is necesarry
	if (  (!MachineFunctionality.supportExternalMedia ) || (!MediaExists)){
		HideObject( mainStoragePopTrigger);
		if( prefs.storage_mode == STORAGE_CARD){
			prefs.storage_mode = STORAGE_INTERNAL;		
			CurrentDBNumber = noSelected;
			TopVisibleRecord = 0;
		}			
	}

	if ( NeedResearchDocumentList){
		NeedResearchDocumentList = false;
		if ( prefs.storage_mode == STORAGE_INTERNAL){
			GetDocumentList( false,0,0);
		} else {
			if ( MSFileListP){
				MemPtrUnlock( MSFileListP);
				MSFileListP=0;
			}
			CreateMSFileList(&MSFileListH, &numMSFiles);
			MSFileListP = MemHandleLock( MSFileListH);
		}
	}
	
// if NextDocument or Previous Document is executed in view form.
	if ( NextOpenDocument != -1){
		if ( 	GotoBottomFlag == 0 ){
			CurrentRecord = 1;
			topOfPage =0;	
		}	
		// if it really exits?
		if ( ( NextOpenDocument >= 0 )&& ( NextOpenDocument <((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles))){
			CurrentDBNumber = NextOpenDocument;
		// Go to the edit form.	
			FrmGotoForm(ViewForm);
		}
		NextOpenDocument = 0;
	}		

// Hide Selection cursor
	CursorDisplayed	= false;
	
// Assure cursor is in the screen
	if ( CurrentDBNumber != noSelected) 	
		MainViewAdjustPosition( CurrentDBNumber);

	MainViewLoadRecords(frm);

// Show Table
	FrmShowObject( frm ,FrmGetObjectIndex( frm, mainDocumentTable));

	if ( MachineFunctionality.supportExternalMedia && MediaExists){
		LstSetSelection( GetObjectPtr(mainStorageList), prefs.storage_mode);
		CtlSetLabel( GetObjectPtr( mainStoragePopTrigger) , LstGetSelectionText( GetObjectPtr(mainStorageList), prefs.storage_mode));
	}
//	 else {
//		CtlHideControl( GetObjectPtr( mainStoragePopTrigger));
//	}
	
	// Draw the form.
	FrmDrawForm(frm);
	prefs.currentView	= MainForm;
}


/***********************************************************************
 *
 * FUNCTION:		MainViewHandleEvent
 *
 * DESCRIPTION:	Handles processing of events for the main form.
 *
 * PARAMETERS:		event	- the most recent event.
 *
 * RETURNED:		True if the event is handled, false otherwise.
 *
 ***********************************************************************/
static Boolean MainViewHandleEvent(EventPtr event)
{
	Boolean		handled = false;
	int db_number;
	FormType *frm = FrmGetActiveForm();
	
	switch (event->eType)
	{

	case displayExtentChangedEvent:
		{
			RectangleType rect;
			RctSetRectangle(&rect,0,0,320,320);
			WinEraseRectangle(&rect,0);
			FrmGotoForm( MainForm );
			DisplayStateChanged = false;
			handled = true;
		}
		break;	

	case frmUpdateEvent:
		break;
		
   	case keyDownEvent:		// P13.  Handle the physical scroll buttons
	   	switch (event->data.keyDown.chr){
	   		case vchrJogPageUp:
				IgnoreJogRelease = true;

	   		case vchrPageUp:
		   		MainViewScroll (winUp, false);
		   		handled = true;
				break;

	   		case vchrJogPageDown:
				IgnoreJogRelease = true;

	   		case vchrPageDown:
		   		MainViewScroll (winDown, false);
		   		handled = true;
				break;
		
			case	TRGJogUpChar:
			case vchrJogUp:
				if (! CursorDisplayed){
			   		MainViewScroll (winUp, false);
//					EvtEnqueueKey( vchrPageUp, 0,commandKeyMask);
//					CurrentDBNumber = 0;
				} else if ( CurrentDBNumber != 0 && CursorDisplayed	){
					CurrentDBNumber--;		
					MainViewSetDocumentChoice( CurrentDBNumber);
				}
				break;

			case	TRGJogDownChar:
			case vchrJogDown:
				if ( ! CursorDisplayed){
			   		MainViewScroll (winDown, false);
//					EvtEnqueueKey( vchrPageDown, 0,commandKeyMask);
//					CurrentDBNumber = 0;
				} if ( CurrentDBNumber != ((prefs.storage_mode==STORAGE_INTERNAL)?TotalDocuments:numMSFiles) -1 && CursorDisplayed	){
					CurrentDBNumber++;
					MainViewSetDocumentChoice( CurrentDBNumber);
				}
				break;

			case vchrJogPress:
				IgnoreJogRelease = false;
				break;

			case	TRGJogPressChar: // TRG Jog is press only.
				IgnoreJogRelease = false;

			case vchrJogBack:
				if ( CursorDisplayed){
					TblUnhighlightSelection(GetObjectPtr (mainDocumentTable));
					CursorDisplayed = false;	
				} else {
					EvtEnqueueKey ( vchrLaunch , 0, commandKeyMask);
				}
				break;
				
			case vchrJogRelease:
				if ( CursorDisplayed && IgnoreJogRelease == false && ( CurrentDBNumber != noSelected) ){
					GotoBottomFlag = 0;
					CurrentRecord = 1;
					topOfPage =0;	
					// Go to the edit form.	
					FrmGotoForm(ViewForm);
				} else if  ( !IgnoreJogRelease && MachineFunctionality.supportExternalMedia ){  // Change Internal/MemoryCard

					CurrentDBNumber = TopVisibleRecord;
					MainViewSetDocumentChoice( CurrentDBNumber);

/*					EventType fake;
					int sel = ( prefs.storage_mode == STORAGE_INTERNAL)?1:0;
					
					if ( !MediaExists )
						break;
					
					LstSetSelection( GetObjectPtr(mainStorageList), sel); // Usually not necesarry, only for fake event forjog press
					
					fake.eType = popSelectEvent;
					fake.data.popSelect.controlID = mainStoragePopTrigger;
					fake.data.popSelect.selection = sel ;
					EvtAddEventToQueue( &fake);				
*/				}
			}
			handled = true;
			break;				
/*
		case msRemovedEvent:
			if ( prefs.storage_mode == STORAGE_CARD){
				prefs.storage_mode = STORAGE_INTERNAL;
				LstSetSelection( GetObjectPtr(mainStorageList), prefs.storage_mode);
				CtlSetLabel( GetObjectPtr( mainStoragePopTrigger) , LstGetSelectionText( GetObjectPtr(mainStorageList), prefs.storage_mode));
				CurrentDBNumber = noSelected;
				TopVisibleRecord = 0;
				
				MainViewLoadRecords(FrmGetActiveForm());
				TblRedrawTable(GetObjectPtr( mainDocumentTable));
			}
			handled = true;
			break;
*/						
		case popSelectEvent:
			if ( event->data.popSelect.controlID == mainStoragePopTrigger){
				if ( !MediaExists){
					prefs.storage_mode = STORAGE_INTERNAL;
					LstSetSelection( GetObjectPtr(mainStorageList), prefs.storage_mode);
					CtlSetLabel( GetObjectPtr( mainStoragePopTrigger) , LstGetSelectionText( GetObjectPtr(mainStorageList), prefs.storage_mode));
					FrmAlert(NoMSAlert);
					handled = true; // Skip changing PopTrigger
				} else {
					prefs.storage_mode = LstGetSelection( GetObjectPtr( mainStorageList));
					NeedResearchDocumentList = true; // Request re-search in MS
					CurrentDBNumber = noSelected;
					TopVisibleRecord = 0;
					FrmGotoForm( MainForm);

/*					CtlSetLabel( GetObjectPtr( mainStoragePopTrigger) , LstGetSelectionText( GetObjectPtr(mainStorageList), prefs.storage_mode));

					if ( prefs.storage_mode == STORAGE_MS){
						if ( MSFileListP){
							MemPtrUnlock( MSFileListP);
							MSFileListP=0;
						}

						FrmHideObject( frm ,FrmGetObjectIndex( frm, mainDocumentTable));
						CreateMSFileList(&MSFileListH, &numMSFiles);
//						FrmShowObject( frm ,FrmGetObjectIndex( frm, mainDocumentTable));

						MSFileListP = MemHandleLock ( MSFileListH);
					}
					CurrentDBNumber = noSelected;
					TopVisibleRecord = 0;
					MainViewLoadRecords(FrmGetActiveForm());
					TblRedrawTable(GetObjectPtr( mainDocumentTable));
					FrmShowObject( frm ,FrmGetObjectIndex( frm, mainDocumentTable));
*/
					handled = true;
				}
			}
			break;
				
 		case tblSelectEvent:  // P12. An entry in the table was selected.
			// Edit the record at the selected table item.
			db_number = TblGetItemInt (event->data.tblSelect.pTable, 
				event->data.tblSelect.row, event->data.tblSelect.column);
			
			CurrentDBNumber = db_number + TopVisibleRecord; 
			GotoBottomFlag = 0;
			CurrentRecord = 1;
			topOfPage =0;	
			// Go to the edit form.	
			FrmGotoForm(ViewForm);
			handled = true;
			break;

  		case frmOpenEvent:	// P3. The form was told to open.
  			// P7. Initialize the main form.
			MainViewInit();
			handled = true;
			break;
			
		case menuEvent:		// P2. A menu item was selected.
			// First clear the menu status from the display.
			MenuEraseStatus(0);
			
			// Process menu commands for the edit form.
			MainViewDoMenuCommand(event->data.menu.itemID);

			handled = true;
			break;
		case sclRepeatEvent:
			MainViewLiveScroll();
		}
	return(handled);
}

void
MainViewDoMenuCommand(int menu)
{
	FormPtr frm;
	switch ( menu){
	
		case MainOptionsAboutJDOCReader:

			frm = FrmInitForm(InfoForm);
			if ( MachineFunctionality.supportHandEraHiRes){
				VgaFormModify( frm, vgaFormModify160To240 );
			}
			
			FrmDoDialog(frm);
			
			// Delete the info form.
	 		FrmDeleteForm(frm);
			break;

	case MainOptionsOperations:
			FrmPopupForm(OptionForm);
			break;

	case MainOptionsScreenRotate:
			if ( !MachineFunctionality.supportHandEraHiRes){
				FrmAlert( RotateOnlyAlert);
			}
			FrmPopupForm(ScreenForm);
			break;

	}
	return ;
}


/***********************************************************************
 *
 * FUNCTION:    ApplicationHandleEvent
 *
 * DESCRIPTION: P3. This routine loads a form resource and sets the event handler for the form.
 *
 * PARAMETERS:  event - a pointer to an EventType structure
 *
 * RETURNED:    True if the event has been handled and should not be
 *						passed to a higher level handler.
 *
 ***********************************************************************/
static Boolean ApplicationHandleEvent(EventPtr event)
{
	FormPtr	frm;
	Int		formId;
	Boolean	handled = false;

	if (event->eType == frmLoadEvent)
		{
		formId = event->data.frmLoad.formID;
		frm = FrmInitForm(formId);
		FrmSetActiveForm(frm);

		switch (formId)
			{
			case MainForm:
				FrmSetEventHandler(frm, MainViewHandleEvent);
				break;
		
			case ViewForm:
				FrmSetEventHandler(frm, EditViewHandleEvent);
				break;

			case OptionForm:
				FrmSetEventHandler(frm, OptionHandleEvent);
				break;

			case ScreenForm:
				FrmSetEventHandler(frm, ScreenHandleEvent);
				break;

		}
		handled = true;
		}
	
	return handled;
}

Boolean IsHardKeyReserved(EventType *evt)
{
	int key_index=0;
	
	if ( evt->eType != keyDownEvent)
		return false;

	if ( evt->data.keyDown.modifiers &  poweredOnKeyMask ) // if powered on by button?
		return false;
		
	switch( evt->data.keyDown.chr){
		case	hard1Chr: 
			key_index = 4;
			break;
		case	hard2Chr:
			key_index = 5;
			break;
		case	hard3Chr: 
			key_index = 6;
			break;
		case	hard4Chr:
			key_index = 7;
			break;
	}				
	
	if ( key_index && (button_action[key_index] != ACTION_NONE ))		
		return true;
		
	return false;
}

/***********************************************************************
 *
 * FUNCTION:		EventLoop
 *
 * DESCRIPTION:	A simple loop that obtains events from the Event
 *						Manager and passes them on to various applications and
 *						system event handlers before passing them on to
 *						FrmDispatchEvent for default processing.
 *
 * PARAMETERS:		None.
 *
 * RETURNED:		Nothing.
 *
 ***********************************************************************/
static void EventLoop(void)
{
	EventType	event;
	Word			error;
	int 		ignore_hardkey;
	
	ignore_hardkey = 0;
	
	do
		{
		if ( CardStateChanged){
			CardStateChanged = false;
			FrmGotoForm( MainForm);
		}
		
		if ( DisplayStateChanged){
			EventType ev;
			ev.eType = displayExtentChangedEvent;
			ev.data.frmUpdate.updateCode = jdocScreenExtend;
			EvtAddEventToQueue( &ev);
			DisplayStateChanged = false;
		}
		
		// Get the next available event.
		EvtGetEvent(&event, evtWaitForever);
/*	
		if ( event.eType == frmUpdateEvent){
			Coord x,y;
			char buf[64];
			WinGetDisplayExtent( &x,&y);
			if ( MachineFunctionality.supportClieSoftSilk){
				screenWidth = x * 2;
				 screenHeight = y * 2;
			} else {
				screenWidth = x;
				screenHeight = y;
			}
			
			AdjustCampusSize();
		}
*/
	
		// Give the system a chance to handle the event.
		if ( (  (prefs.currentView ==ViewForm) && IsHardKeyReserved(&event) )  || (! SysHandleEvent(&event)) )
			if (! MenuHandleEvent(0, &event, &error))
				if (! ApplicationHandleEvent(&event))
					FrmDispatchEvent(&event);
		
		}
	while (event.eType != appStopEvent);
}

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
		
	switch ( cmd){

		case sysAppLaunchCmdNormalLaunch :

			GetMachineFunctionality(&MachineFunctionality);

			if ( MachineFunctionality.supportHighDensity){
				MachineFunctionality.supportHiResolution = 0;
			}
			
			if (  MachineFunctionality.osVersion >= 0x350 ){
				if (!StartApplication()){
					FrmGotoForm(prefs.currentView);
					EventLoop();
					StopApplication();
				}
			} else
				FrmAlert( RomIncompatibleAlert); 
			break;

		case sysAppLaunchCmdSyncNotify :
		case sysAppLaunchCmdSystemReset :
			{
				MachineFunctionType func; 
				GetMachineFunctionality(&func);
				if ( func.supportExternalMedia && ( func.vfsManagerVersion >= 2)){
//					SndPlaySystemSound( sndAlarm);
					VFSRegisterDefaultDirectory( ".txt", ExpMediaType_Any , CARD_TEXT_PATH);
				}
			}
			break;
	}
	
	return 0;
}
