/*
 * PRC-Tools $B9V:B(B $B%5%s%W%k%W%m%0%i%`(B 2
 *
 * Copyright (c) 2002 WATANABE, Yoshiki
 */

#include <PalmOS.h>
#include "ResourceHelloWorldRsc.h"

/*
 * StartApplication -- $B%"%W%j%1!<%7%g%s$N=i4|2=$r9T$J$&(B
 * 
 * MainForm $B$r3+$/(B
 */
static Err StartApplication(void)
{
    FrmGotoForm(MainForm); // MainForm $B$r3+$/(B
    return errNone;
}

/*
 * MainFormHandleEvent -- MainForm $B$K4X$o$k%$%Y%s%H$r=hM}$9$k(B
 * 
 * MainForm $B$N=i4|2=$K4X$9$k%$%Y%s%H$r=hM}$9$k(B
 */
static Boolean MainFormHandleEvent(EventPtr event)
{
    Boolean handled = false;

    switch (event->eType) {
    case frmOpenEvent: // MainForm $B$,3+$+$l$?(B
	FrmDrawForm(FrmGetActiveForm()); // MainForm $B$rI=<($9$k(B
	handled = true;
	break;
    }

    return handled;
}

/*
 * ApplicationHandleEvent -- $B%"%W%j%1!<%7%g%sA4BN$K4X$o$k%$%Y%s%H$r=hM}$9$k(B
 * 
 * $B3+$+$l$?%U%)!<%`$r%"%/%F%#%V$K$7%$%Y%s%H%O%s%I%i$r@_Dj$9$k(B
 */
static Boolean ApplicationHandleEvent(EventPtr event)
{
    Boolean handled = false;

    if (event->eType == frmLoadEvent) { // $B%U%)!<%`$r%m!<%I$9$k(B
	UInt16 formId = event->data.frmLoad.formID; // $B%m!<%I$9$k%U%)!<%`$N(B ID
						    // $B$r<hF@(B ($B$3$NNc$G$O>o$K(B
						    // MainForm)
	FormPtr form =  FrmInitForm(formId); // $B%U%)!<%`$r%m!<%I$7$F=i4|2=$9$k(B

	FrmSetActiveForm(form); // $B%m!<%I$7$?%U%)!<%`$r%"%/%F%#%V$K$9$k(B

	switch (formId) {
	case MainForm:
	    // $B$3$N%U%)!<%`$KBP$9$k%$%Y%s%H$r(B MainFormHandleEvent $B$G(B
	    // $B=hM}$9$k$h$&$K@_Dj$9$k(B
	    FrmSetEventHandler(form, MainFormHandleEvent);
	    break;
	}
	handled = true;
    }

    return handled;
}

/*
 * EventLoop -- $B%$%Y%s%H$r<h$j9~$_I,MW$J=hM}$r9T$J$&(B
 * 
 * $B%$%Y%s%H$r=hM}$9$k(B API, $B4X?t$rE,598F$S=P$9(B
 */
static void EventLoop(void)
{
    EventType event;

    do {
	EvtGetEvent(&event, evtWaitForever); // $B<!$N%$%Y%s%H$r<hF@$9$k(B
	if (!SysHandleEvent(&event)) { // $B%7%9%F%`4XO"$N%$%Y%s%H$r=hM}$9$k(B
	    Err error;
	    if (!MenuHandleEvent(NULL, &event, &error)) { // $B%a%K%e!<4XO"$N%$(B
							  // $B%Y%s%H$r=hM}$9$k(B
							  // ($B$3$NNc$G$O=hM}$9(B
							  // $B$Y$-%$%Y%s%H$O$J(B
							  // $B$$(B)
		if (!ApplicationHandleEvent(&event)) {
		    // $B8=:_$N%U%)!<%`$G%$%Y%s%H%O%s%I%i$H$7$F@_Dj$5$l$F$$$k4X?t(B
		    // $B$r8F$S=P$9(B ($B$3$NNc$G$O(B MainFormHandleEvent $B$,8F$P$l$k(B)
		    FrmDispatchEvent(&event);
	      }
	   }
	}
    } while (event.eType != appStopEvent); // $B=*N;$N%$%Y%s%H$,Mh$k$^$G7+$jJV$9(B
}


/*
 * StopApplication -- $B%"%W%j%1!<%7%g%s$N=*N;;~$N=hM}$r9T$J$&(B
 * 
 * $B3+$$$F$$$k%U%)!<%`$K(B frmSave $B$rAw$j(B, $B$=$l$i$N%U%)!<%`$rJD$8$k(B
 */
static void StopApplication(void)
{
    FrmSaveAllForms();
    FrmCloseAllForms();
}

/*
 * PilotMain -- $B$3$N%"%W%j%1!<%7%g%s$N%a%$%s4X?t$G$"$k(B
 * 
 * $B$3$N%5%s%W%k$G$ODL>o$N5/F0J}K!(B (sysAppLaunchCmdNormalLaunch) $B$G$N$_F0:n$9$k(B
 */
UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
    Err error = errNone;

    switch (cmd) {
    case sysAppLaunchCmdNormalLaunch:
	error = StartApplication();
	EventLoop();
	StopApplication();
	break;
    }

    return error;
}
