/*
 * KeyNotificationMain.c
 *
 * main file for KeyNotificationTest
 *
 * This wizard-generated code is based on code adapted from the
 * stationery files distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1999-2000 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
#include <PalmOS.h>

#include "KeyNotification.h"
#include "KeyNotificationRsc.h"

/*********************************************************************
 * Entry Points
 *********************************************************************/

/*********************************************************************
 * Global variables
 *********************************************************************/

/* g_prefs
 * cache for application preferences during program execution */
KeyNotificationPreferenceType g_prefs;

/* sonyHiResRefNum
 * reference number of Sony Hi-Res Library */
UInt16 sonyHiResRefNum = sysInvalidRefNum;

/*********************************************************************
 * Internal Constants
 *********************************************************************/

/* Define the minimum OS version we support */
#define ourMinVersion    sysMakeROMVersion(3,0,0,sysROMStageDevelopment,0)
#define kPalmOS20Version sysMakeROMVersion(2,0,0,sysROMStageDevelopment,0)

#define APP_CREATOR 'O5S1'
#define FTR_NUM_HACK_INSTALLED 0
/*********************************************************************
 * Internal Functions
 *********************************************************************/

/*
 * FUNCTION: GetObjectPtr
 *
 * DESCRIPTION:
 *
 * This routine returns a pointer to an object in the current form.
 *
 * PARAMETERS:
 *
 * formId
 *     id of the form to display
 *
 * RETURNED:
 *     address of object as a void pointer
 */

static void * GetObjectPtr(UInt16 objectID)
{
    FormType * frmP;

    frmP = FrmGetActiveForm();
    return FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID));
}

static Boolean
IsOS5(void)
{
	UInt32 romVersion;

	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	return (romVersion >= 0x05000000 );
}

// Hack̖{́Bpӂꂽ_CAO\B
static void
KeyboardHack(void)
{
	LocalID dbID;
	DmOpenRef db;

	dbID = DmFindDatabase( 0,"OS5Sample3");
	db = DmOpenDatabase( 0, dbID, dmModeReadOnly);

	FrmAlert( KeyboardReplacementAlert);
	
	DmCloseDatabase( db );
}


static void
KeyboardHackEntry(KeyboardType kbd)
{
// Hack{̂Ăяo
	KeyboardHack();

// ͕WPalmOS֐̋@\uĂ邪A
// TrapPalmOS֐̏𑱂ꍇAȉ̂悤ɂB
//	{
//		static void (*p)(KeyboardType kbd);
//		FtrGet( APP_CREATOR, 1000, (UInt32 *)&p); // TrapZbgɋL^X̃AhX擾	
//		(*p)(kbd); // XPalmOS֐Ăяo
//  }
	return;
}

static Boolean
KeyboardNotifyHandler(SysNotifyParamType *notify)
{
	DmOpenRef db;
	LocalID dbID;

// ɑHackςȂ牽ȂB
	if  (notify->handled == true)
		goto EXIT;

// Hack{̂ĂяoB	
	KeyboardHack();

// σtO𗧂Ă邱ƂŎۂ̃L[{[hN̂h
	notify->handled = true;

EXIT:
	return 0;
}

static void
InstallHackOS5( Boolean install)
{
	UInt16 cardNo;
	LocalID dbID;

	SysCurAppDatabase (&cardNo, &dbID);

	if ( install ){
		SysNotifyRegister( cardNo, dbID, sysNotifyKeyboardDialogEvent, 0, sysNotifyNormalPriority, 0) ;
		FtrSet( APP_CREATOR, FTR_NUM_HACK_INSTALLED, 0); // Set Mark as installed
	} else {
		SysNotifyUnregister( cardNo, dbID, sysNotifyKeyboardDialogEvent , 0) ;
		FtrUnregister( APP_CREATOR, FTR_NUM_HACK_INSTALLED); // Remove mark
	}    
}


static void
InstallHackOS4( Boolean install)
{
	DmOpenRef db;
	MemHandle h;
	MemPtr p;
	UInt32 old;
	LocalID dbID;
	UInt16 cardNo;

// Ƃŏ邽߂ɎgOpenB
	SysCurAppDatabase (&cardNo, &dbID);
	db = DmOpenDatabase( cardNo , dbID, dmModeReadOnly);

	if ( install){// Hack̃CXg[
// vO{̂i[Ă郊\[XړȂ悤ɃbNB
		h = DmGetResource( 'code', 1);
		p = MemHandleLock( h);
		DmCloseDatabase( db);

// ݂PalmOS֐̃AhX擾AFeature ManagerɂL^B
		old = (UInt32)SysGetTrapAddress( sysTrapSysKeyboardDialog ); // get original trap address
		FtrSet(  APP_CREATOR, 1000, old ); // save it by feature( HackMaster rule)
// PalmOŠĂяoe[uuB
		SysSetTrapAddress( sysTrapSysKeyboardDialog , KeyboardHackEntry );

// Hack쒆ɍ폜Ȃ悤ProtectĂ
		DmDatabaseProtect(cardNo, dbID, true); // keep DB from Delete

// HackInstallς݂ł邱ƂFeatureŎB
		FtrSet( APP_CREATOR, FTR_NUM_HACK_INSTALLED, 0); // Set Mark as installed

	} else {  // Hack̃ACXg[
// Ăяoe[uɖ߂
		FtrGet(  APP_CREATOR, 1000, &old ); // Get the old pointer
		SysSetTrapAddress( sysTrapSysKeyboardDialog , (MemPtr)old ); // Reset old 
// FeatureĂB
		FtrUnregister(  APP_CREATOR, 1000 ); 

// bNĂR[h\[XAbNB
		h = DmGetResource( 'code', 1);
		MemHandleUnlock( h);
		DmCloseDatabase( db);

// ProtectB
		DmDatabaseProtect( cardNo, dbID, false); // Unprotect

// Hack Installς݂̃}[N
		FtrUnregister( APP_CREATOR, FTR_NUM_HACK_INSTALLED); // Remove mark
	}

}

static void
InstallHack( Boolean install)
{
	if ( IsOS5()){
		InstallHackOS5( install );
	} else {
		InstallHackOS4( install );
	}
}

/*
 * FUNCTION: MainFormInit
 *
 * DESCRIPTION: This routine initializes the MainForm form.
 *
 * PARAMETERS:
 *
 * frm
 *     pointer to the MainForm form.
 */

static void MainFormInit(FormType *frmP)
{
	FieldType *field;
	UInt16 fieldIndex;
	UInt32 dummy;
	
	fieldIndex = FrmGetObjectIndex(frmP, MainDescriptionField);
	field = (FieldType *)FrmGetObjectPtr(frmP, fieldIndex);
	FrmSetFocus(frmP, fieldIndex);

	if ( FtrGet( APP_CREATOR, FTR_NUM_HACK_INSTALLED ,&dummy) == errNone ){ // Already Installed
		FrmShowObject( FrmGetActiveForm(), FrmGetObjectIndex(FrmGetActiveForm(), MainOffButton)); 
		FrmHideObject( FrmGetActiveForm(), FrmGetObjectIndex(FrmGetActiveForm(), MainOnButton)); 
	} else { 
		FrmShowObject( FrmGetActiveForm(), FrmGetObjectIndex(FrmGetActiveForm(), MainOnButton)); 
		FrmHideObject( FrmGetActiveForm(), FrmGetObjectIndex(FrmGetActiveForm(), MainOffButton)); 
	}
}

/*
 * FUNCTION: MainFormDoCommand
 *
 * DESCRIPTION: This routine performs the menu command specified.
 *
 * PARAMETERS:
 *
 * command
 *     menu item id
 */

static Boolean MainFormDoCommand(UInt16 command)
{
    Boolean handled = false;
    FormType * frmP;

    switch (command)
    {
    }
    
    return handled;
}

/*
 * FUNCTION: MainFormHandleEvent
 *
 * DESCRIPTION:
 *
 * This routine is the event handler for the "MainForm" of this 
 * application.
 *
 * PARAMETERS:
 *
 * eventP
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed to
 *     FrmHandleEvent
 */

static Boolean MainFormHandleEvent(EventType * eventP)
{
    Boolean handled = false;
    FormType * frmP;

    switch (eventP->eType) 
        {
        case menuEvent:
            return MainFormDoCommand(eventP->data.menu.itemID);

        case frmOpenEvent:
            frmP = FrmGetActiveForm();
            FrmDrawForm(frmP);
            MainFormInit(frmP);
            handled = true;
            break;
            
        case frmUpdateEvent:
            /* To do any custom drawing here, first call
             * FrmDrawForm(), then do your drawing, and
             * then set handled to true. */
            break;

		case ctlSelectEvent:
			switch ( eventP->data.ctlSelect.controlID){
				case MainOnButton:
					InstallHack( true );
					MainFormInit(FrmGetActiveForm());
					handled = true;
					break;

				case MainOffButton:
					InstallHack( false );
					MainFormInit(FrmGetActiveForm());
					handled = true;
					break;
			}
			break;
						
        default:
            break;
        }
    
    return handled;
}

/*
 * FUNCTION: AppHandleEvent
 *
 * DESCRIPTION: 
 *
 * This routine loads form resources and set the event handler for
 * the form loaded.
 *
 * PARAMETERS:
 *
 * event
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed
 *     to a higher level handler.
 */

static Boolean AppHandleEvent(EventType * eventP)
{
    UInt16 formId;
    FormType * frmP;

    if (eventP->eType == frmLoadEvent)
    {
        /* Load the form resource. */
        formId = eventP->data.frmLoad.formID;
        frmP = FrmInitForm(formId);
        FrmSetActiveForm(frmP);

        /* Set the event handler for the form.  The handler of the
         * currently active form is called by FrmHandleEvent each
         * time is receives an event. */
        switch (formId)
        {
        case MainForm:
            FrmSetEventHandler(frmP, MainFormHandleEvent);
            break;

        default:
            break;

        }
        return true;
    }

    return false;
}

/*
 * FUNCTION: AppEventLoop
 *
 * DESCRIPTION: This routine is the event loop for the application.
 */

static void AppEventLoop(void)
{
    UInt16 error;
    EventType event;

    do {
        /* change timeout if you need periodic nilEvents */
        EvtGetEvent(&event, evtWaitForever);

        if (! SysHandleEvent(&event))
        {
            if (! MenuHandleEvent(0, &event, &error))
            {
                if (! AppHandleEvent(&event))
                {
                    FrmDispatchEvent(&event);
                }
            }
        }
    } while (event.eType != appStopEvent);
}

/*
 * FUNCTION: AppStart
 *
 * DESCRIPTION:  Get the current application's preferences.
 *
 * RETURNED:
 *     errNone - if nothing went wrong
 */

static Err AppStart(void)
{

    return errNone;
}

/*
 * FUNCTION: AppStop
 *
 * DESCRIPTION: Save the current state of the application.
 */

static void AppStop(void)
{
    FrmCloseAllForms();

	{
		UInt16 cardNo;
		LocalID dbID;
		SysCurAppDatabase (&cardNo, &dbID);

//		SysNotifyUnregister( cardNo, dbID, sysNotifyKeyboardDialogEvent, sysNotifyNormalPriority); 
	}
}

/* all code from here to end of file should use no global variables */
#pragma warn_a5_access on

/*
 * FUNCTION: RomVersionCompatible
 *
 * DESCRIPTION: 
 *
 * This routine checks that a ROM version is meet your minimum 
 * requirement.
 *
 * PARAMETERS:
 *
 * requiredVersion
 *     minimum rom version required
 *     (see sysFtrNumROMVersion in SystemMgr.h for format)
 *
 * launchFlags
 *     flags that indicate if the application UI is initialized
 *     These flags are one of the parameters to your app's PilotMain
 *
 * RETURNED:
 *     error code or zero if ROM version is compatible
 */

static Err RomVersionCompatible(UInt32 requiredVersion, UInt16 launchFlags)
{
    UInt32 romVersion;

    /* See if we're on in minimum required version of the ROM or later. */
    FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
    if (romVersion < requiredVersion)
    {
        if ((launchFlags & 
            (sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
            (sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
        {
            FrmAlert (RomIncompatibleAlert);

            /* Palm OS versions before 2.0 will continuously relaunch this
             * app unless we switch to another safe one. */
            if (romVersion < kPalmOS20Version)
            {
                AppLaunchWithCommand(
                    sysFileCDefaultApp, 
                    sysAppLaunchCmdNormalLaunch, NULL);
            }
        }

        return sysErrRomIncompatible;
    }

    return errNone;
}

/*
 * FUNCTION: KeyNotificationPalmMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 *
 * PARAMETERS:
 *
 * cmd
 *     word value specifying the launch code. 
 *
 * cmdPB
 *     pointer to a structure that is associated with the launch code
 *
 * launchFlags
 *     word value providing extra information about the launch
 *
 * RETURNED:
 *     Result of launch, errNone if all went OK
 */

static UInt32 KeyNotificationPalmMain(
    UInt16 cmd, 
    MemPtr cmdPBP, 
    UInt16 launchFlags)
{
    Err error;
	SysNotifyParamType *notifyP;
	
    error = RomVersionCompatible (ourMinVersion, launchFlags);
    if (error) return (error);

    switch (cmd)
    {
    case sysAppLaunchCmdNormalLaunch:
        error = AppStart();
        if (error) 
            return error;

        /* start application by opening the main form
         * and then entering the main event loop */
        FrmGotoForm(MainForm);
        AppEventLoop();
        
        AppStop();
        break;

  case  sysAppLaunchCmdNotify :
		notifyP = ( SysNotifyParamType *)cmdPBP;
		if( notifyP->	notifyType == sysNotifyKeyboardDialogEvent){
			return KeyboardNotifyHandler(notifyP);
		}
		break;


    default:
        break;
    }

    return errNone;
}

/*
 * FUNCTION: PilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 * 
 * PARAMETERS:
 *
 * cmd
 *     word value specifying the launch code. 
 *
 * cmdPB
 *     pointer to a structure that is associated with the launch code
 *
 * launchFlags
 *     word value providing extra information about the launch.
 *
 * RETURNED:
 *     Result of launch, errNone if all went OK
 */
 
UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
    return KeyNotificationPalmMain(cmd, cmdPBP, launchFlags);
}

/* turn a5 warning off to prevent it being set off by C++
 * static initializer code generation */
#pragma warn_a5_access reset
