#include <Pilot.h>			
#include "stationary2_res.h"

extern void __Startup__();
extern FieldPtr GetActivField();
extern Boolean EventLoop();
extern void InsertResult(FieldPtr);
extern void AppHandleEvent(EventPtr, int*,int*);
extern void CopyResultToClipboard();
extern Ptr GetObjectPtr( int );
extern void SetResultValue( int);
extern FieldPtr GetActiveField();

void
__Startup__()
{
	FormPtr form;
	FieldPtr field;
	Boolean result;	
	field = GetActiveField();
		
	form = FrmInitForm( DACalcForm);
	FrmDrawForm( form);
	FrmSetActiveForm( form);
	
	result = EventLoop();
	
	if ( result && ( field != 0))
		CopyResultToClipboard( field);
		
	FrmEraseForm(form);
	FrmDeleteForm(form);

	if ( result && ( field != 0))
		FldPaste( field);

	return;
}

Boolean
EventLoop()
{
	EventType ev;
	int done =0;
	int result;
	
	do {
		EvtGetEvent( &ev,0);
		if (!SysHandleEvent( &ev))
			if (!FrmHandleEvent(FrmGetActiveForm(), &ev))
			AppHandleEvent(&ev,&done,&result);
	} while (!done);
	
	return result;
}

Ptr GetObjectPtr( int id)
{
	FormPtr form;
	form = FrmGetActiveForm();
	return( FrmGetObjectPtr( form, FrmGetObjectIndex(form,id)));
}

void
AppHandleEvent(EventPtr ev, int *done,int *result)
{
	int arg1,arg2,operator,value;
	Ptr p;
	
	if (ev->eType == appStopEvent){
		*done = true;
		*result = 0;
		EvtAddEventToQueue (ev);
		return;
	} else 	if (ev->eType == ctlSelectEvent){
		switch (ev->data.ctlSelect.controlID ){
			case DACalcEqualButton:
				p = FldGetTextPtr( (FieldPtr)GetObjectPtr( DACalcArg1Field));
				arg1 = StrAToI( p);
				p = FldGetTextPtr( (FieldPtr)GetObjectPtr( DACalcArg2Field));
				arg2 = StrAToI( p);
				operator = LstGetSelection (GetObjectPtr (DACalcOperatorList));

				
				value = arg1+arg2;
				SetResultValue( value); 
				break;
			case DACalcCancelButton:
				*done = true;
				*result = 0;
				break;		
			case DACalcInsertButton:
				*done = true;
				*result = true;
				break;		
		}
	}
}

FieldPtr 
GetActiveField()
{
	Ptr p;
	FormPtr form;
	int index;
	
	form = FrmGetActiveForm();
	index = FrmGetFocus(form);

	if ( index == noFocus)
		return 0;
			
	return ( FrmGetObjectPtr( form, index));
}

void 
CopyResultToClipboard(FieldPtr field)
{
	Ptr p;
	char buf[1];
	p = FldGetTextPtr( (FieldPtr)GetObjectPtr( DACalcResultField));
	if ( p != NULL)
		ClipboardAddItem (clipboardText,p,StrLen(p));
	else 
		ClipboardAddItem (clipboardText,buf,0);	
}

void
SetResultValue( int value)
{
	char str[10];
	Handle h1,h2;
	CharPtr p;
	FieldPtr field;
	Boolean fieldEditable;
	
	StrIToA(str,value);
	h1 = MemHandleNew( StrLen( str)+1);
	p = MemHandleLock( h1);
	StrCopy( p,str);
	MemHandleUnlock(h1);
	
	field = (FieldPtr)GetObjectPtr( DACalcResultField);
	h2 = FldGetTextHandle( field);

	fieldEditable		= field->attr.editable;
	field->attr.editable	= true;
	
	FldSetTextHandle( field,h1);
	FldDrawField( field);

	field->attr.editable	= fieldEditable;
	
	if ( h2 != 0)
		MemHandleFree( h2);	
}
 
