#include "dal.h"

long __getA7(void) = { 0x200F };
void __setA7(long a7:__d0) = { 0x2E40 };
#define dStackSize 4000

#define ToLower(c)  (( ( (c)>='A') && ( (c)<='Z'))?((c)+'a'-'A'):(c))

void SyncApps(dal_pref *prefp);


// returns true when first launch
Boolean ReadPreference(DalPreferenceType *pref)
{
	UInt16 pref_size;
	Boolean first = false;
		
	pref_size = sizeof( DalPreferenceType ); 
	if ( PrefGetAppPreferences (CREATOR, 0, pref,&pref_size,true)== noPreferenceFound){
		InitializePrefs();
		pref_size = sizeof(DalPreferenceType); 
		PrefGetAppPreferences (CREATOR,0, pref,& pref_size, true );
		first = true;
	} else if (pref_size != sizeof(DalPreferenceType)) {
		InitializePrefs();
		pref_size = sizeof( DalPreferenceType); 
		PrefGetAppPreferences (CREATOR,0, pref,& pref_size,true);
	}
//	SetFeature( pref);
	if ( first)
		InstallSampleDA();
	return first;
}

void SavePreference(DalPreferenceType *pref)
{
	
	PrefSetAppPreferences( CREATOR , 0, VERSION, pref, sizeof( DalPreferenceType ), true);
//	SetFeature( pref);
}

void
InitializePrefs()
{
	DalPreferenceType p;
	
	MemSet( (MemPtr)&p, sizeof(p),0);
	
	p.isActive = true;
/*	p.menu = true;
	p.launch = false;
	p.calc = false;
	p.find = true;
*/	
	SavePreference( &p);	
}
/*
Boolean IsRunningOnPose(void)
{
	DWord temp;
	if (FtrGet ('pose', 0, &temp) == ftrErrNoSuchFeature)
	 return false;
	else
	 return true;
}
*/

UInt16 notify_receiver( SysNotifyParamType *param)
{
	MenuEraseStatus(0);
	LaunchDA();
	
	return 0;
}

UInt16 notify_receiver_direct1( SysNotifyParamType *param)
{
	DalPreferenceType prefs;
	ReadPreference ( &prefs);
	
//	SndPlaySystemSound( sndAlarm);
	MenuEraseStatus(0);
	Launch1DA( prefs.direct1);

	return 0;
}

UInt16 notify_receiver_direct2( SysNotifyParamType *param)
{
	DalPreferenceType prefs;
	ReadPreference ( &prefs);
	
//	SndPlaySystemSound( sndAlarm);
	MenuEraseStatus(0);
	Launch1DA( prefs.direct2);

	return 0;
}

int	LaunchDA(void)
{
	Boolean handled = false;
	dal_pref *prefp=0;
	char **list=0;
	ListPtr ListP=0;
	int item;
	int candidates;
	int sel;
	MemHandle h;
	MemPtr p;
	DmOpenRef db=0;
	DmOpenRef myDb=0;
	UInt16 card;
	LocalID dbID;
//	Err err;
	FormType * form=0;
	char *pos;
	char tmp[33];
//	UInt w;
//	FormPtr oldform=0;
//	WinHandle dwin,awin;
//	WinHandle save;
	EventType event;
//	RectangleType r;
	int i;
	char key;
	char keyed_names[16];
	char keyed_names_pos;
	UInt32 saveStack=0;
     	UInt32  newStack=0;
	UInt16 prefsize;
//	Boolean InsPt;
	Boolean JogJustPressed = 0;
	int total_dbs;
	Boolean OnPose = IsRunningOnPose();
	FormActiveStateType formState;
		
// Allocate and read preference
	prefp = MemPtrNew( sizeof( dal_pref));
	prefsize= sizeof( dal_pref);
	PrefGetAppPreferences(CREATOR, 1, prefp, &prefsize, false);

// Save current form
/*	oldform = FrmGetActiveForm();
	w = FrmGetActiveFormID();
	awin = WinGetActiveWindow();
	dwin = WinGetDrawWindow();


// Save and disable Insertion Point
	InsPt = InsPtEnabled();
	InsPtEnable(false);
*/

	FrmSaveActiveState( &formState);

	if ( DmFindDatabaseByName("DA Launcher", &card, &dbID) == false){
		ErrFatalDisplay( "Can't find DA Launcher Database");
	}
	myDb = DmOpenDatabase( card, dbID, dmModeReadOnly);
	
	form = FrmInitForm( LaunchForm );
	FrmSetActiveForm(form);

	list = (char **)MemPtrNew( MAX_DA * sizeof( char *));				

	total_dbs = 0;
	for ( i = 0 ; i < MemNumCards();i++){
		total_dbs += DmNumDatabases(i);
	}

	if ( prefp->total_dbs != total_dbs ){
		SyncApps( prefp);
		prefsize= sizeof( dal_pref);
		PrefSetAppPreferences( CREATOR,1,1,prefp,prefsize,false);		
	}

	candidates = prefp->total_ap;
	pos = prefp->names;

	if ( candidates == 0){
		FrmAlert( NoDAAlert);
		goto ERROR;
	}		
	
	for ( i = 0; i <candidates;i++){
		list[i ] = pos;
		pos += StrLen(pos)+1;
	}
	
//	save = WinCreateOffscreenWindow( 80,160,genericFormat, &err );
//	WinCopyRectangle( WinGetDisplayWindow(),save,  &r,0,0,scrCopy);

// Save screen.  This must be done AFTER form setting( 0.0-160.160 mode )
/*	RctSetRectangle(&r,0,0,80,160);
	save = WinSaveBits( &r , &err);
	if (err)
		save = 0;
*/
	ListP= GetObjectPtr( LaunchDAList);

	LstSetListChoices ( ListP, list, candidates);

	{
		int columns = (candidates>13)?13:candidates;
		WinHandle win;
		RectangleType rect;
		
		LstSetHeight( ListP,columns);
		LstSetSelection( ListP, 0);
		
		win=  FrmGetWindowHandle (form); 
	
		RctSetRectangle( &rect, 73, 147 - columns * 11, 85, columns* 11 + 11);
		WinSetWindowBounds( win, &rect);

	}
//	LstSetPosition ( ListP ,2,159-11*((candidates>13)?13:candidates) );

//	LstMakeItemVisible ( ListP, 0);
//	LstEraseList(ListP);
//	LstDrawList(ListP);

	FrmDrawForm( form );

	sel = -1;
	keyed_names_pos = 0;
	
	do
		{

		EvtGetEvent (&event, evtWaitForever);
		if ( (event.eType == keyDownEvent ) && ( (event.data.keyDown.chr == launchChr) || (event.data.keyDown.chr == findChr) || (event.data.keyDown.chr == calcChr) || (event.data.keyDown.chr == menuChr))){
			sel = -3;
		} else if ( (event.eType == keyDownEvent ) && ( ( event.data.keyDown.chr == pageDownChr) || ( event.data.keyDown.chr == vchrJogPageDown)  )){ // scroll down button
			LstScrollList (ListP, winDown, 12); 

			item = LstGetSelection( ListP);
			item += 12;
			if ( item >= candidates)
				item = candidates-1;
			LstSetSelection( ListP, item);

			JogJustPressed = false;
		} else if ( (event.eType == keyDownEvent ) && ( event.data.keyDown.chr == pageUpChr) || ( event.data.keyDown.chr == vchrJogPageUp)   ){ // scroll up button
			LstScrollList (ListP, winUp, 12); 

			item = LstGetSelection( ListP);
			item -= 12;
			if ( item < 0)
				item =0; 
			LstSetSelection( ListP, item);

			JogJustPressed = false;
		} else if ( (event.eType == keyDownEvent ) &&  (( event.data.keyDown.chr == 10) || (( event.data.keyDown.chr == vchrJogRelease ) && JogJustPressed ) )){ // return 
			sel = LstGetSelection( ListP);
		} else if ( (event.eType == keyDownEvent ) && ( event.data.keyDown.chr == vchrJogPress)){
			JogJustPressed= true;
		} else if ( (event.eType == keyDownEvent ) && ( event.data.keyDown.chr == 8)){ // bs 
			keyed_names_pos = 0;
			LstSetSelection( ListP, 0);
		} else if ( (event.eType == keyDownEvent ) && (( event.data.keyDown.chr == ' ')|| ( event.data.keyDown.chr == vchrJogDown)   )){ // space 
			item = LstGetSelection( ListP);
			item += 1;
			if ( item >= candidates)
				item = candidates-1;
			LstSetSelection( ListP, item);
		} else if ( (event.eType == keyDownEvent ) && ( ( event.data.keyDown.chr == vchrJogUp)   )){ // 
			item = LstGetSelection( ListP);
			item -= 1;
			if ( item < 0)
				item = 0;
			LstSetSelection( ListP, item);

		} else if ( (event.eType == keyDownEvent )&&( event.data.keyDown.chr > ' ') &&( event.data.keyDown.chr <= 'z')){ // Now search for program names
			key =  ToLower(event.data.keyDown.chr);
			if ( keyed_names_pos < 15){
				keyed_names[ keyed_names_pos++] = key;
				keyed_names[ keyed_names_pos] = 0;
			}
			
			for ( i = 0 ; i < candidates; i++){
				if ( StrNCaselessCompare( list [i],keyed_names, keyed_names_pos) == 0)
					break;
			}
			if ( i == candidates ){ // no program matches clear input
				keyed_names_pos = 0;
			} else {				
				LstSetSelection( ListP, i);
				if (( i == candidates -1)|| ( StrNCaselessCompare( list [i+1],keyed_names, keyed_names_pos) != 0)){
					event.eType = lstSelectEvent;
					event.data.lstSelect.selection = i;
					EvtAddEventToQueue( &event );
				}
			}

		 } else if ( event.eType == appStopEvent){
			EvtAddEventToQueue( &event ); // this one is handled by J-OS this is for Apps.
			sel = -2;
		} else if (! SysHandleEvent (&event)){
			if ( !FrmHandleEvent (form,&event)){
				if ( event.eType == lstSelectEvent){
//					WinDrawChars( "lstSelect received",19,50,20);
					sel = event.data.lstSelect.selection;
				} else if ( event.eType == penDownEvent){
					sel = -2;
				}
			}
		}
		
	} while (sel == -1);

	if ( sel >= 0)
		StrCopy( tmp, list[sel]);

//WinDrawChars( "Pointer 1",9,50,25);

	MemPtrFree( list);
	list = 0;
	MemPtrFree( prefp);
	prefp = 0;

//WinDrawChars( "Pointer 2",9,50,25);
	
	handled = true;

	FrmEraseForm( form );
	FrmDeleteForm( form);
	
//	SndPlaySystemSound (sndAlarm);
//	SysTaskDelay(200);	
/*
	if (save){
		WinRestoreBits( save ,0 ,0);
		save = 0;
	}
*/
	DmCloseDatabase( myDb);
	myDb = 0;
	
//WinDrawChars( "Pointer 3",9,50,25);

	FrmRestoreActiveState( &formState);

//	SndPlaySystemSound (sndAlarm);
//	SysTaskDelay(200);	

//	FrmSaveActiveState( &formState);

/*		
	if ( w != 0){
		FrmSetActiveForm(oldform);
	} 
	WinSetActiveWindow(awin);
	WinSetDrawWindow(dwin);
	InsPtEnable( false);
*/						
	if ( sel >=0 ){	
		int card;
		for ( card = 0 ; card < MemNumCards(); card++){		
			dbID = DmFindDatabase( card,tmp);
			if ( dbID)
				break;
		}

		if ( dbID == 0){ // Can't find db. it's deleted so must sync!
			prefp = MemPtrNew( sizeof( dal_pref));
			PrefGetAppPreferences(CREATOR, 1, prefp, &prefsize, false);
			SyncApps( prefp);
			PrefSetAppPreferences( CREATOR,1,1,prefp,prefsize,false);		
			MemPtrFree( prefp);
			prefp = 0;
			goto ERROR;

		}
//		DmDatabaseInfo ( card, dbID, nil, nil, nil, nil,nil, nil, nil, nil, nil, &type,nil);
		db =DmOpenDatabase( card, dbID , dmModeReadOnly);
		h = DmGet1Resource( 'code', 1000);
		p = MemHandleLock(h);

/*
		newStack = 0;

		if (!OnPose){		
// Disable stack replacing
//		    newStack = (ULong) MemPtrNew (dStackSize);

		    if (newStack ){
		    		saveStack = __getA7 ();
	   			__setA7 (newStack + dStackSize);
   		    }
		}
*/

// Call DA's Entry point
		
		((void (*)(void))p)();	

/*
// Restore former stack
		if (newStack){
		     __setA7 (saveStack);
		     MemPtrFree ((Ptr) newStack);
   	 	}
*/		
		MemHandleUnlock(h);
		DmReleaseResource( h);

		DmCloseDatabase( db);
		db = 0;
	}

ERROR:
/*
	if (w != 0){
		FrmSetActiveForm(oldform);
	}
	WinSetActiveWindow(awin);
	WinSetDrawWindow(dwin);		
	InsPtEnable(InsPt);
*/
	FrmRestoreActiveState( &formState);

EXIT:

	if ( prefp)
		MemPtrFree( prefp);
	if ( list)
		MemPtrFree(list);			
 	if ( db)
 		DmCloseDatabase( db);
 	if ( myDb)
 		DmCloseDatabase( myDb);

 	return 0;
}

void
Launch1DA(UInt32 creator)
{
	FormActiveStateType formState;
	Err err;
	UInt16 cardNo;
	LocalID dbID;
	DmSearchStateType state;
	DmOpenRef db;
	MemHandle h;
	MemPtr p;
	
	err = DmGetNextDatabaseByTypeCreator ( true, & state, 'DAcc' , creator, true, &cardNo,&dbID); 
	if  ( err)
		return;

	FrmSaveActiveState( &formState);
		 	
	db =DmOpenDatabase( cardNo, dbID , dmModeReadOnly);
	h = DmGet1Resource( 'code', 1000);
	p = MemHandleLock(h);

// Call DA's Entry point
		
	((void (*)(void))p)();	

	MemHandleUnlock(h);
	DmReleaseResource( h);

	DmCloseDatabase( db);

	FrmRestoreActiveState( &formState);

 	return ;
}


static Int16 CompFunc( void *p1,void *p2,long other)
{
	return StrCaselessCompare( (char *)p1, (char *)p2);
}

void SyncApps(dal_pref *prefp)
{
	int candidates;
	Boolean newSearch;
	DmSearchStateType stateInfo;
	LocalID acdbID;	
	UInt16	result;
	char *pos;
	UInt16 cardNo;
	char tmp[33];
	char *buf,*p;
	int i;
	
	buf = p = MemPtrNew(33* MAX_DA);
	

	newSearch = true;
	candidates = 0;
	pos = buf;
	while( candidates != MAX_DA ){
		result = DmGetNextDatabaseByTypeCreator (newSearch, &stateInfo, 'DAcc',0, false, &cardNo, &acdbID);
		newSearch = false;
		if ( result != 0)
			break;
		DmDatabaseInfo ( cardNo, acdbID, tmp, nil, nil, nil,nil, nil, nil, nil, nil, nil,nil);
		StrCopy( pos,tmp);
		pos+= 33;
		candidates++;
	}

	SysInsertionSort (buf, candidates, 33, CompFunc,0);

	pos = prefp->names;
	
	for ( i = 0 ; i <  candidates; i++){
		StrCopy( pos,p);
		pos += StrLen( pos)+1;
		p += 33;
	}

	MemPtrFree( buf);
	
	prefp->total_ap = candidates;
	prefp->total_dbs = DmNumDatabases(0);

}


//Callback for ExgDBWrite to send data with Exchange Manager
static Err WriteDBData(const void*dataP,UInt32 *sizeP,void*userDataP)
{
	Err err;
	*sizeP =ExgSend((ExgSocketPtr)userDataP,(void*)dataP,*sizeP,&err);
	return err;
}

Err SendDatabase (UInt16 cardNo,LocalID dbID,char *nameP,char *descriptionP)
{
	ExgSocketType exgSocket;
	Err err;

//Create exgSocket structure
	MemSet(&exgSocket,sizeof(exgSocket),0);
	exgSocket.description =descriptionP;
	exgSocket.name =nameP;

//Start an exchange put operation
	err =ExgPut(&exgSocket);
	if (!err){
		err =ExgDBWrite(WriteDBData,&exgSocket,NULL,dbID,cardNo);
		err =ExgDisconnect(&exgSocket,err);
	}
	return err;
}
