/* copyright by Hacker Dude-san */

#include "dal.h"

#ifndef nil
#define nil 0
#endif

/***********************************************************************
 *	Global variables
 ***********************************************************************/

DalPreferenceType dal_prefs;
application *application_list=0;
int num_applications=0;
char **application_list_ptr=0;
UInt32 application_choice;
Int16 choosing_direct_number;

char direct_da_name[2][32]; // Used to display 

MemPtr saveJogAsisstMaskPtr=0;
UInt16 jogAsisstMask[6] = { 0x0002,  0x007f};

/************************************************************************
*            Function Definition
************************************************************************/

static Int16 StartApplication (void)
{
	UInt16 **maskPP=0;

	ChangeToHiResIfAny();
	
// Set up JogAsisst Mask
	if(!FtrGet(sonySysFtrCreator, sonySysFtrNumJogAstMaskP,(UInt32 *)&maskPP)) {
		saveJogAsisstMaskPtr =*maskPP;
		*maskPP = (UInt16 *)jogAsisstMask;
	}

	return 0;		// no error
}

static void StopApplication (void)
{
	UInt16 **maskPP;

	FrmCloseAllForms ();

	if ( application_list)
		MemPtrFree( application_list);

	if ( application_list_ptr)
		MemPtrFree( application_list_ptr);

	if(!FtrGet(sonySysFtrCreator, sonySysFtrNumJogAstMaskP,(UInt32 *)&maskPP)) {
		*maskPP = saveJogAsisstMaskPtr ;
	}

			
	return;	
}

void
InstallSampleDA(void)
{
	MemHandle h;
	MemPtr p;
// Install SimpleClock DA

	h = DmGetResource('Dimg',1000);
	if ( h){
		p = MemHandleLock(h);
		DmCreateDatabaseFromImage( p );
		MemHandleUnlock( h);
		DmReleaseResource( h);
	}
}

static Boolean
AddResource( DmOpenRef db,MemHandle h, UInt32 type , UInt16 id)
{
	MemHandle new_h;
	MemPtr new_p, p;
	
	new_h = DmNewResource( db, type , id , MemHandleSize( h));
	ErrFatalDisplayIf( new_h == 0 , "Can't create bitmap resource in dummy database");

	new_p = MemHandleLock ( new_h);
	p = MemHandleLock( h);
	
	DmWrite ( new_p, 0, p, MemHandleSize(h));

	MemHandleUnlock(h);
	MemHandleUnlock( new_h);

	DmReleaseResource( new_h);
	return true;
}

static void
InstallBitmapDatabase(Boolean overRide)
{
//	UInt16 cardNo;
	LocalID dbID=0;
	LocalID dal_dbID=0;
	DmOpenRef db=0;
	DmOpenRef  dal_db=0;
	MemHandle h,new_h;
	MemPtr new_p;
	char icon_name[33];
	DalPreferenceType prefs;
	
	dbID = DmFindDatabase( 0, "DA Launcher Temp DB");
	if ( dbID){ // Already here . Let'S erase it.
		if ( overRide){
			if ( DmDeleteDatabase( 0, dbID) != errNone) // Failed in Deleting?
				return;
		} else {
			return;
		}
	}
	
	DmCreateDatabase( 0, 	"DA Launcher Temp DB", 'JDal', 'temp', true);
	dbID = DmFindDatabase( 0, "DA Launcher Temp DB");
	db = DmOpenDatabase( 0, dbID, dmModeReadWrite);

	dal_dbID = DmFindDatabase( 0, "DA Launcher");

	if ( dal_dbID == 0){
		goto EXIT;
	}

	dal_db = DmOpenDatabase( 0, dal_dbID, dmModeReadOnly);
	
// Get DA Launcher Icon
	h = DmGetResource( 'Tbmp', CommandBarIconBitmapFamily);
	ErrFatalDisplayIf( h == 0 , "Can't find Icon resource");
	AddResource(  db, h, 'Tbmp' , BITMAP_RESOURCEID_DUMMY);
	DmReleaseResource( h);

// Get Icon for direct
// We must get them for DA. and if not, add default icon. TDL!!!
	h = DmGetResource( 'Tbmp', CommandBarDirectIconBitmapFamily);
	ErrFatalDisplayIf( h == 0 , "Can't find Direct Icon resource");
	AddResource(  db, h, 'Tbmp' , BITMAP_RESOURCEID_DIRECT1);
	AddResource(  db, h, 'Tbmp' , BITMAP_RESOURCEID_DIRECT2);
	DmReleaseResource( h);

// Get String for "Launch DA"
	h = DmGetResource( 'tSTR', IconNameString );
	ErrFatalDisplayIf( h == 0 , "Can't find Launching DA string");
	AddResource(  db, h, 'tSTR' ,  LAUNCH_DA_STRING_RESOURCE_ID);
	DmReleaseResource( h);

// Get application name for Direct and store it
	ReadPreference( &prefs);
	
// For Direct1
	if ( prefs.direct1 != 0){
		CopyApplicationNameFromTypeCreator( icon_name, 'DAcc',prefs.direct1);
	} else {
		StrCopy( icon_name,"");
	}
	new_h = MemHandleNew( StrLen( icon_name)+1);
	new_p = MemHandleLock( new_h);
	StrCopy( new_p, icon_name);
	MemHandleUnlock( new_h);

	AddResource(  db, new_h, 'tSTR' ,  DIRECT1_APP_NAME_RESOURCE_ID );

	MemHandleFree( new_h);
	
// For Direct2
	if ( prefs.direct2 != 0){
		CopyApplicationNameFromTypeCreator( icon_name, 'DAcc',prefs.direct2);
	} else {
		StrCopy( icon_name,"");
	}

	new_h = MemHandleNew( StrLen( icon_name)+1);
	new_p = MemHandleLock( new_h);
	StrCopy( new_p, icon_name);
	MemHandleUnlock( new_h);

	AddResource(  db, new_h, 'tSTR' ,  DIRECT2_APP_NAME_RESOURCE_ID );

	MemHandleFree( new_h);

EXIT:
	if (db)
		DmCloseDatabase( db);
	if( dal_db)
		DmCloseDatabase( dal_db);	
}

static void
DeleteBitmapDatabase(void)
{
	LocalID dbID;
	
	dbID = DmFindDatabase( 0, "DA Launcher Temp DB");
	if ( dbID){ // Already here . Let'S erase it.
		DmDeleteDatabase( 0, dbID);
	}

	return; 	
}

static DmOpenRef
OpenImageDB(void)
{
	DmOpenRef db;
	LocalID dbID;
// Open Databse contains DA Launcher icon.
//	InstallBitmapDatabase( false );

	dbID = DmFindDatabase( 0, "DA Launcher Temp DB");
	if ( dbID != 0){
		db = DmOpenDatabase ( 0, dbID, dmModeReadOnly | dmModeLeaveOpen );

// To Show it's registered
		FtrSet( AppCreator, FEATURE_NUM_ICON_DB,  (UInt32)db );
	}
	
	return db;
}

static void
CloseImageDB(void)
{
	DmOpenRef db;
	
	if ( FtrGet( AppCreator, FEATURE_NUM_ICON_DB,  (UInt32 *)&db ) == 0)
		DmCloseDatabase( db);

	FtrUnregister( AppCreator, FEATURE_NUM_ICON_DB);
}


// Handler for Notification( CmdBarOpen)
static UInt16
CommandBarNotifyHandler(	SysNotifyParamType *notifyP)
{
	Err err;
	char icon_name[32];
//	DmOpenRef dal_db;
//	LocalID dal_dbID;
//	DalPreferenceType prefs;
//	DmOpenRef image_db;

// Open the dummy database with DA Launcher icon
// So that MenuCommand bar can be drawn with it.
// This database is closeed automatically in next application switch
/*
	image_db = OpenImageDB();	

	ReadPreference( &prefs);
	
	if ( prefs.direct1 != 0){
		CopyApplicationNameFromTypeCreator( icon_name, 'DAcc',prefs.direct1);
		err  = MenuCmdBarAddButton ( menuCmdBarOnRight, BITMAP_RESOURCEID_DIRECT ,  menuCmdBarResultNotify , DA_LAUNCHER_DIRECT1_NOTIFY , icon_name);
	}	
	if ( prefs.direct2 != 0){
		CopyApplicationNameFromTypeCreator( icon_name, 'DAcc',prefs.direct2);
		err  = MenuCmdBarAddButton ( menuCmdBarOnRight, BITMAP_RESOURCEID_DIRECT ,  menuCmdBarResultNotify , DA_LAUNCHER_DIRECT2_NOTIFY , icon_name);
	}	
*/
// Get application name for Direct1
	SysCopyStringResource ( icon_name, DIRECT1_APP_NAME_RESOURCE_ID );
	if ( StrLen( icon_name) != 0)
		err  = MenuCmdBarAddButton ( menuCmdBarOnRight, BITMAP_RESOURCEID_DIRECT1 ,  menuCmdBarResultNotify , DA_LAUNCHER_DIRECT1_NOTIFY , icon_name);

// Get application name for Direct2
	SysCopyStringResource ( icon_name, DIRECT2_APP_NAME_RESOURCE_ID );
	if ( StrLen( icon_name) != 0)
		err  = MenuCmdBarAddButton ( menuCmdBarOnRight, BITMAP_RESOURCEID_DIRECT2,  menuCmdBarResultNotify , DA_LAUNCHER_DIRECT2_NOTIFY , icon_name);

// Get "Launch DA" string
	SysCopyStringResource ( icon_name, LAUNCH_DA_STRING_RESOURCE_ID);
	err  = MenuCmdBarAddButton ( menuCmdBarOnRight, BITMAP_RESOURCEID_DUMMY ,  menuCmdBarResultNotify , DA_LAUNCHER_NOTIFY , icon_name);

// Set the alarl to close ImageDB
/*
	dal_dbID = DmFindDatabase( 0, "DA Launcher");
	if (dal_dbID){
		 AlmSetAlarm (0, dal_dbID, (UInt32)image_db, TimGetSeconds()+2,  true);
	}
*/	
	return 0; 
}

static void
ProtectDatabase( Boolean protect)
{
	UInt16 cardNo;
	LocalID dbID;
	MemHandle h;

// We protect DA Launcher even if it's Launch Command based. Because if DA Launcher is deleted, Temp DB won't be erased.
#ifdef USE_LAUNCH_COMMAND_FOR_NOTIFY
//	return;
#endif

// Get code resource and lock it
	h = DmGetResource ( 'code', 1);
	if (h){
		if ( protect)
			MemHandleLock( h);
		else
			MemHandleUnlock(h);
	}
	
	SysCurAppDatabase (&cardNo, &dbID);
	DmDatabaseProtect( cardNo, dbID, protect);
}

static void
RegisterNotification()
{
	UInt16 cardNo;
	LocalID dbID;
	UInt32 dummy;

	if ( FtrGet( AppCreator, FEATURE_NUM_NOTIFY_REGISTERED, &dummy ) != ftrErrNoSuchFeature )
		return;
		
	SysCurAppDatabase (&cardNo, &dbID);

#ifdef USE_LAUNCH_COMMAND_FOR_NOTIFY
	SysNotifyRegister( cardNo, dbID, sysNotifyMenuCmdBarOpenEvent, 0,  sysNotifyNormalPriority, 0) ;
	SysNotifyRegister( cardNo, dbID, DA_LAUNCHER_NOTIFY , 0, sysNotifyNormalPriority, 0) ;
	SysNotifyRegister( cardNo, dbID, DA_LAUNCHER_DIRECT1_NOTIFY , 0, sysNotifyNormalPriority, 0) ;
	SysNotifyRegister( cardNo, dbID, DA_LAUNCHER_DIRECT2_NOTIFY , 0, sysNotifyNormalPriority, 0) ;
#else
	SysNotifyRegister( cardNo, dbID, sysNotifyMenuCmdBarOpenEvent,CommandBarNotifyHandler,  sysNotifyNormalPriority, 0) ;
	SysNotifyRegister( cardNo, dbID, DA_LAUNCHER_NOTIFY ,notify_receiver, sysNotifyNormalPriority, 0) ;
	SysNotifyRegister( cardNo, dbID, DA_LAUNCHER_DIRECT1_NOTIFY ,notify_receiver_direct1, sysNotifyNormalPriority, 0) ;
	SysNotifyRegister( cardNo, dbID, DA_LAUNCHER_DIRECT2_NOTIFY ,notify_receiver_direct2, sysNotifyNormalPriority, 0) ;
#endif

// To show notification is registered
	FtrSet( AppCreator, FEATURE_NUM_NOTIFY_REGISTERED, 0 );
}

static void
UnregisterNotification()
{
	UInt16 cardNo;
	LocalID dbID;
//	DmOpenRef db;
	
//	SndPlaySystemSound( sndAlarm); 
	SysCurAppDatabase (&cardNo, &dbID);

	SysNotifyUnregister( cardNo, dbID, sysNotifyMenuCmdBarOpenEvent,0) ;
	SysNotifyUnregister( cardNo, dbID, DA_LAUNCHER_NOTIFY ,0) ;
	SysNotifyUnregister( cardNo, dbID, DA_LAUNCHER_DIRECT1_NOTIFY , 0) ;
	SysNotifyUnregister( cardNo, dbID, DA_LAUNCHER_DIRECT2_NOTIFY , 0) ;
	
// To Show it's not registered
	FtrUnregister( AppCreator, FEATURE_NUM_NOTIFY_REGISTERED);
}


static Int16 SortCompFunc( void *p1,void *p2,long other)
{
	return StrCaselessCompare( (char *)p1, (char *)p2);
}

static int
MakeAppList(application **app)
{
	int candidates;
	Boolean newSearch;
	DmSearchStateType stateInfo;
	LocalID acdbID;	
	UInt16	result;
	char * pos;
	UInt16 cardNo;
	char tmp[33];
	char *buf,*p;
//	int i;
//	application	app;
	UInt32	creator;
	
	if ( *app ) // if already allocated
		return 0;
	
	buf = p = MemPtrNew(sizeof ( application )* MAX_DA);

	newSearch = true;
	candidates = 0;
	pos = buf;
	while( candidates != MAX_DA ){
		result = DmGetNextDatabaseByTypeCreator (newSearch, &stateInfo, 'DAcc',0, true, &cardNo, &acdbID);
		newSearch = false;
		if ( result != 0)
			break;
		DmDatabaseInfo ( cardNo, acdbID, nil, nil, nil, nil,nil, nil, nil, nil, nil, nil, &creator);
		CopyApplicationNameFromTypeCreator( tmp, 'DAcc',creator);
		StrCopy( pos,tmp);
		pos+= sizeof( application) - sizeof(UInt32);
		MemMove( pos ,(char *)&creator,4);
		pos += sizeof (UInt32);
		candidates++;
	}
	
	SysInsertionSort (buf, candidates, sizeof(application), SortCompFunc,0);

	*app = MemPtrNew( sizeof(application)*candidates+1);
	MemMove( *app, buf, sizeof(application)*candidates);
	MemPtrFree( buf);
	return candidates;
}

static void DaListFormInit(FormPtr /*frmP*/)
{
	int i;
	
	if ( ( num_applications == 0) || ( application_list == 0) )
		num_applications = MakeAppList( &application_list);

	application_list_ptr = MemPtrNew( sizeof( MemPtr) * num_applications);

	for ( i = 0; i < num_applications;i++){
		application_list_ptr[i] = application_list[i].name;
	}
	
	LstSetListChoices( GetObjectPtr( DaListApplicationList), application_list_ptr , num_applications);
}

static void
DaListFormClose()
{
	if ( application_list_ptr){
		MemPtrFree( application_list_ptr);
		application_list_ptr = 0;
	}

	if ( application_list){
		MemPtrFree( application_list);
		application_list = 0;
		num_applications = 0;
	}
	
}



static Boolean DaListFormHandleEvent(EventPtr eventP)
{
   Boolean handled = false;
   FormPtr frmP;
//   EventType ev;
   ListType *listP = GetObjectPtr( DaListApplicationList);
   Int16 sel= LstGetSelection( listP );

	switch (eventP->eType) 
		{
		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			DaListFormInit( frmP);
			FrmDrawForm ( frmP);
			if ( num_applications == 0){
				FrmAlert( NoDAAlert) ;
				FrmGotoForm( PreferenceForm );
			}
			handled = true;
			break;

		case frmCloseEvent:
			DaListFormClose();
			break;
				
		case ctlSelectEvent:
			switch ( eventP->data.ctlSelect.controlID){
				case DaListOkButton:
					DaListFormClose();
					FrmGotoForm( PreferenceForm );
					handled = true;
					break;			

				case DaListRunButton:
					if ( (sel != -1 ) && ( sel != 255)){
						Launch1DA( application_list[sel].creator);
					} else {
						FrmAlert( ChooseItemAlert);
					}
					handled = true;
					break;

				case DaListBeamButton:
					if ( (sel != -1 ) && ( sel != 255)){
						UInt16 cardNo;
						LocalID dbID;
						DmSearchStateType state;
						Err err;
						char buf[35];						
						err = DmGetNextDatabaseByTypeCreator ( true, & state, 'DAcc' , application_list[sel].creator, true, &cardNo,&dbID); 
						if ( err )
							break;

						StrCopy( buf, application_list[sel].name );
						StrCat( buf, ".prc");
						 SendDatabase (cardNo,dbID,buf, application_list[sel].name);
					} else {
						FrmAlert( ChooseItemAlert);
					}
					handled = true;
					break;

					
				case DaListDeleteButton:
					if ( (sel != -1 ) && ( sel != 255)){
						if ( FrmCustomAlert ( DeleteConfirmAlert ,  application_list[sel].name ,"","") == 0){
							UInt16 cardNo;
							LocalID dbID;
							DmSearchStateType state;
							Err err;
							
							err = DmGetNextDatabaseByTypeCreator ( true, & state, 'DAcc' , application_list[sel].creator, true, &cardNo,&dbID); 
							if ( err )
								break;
							
							err = DmDeleteDatabase( cardNo, dbID );
							if (err){
								FrmCustomAlert( CantDeleteAlert, application_list[sel].name ,"","" );
								break;
							}
							
	// Go to this form again to refresh DA list
							DaListFormClose();
							FrmGotoForm( DaListForm);	
						}
					} else {
						FrmAlert( ChooseItemAlert);
					}
					handled = true;
					break;
	
			}
			break;

		case keyDownEvent:
			switch ( eventP->data.keyDown.chr){
			case vchrPageUp:
//			case vchrJogPageUp:
				LstScrollList( listP , winUp , LstGetVisibleItems ( listP) - 1);
				handled = true;
				break;

			case vchrPageDown:
//			case vchrJogPageDown:
				LstScrollList( listP , winDown , LstGetVisibleItems (listP) - 1);
				handled = true;
				break;

			case vchrJogUp:
				if ( sel == -1 || sel == 255 ){
					sel = 0;
				} else {
					if ( sel != 0)
						sel--;
				}
				LstSetSelection( listP , sel);
				handled = true;
				break;

			case vchrJogDown:
				if ( sel == -1 || sel == 255 ){
					sel = 0;
				} else {
					if ( sel != LstGetNumberOfItems(listP) - 1)
						sel++;
				}
				LstSetSelection( listP , sel);
				handled = true;
				break;

			case vchrJogRelease:
				CtlHitControl ( GetObjectPtr( DaListOkButton)  );
				handled = true;
				break;				
			}
			break;


		default:
			break;
		
		}
	
	return handled;
}

static void ChooseApFormInit(FormPtr /*frmP*/)
{
	int i;
	
	if ( ( num_applications == 0) || ( application_list == 0) )
		num_applications = MakeAppList( &application_list);

	application_list_ptr = MemPtrNew( sizeof( MemPtr) * num_applications);

	for ( i = 0; i < num_applications;i++){
		application_list_ptr[i] = application_list[i].name;
	}
	
	LstSetListChoices( GetObjectPtr( ChooseApApplicationList), application_list_ptr , num_applications);
}

static void
ChooseApFormClose()
{
	if ( application_list_ptr){
		MemPtrFree( application_list_ptr);
		application_list_ptr = 0;
	}
}



static Boolean ChooseApFormHandleEvent(EventPtr eventP)
{
   Boolean handled = false;
   FormPtr frmP;
   EventType ev;

	switch (eventP->eType) 
		{
		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			ChooseApFormInit( frmP);
			FrmDrawForm ( frmP);
			if ( num_applications == 0){
				FrmAlert( NoDAAlert) ;
				application_choice = 0 ; // No App is choosen
				FrmReturnToForm( 0 );
				ev.eType = AppChoosenEvent;
				EvtAddEventToQueue( &ev);
			}
			handled = true;
			break;

		case frmCloseEvent:
			ChooseApFormClose();
			break;
				
		case ctlSelectEvent:
			switch ( eventP->data.ctlSelect.controlID){
				case ChooseApOkButton:
					{
						Int16 sel= LstGetSelection( GetObjectPtr( ChooseApApplicationList));
						if ( sel == -1 || sel == 255){
							application_choice = 0;
						} else {
							application_choice = application_list[sel].creator;
						}
					}
					FrmReturnToForm( 0 );
					ev.eType = AppChoosenEvent;
					EvtAddEventToQueue( &ev);
					handled = true;
					break;

				case ChooseApNoAppButton:
					application_choice = 0 ; // No App is choosen
					ev.eType = AppChoosenEvent;
					EvtAddEventToQueue( &ev);
					FrmReturnToForm( 0 );
					handled = true;
					break;

				case ChooseApCancelButton: // Return with do nothing
					ChooseApFormClose();
					FrmReturnToForm( 0);
					handled = true;
					break;
			
			}
			break;

		case keyDownEvent:
			switch ( eventP->data.keyDown.chr){
			case vchrPageUp:
//			case vchrJogPageUp:
				LstScrollList( GetObjectPtr(ChooseApApplicationList) , winUp , LstGetVisibleItems (GetObjectPtr(ChooseApApplicationList)) - 1);
				handled = true;
				break;

			case vchrPageDown:
//			case vchrJogPageDown:
				LstScrollList( GetObjectPtr(ChooseApApplicationList) , winDown , LstGetVisibleItems (GetObjectPtr(ChooseApApplicationList)) - 1);
				handled = true;
				break;

			case vchrJogUp:
				{
					int sel;
					sel = LstGetSelection( GetObjectPtr(ChooseApApplicationList));
					if ( sel == -1 || sel == 255 ){
						sel = 0;
					} else {
						if ( sel != 0)
							sel--;
					}
					LstSetSelection( GetObjectPtr(ChooseApApplicationList) , sel);
					handled = true;
				}
				break;

			case vchrJogDown:
				{
					int sel;
					sel = LstGetSelection( GetObjectPtr(ChooseApApplicationList));
					if ( sel == -1 || sel == 255 ){
						sel = 0;
					} else {
						if ( sel != LstGetNumberOfItems(GetObjectPtr( ChooseApApplicationList)) - 1)
							sel++;
					}
					LstSetSelection( GetObjectPtr(ChooseApApplicationList) , sel);
					handled = true;
				}
				break;

			case vchrJogRelease:
				{
					int sel;
					sel = LstGetSelection( GetObjectPtr(ChooseApApplicationList));
					if ( ( sel != -1) && (sel != 255)){
						application_choice = application_list[sel].creator;
						FrmReturnToForm( 0 );
						ev.eType = AppChoosenEvent;
						EvtAddEventToQueue( &ev);
					}
					handled = true;
				}
				break;				
			}
			break;
			
		default:
			break;
		
		}
	
	return handled;
}

static void PreferenceSetDirectDAName(void)
{
	DalPreferenceType prefs;
	ReadPreference(&prefs);

	if ( prefs.direct1 == 0){
		SysCopyStringResource ( direct_da_name[0], UnsetString);
	} else {
		CopyApplicationNameFromTypeCreator( direct_da_name[0],  'DAcc', prefs.direct1 );
	}

	CtlSetLabel( GetObjectPtr( PreferenceDirect1SelTrigger) , direct_da_name[0] );

	if ( prefs.direct2 == 0){
		SysCopyStringResource ( direct_da_name[1], UnsetString);
	} else {
		CopyApplicationNameFromTypeCreator( direct_da_name[1],  'DAcc', prefs.direct2 );
	}

	CtlSetLabel( GetObjectPtr( PreferenceDirect2SelTrigger) , direct_da_name[1] );
	

}
static void PreferenceFormInit (FormPtr formP)
{
	DalPreferenceType prefs;
	UInt32 temp;
	
	ReadPreference(&prefs);

	if ( prefs.isActive && (FtrGet( AppCreator, FEATURE_NUM_NOTIFY_REGISTERED, &temp ) == errNone) ){
		FrmSetControlGroupSelection(formP, 1, PreferenceActivePushButton);
	} else {
		FrmSetControlGroupSelection(formP, 1, PreferenceStoppedPushButton);
		prefs.isActive= false;
		SavePreference( &prefs);
	}
	
	PreferenceSetDirectDAName();
}
	
static void PreferenceFormSavePref()
{
	FormPtr frm;
	UInt8 sel;
	Int16 ctl;
	DalPreferenceType prefs;
	
	ReadPreference(&prefs);

	frm = FrmGetActiveForm ();

	sel = FrmGetControlGroupSelection(frm, 1);				
	ctl = FrmGetObjectId (frm, sel);

	switch ( ctl ){
		case  PreferenceActivePushButton:
			prefs.isActive = true;
			break;
		case PreferenceStoppedPushButton:
			prefs.isActive = false;
			break;
	}

	SavePreference( &prefs);
	
}



static Boolean PreferenceFormHandleEvent (EventPtr event)
{
	FormPtr 			formP=FrmGetActiveForm();
	Boolean 			handled = false;
//	UInt	 			currentAppCardNo;
//	LocalID			currentAppDBID;
//	EventType		newEvent;
//	int result;
	
	if (event->eType == nilEvent){
		return true;				// handled
	}else if (event->eType == menuEvent){
		if ( event->data.menu.itemID == OptionInstallSampleDA  ){
			InstallSampleDA();
			
// Invalid DA List
			if ( application_list){
				MemPtrFree( application_list);
				application_list = 0;
				num_applications = 0;
			}

			FrmAlert( DAInstalledAlert);			
		}
	}else if (event->eType == ctlSelectEvent){
		DalPreferenceType prefs;
	
		ReadPreference(&prefs);

		if ( (event->data.ctlSelect.controlID ==  PreferenceActivePushButton) && ( prefs.isActive == false)){
/*			result = FrmAlert( NeedResetAlert );	
			if ( result == 0){
				SysReset();
			} else { // Canceled
				FrmSetControlGroupSelection ( formP, 1, PreferenceStoppedPushButton);
				save_pref(); // save setting
			}	
*/
			RegisterNotification();
			ProtectDatabase(true ); // To ensure code resource is here.(don't move or deleted)
			CloseImageDB();// Close the DB ( in case if it's open)
			InstallBitmapDatabase(true);
			OpenImageDB();
			PreferenceFormSavePref(); // save setting
		} else if  (( event->data.ctlSelect.controlID ==  PreferenceStoppedPushButton) && ( prefs.isActive == true)) {
			UnregisterNotification();
			ProtectDatabase(false);
			CloseImageDB();
			DeleteBitmapDatabase();
			PreferenceFormSavePref(); // save setting
		} else if ( event->data.ctlSelect.controlID ==  PreferenceDAListButton) {
			FrmGotoForm( DaListForm);
			handled = true;
		} else if ( event->data.ctlSelect.controlID ==  PreferenceAboutButton) {
			FrmAlert( AboutAlert );
			handled = true;
		} else if ( event->data.ctlSelect.controlID ==  PreferenceActiveHelpButton) {
			FrmAlert( ActiveHelpAlert);
			handled = true;
		} else if ( event->data.ctlSelect.controlID ==  PreferenceDirectHelpButton) {
			FrmAlert( DirectHelpAlert);
			handled = true;
		} else if ( event->data.ctlSelect.controlID ==  PreferenceDirect1SelTrigger) {
			choosing_direct_number = 1;
			FrmPopupForm( ChooseApForm);
			handled = true;
		} else if ( event->data.ctlSelect.controlID ==  PreferenceDirect2SelTrigger) {
			choosing_direct_number = 2;
			FrmPopupForm( ChooseApForm);
			handled = true;
		}
		
		
	} else if (event->eType == frmOpenEvent){
		formP = FrmGetActiveForm ();
		PreferenceFormInit (formP);
		FrmDrawForm (formP);

		handled = true;
	} else if ( event->eType == AppChoosenEvent) {
		DalPreferenceType prefs;
		
		ReadPreference(&prefs);

		if (choosing_direct_number == 1){
			prefs.direct1 = application_choice;
		} else {
			prefs.direct2 =application_choice;		
		}
		
		SavePreference( &prefs);
		PreferenceSetDirectDAName(); // Refresh Screen
// Update Bitmap Database( so as to update direct DAs)
		CloseImageDB(); // We must close it if it's opened . To update it .
		InstallBitmapDatabase(true);
		if ( prefs.isActive )
			OpenImageDB();
	}
	
	return (handled);
}

	
static Boolean ApplicationHandleEvent (EventPtr event)
{
	FormPtr formP;
	UInt16 formId;

	if (event->eType == frmLoadEvent)
		{
		// Load the form resource.
		formId = event->data.frmLoad.formID;
		formP = FrmInitForm (formId);
		FrmSetActiveForm (formP);		
		
		switch (formId)
			{
			case PreferenceForm:
				FrmSetEventHandler (formP, PreferenceFormHandleEvent);
				break;
			case ChooseApForm:
				FrmSetEventHandler (formP, ChooseApFormHandleEvent);
				break;
			case DaListForm:
				FrmSetEventHandler (formP, DaListFormHandleEvent);
				break;
			}
		return (true);
		}
		
	return (false);
}


static void EventLoop (void)
{
	EventType event;
	Err error;
	
	do
		{
		EvtGetEvent (&event, 0);

		if (! SysHandleEvent (&event))
			if (! MenuHandleEvent (0, &event, &error))
				if (! ApplicationHandleEvent (&event))
					FrmDispatchEvent (&event);
		}
		while (event.eType != appStopEvent);

}


UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	Err error;
	DalPreferenceType prefs;
//	DWord temp;
	SysNotifyParamType *notifyP;
	MachineFunctionType func;
	LocalID dal_dbID;	

	if ( (cmd == sysAppLaunchCmdSystemReset) || (cmd == sysAppLaunchCmdSyncNotify ) ){
		ReadPreference(&prefs);
			
		GetMachineFunctionality( &func);

		if ( ( prefs.isActive ) && ( func.osVersion >= 0x0350 ) ){ // IF DALauncher is enabled
			RegisterNotification();
			ProtectDatabase(true); // To ensure code resource is here.(don't move or deleted)
			InstallBitmapDatabase(true);
			dal_dbID = DmFindDatabase( 0, "DA Launcher");
			if (dal_dbID){
				 AlmSetAlarm (0, dal_dbID, (UInt32)0, TimGetSeconds()+2,  true);
			}

		}

		return 0;
	} else if ( cmd == sysAppLaunchCmdNotify){
//		WinDrawChars("Notify Received",15,0,0);
		notifyP = ( SysNotifyParamType *)cmdPBP;
		if( notifyP->	notifyType == sysNotifyMenuCmdBarOpenEvent){
			CommandBarNotifyHandler(notifyP);
		} else if( ( notifyP->notifyType == DA_LAUNCHER_NOTIFY )  ){
			MenuEraseStatus(0);
			notify_receiver(notifyP);
		} else if( ( notifyP->notifyType == DA_LAUNCHER_DIRECT1_NOTIFY)  ){
			MenuEraseStatus(0);
			notify_receiver_direct1( notifyP);
		} else if( ( notifyP->notifyType == DA_LAUNCHER_DIRECT2_NOTIFY)  ){
			MenuEraseStatus(0);
			notify_receiver_direct2( notifyP);
		}
	} else if (cmd == sysAppLaunchCmdNormalLaunch ){
		UInt32 dummy;
		
		GetMachineFunctionality( &func);
		ReadPreference(&prefs);
			
		if ( ( prefs.isActive ) && ( func.osVersion >= 0x0350 ) ){ // IF DALauncher is enabled. But it's not registered( In case it's copied to internal by Illegal File Mover( Don't send SyncNotify)
			if ( FtrGet( AppCreator, FEATURE_NUM_NOTIFY_REGISTERED, &dummy ) == ftrErrNoSuchFeature ){
				prefs.isActive = false;
				SavePreference( &prefs);
			}
		}

		if ( !( func.osVersion >= 0x0350) ){
			FrmAlert( DANotSupportedAlert);
		} else{
			error = StartApplication ();
			FrmGotoForm (PreferenceForm);
			if (! error)
				EventLoop ();
			StopApplication ();
		}
	} else if ( cmd == sysAppLaunchCmdAlarmTriggered ){
//		WinDrawChars(" Alarm Triggered",15,0,0);		
//		SndPlaySystemSound( sndAlarm);
//		DmCloseDatabase( (DmOpenRef )( ( (SysDisplayAlarmParamType* )cmdPBP)->ref) );
		OpenImageDB();
	}
	return 0;
}

 