//*****************************************************************************
//* Copyright (c) 2002-2004 Miday Workshop All rights reserved.
//*
//* File: Common.c
//*****************************************************************************

//general Palm OS includes
#include <PalmOS.h>
#include <TxtGlue.h>
#include <SonyCLIE.h>

//private includes
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//--------------------------------------------------------
//@tB[`̈悩荞
//  It inputs from feature.
//--------------------------------------------------------
void GetPreferences(){
	DateTimeType dateTime;
	unsigned short optsize;
	short ix;

	TimSecondsToDateTime (TimGetSeconds (), &dateTime);
	optsize = sizeof(OPTIONS3);
	if( (PrefGetAppPreferences (Df_CreaID, 2, &Opt3, &optsize, true) == noPreferenceFound) 
		 || ( optsize < sizeof(OPTIONS3))){//o[WR̃tB[`͖  (There is no feature of a version 3.)

		optsize = sizeof(OPTIONS2);
		if( (PrefGetAppPreferences (Df_CreaID, 1, &Opt2, &optsize, true) == noPreferenceFound) 
			 || ( optsize < sizeof(OPTIONS2))){//o[WQ̃tB[`  (There is also no feature of a version 2.)
			Opt3.version              = 3;
			Opt3.hol_count_flag       = 1;
			Opt3.st_year              = dateTime.year;
			Opt3.st_month             = 1;
			Opt3.en_year              = dateTime.year;
			Opt3.en_month             = 12;
			if ( Opt3.st_year < Start_year )   Opt3.st_year = Start_year;
			if ( Opt3.st_year > Start_year+9 ) Opt3.st_year = Start_year+9;
			if ( Opt3.en_year < Start_year )   Opt3.en_year = Start_year;
			if ( Opt3.en_year > Start_year+9 ) Opt3.en_year = Start_year+9;

			for ( ix=0; ix<MAX_MEMORIAL_DEFNO; ix++ ) {
				Opt3.memorial_flag[ix] = 0;Opt3.memorial_col1[ix] = 0;Opt3.memorial_col2[ix] = 0;
				Opt3.memorial_year[ix] = dateTime.year;Opt3.memorial_month[ix] = 1;Opt3.memorial_day[ix] = 1;
				if ( Opt3.memorial_year[ix] < Start_year )   Opt3.memorial_year[ix] = Start_year;
				if ( Opt3.memorial_year[ix] > Start_year+9 ) Opt3.memorial_year[ix] = Start_year+9;
			}

			Opt3.week_color[0] = 1;Opt3.week_color[1] = 0;Opt3.week_color[2] = 0;Opt3.week_color[3] = 0;
			Opt3.week_color[4] = 0;Opt3.week_color[5] = 0;Opt3.week_color[6] = 1;
			Opt3.hol_color = 1;
			Opt3.data_ver  = 3;
			Opt3.beam_opt  = 0;
			Opt3.beam_flag = 0x03;
		} else {//o[WQ̃tB[`͗L  (There is feature of a version 2.)
			Opt3.version              = 3;
			Opt3.hol_count_flag       = 1;
			Opt3.st_year              = Opt2.st_year;
			Opt3.st_month             = Opt2.st_month;
			Opt3.en_year              = Opt2.en_year;
			Opt3.en_month             = Opt2.en_month;
			MemMove(&Opt3.memorial_flag[0],  &Opt2.memorial_flag[0],  6);
			Opt3.memorial_hol_flag[0] = 0;
			Opt3.memorial_hol_flag[1] = 0;
			Opt3.memorial_hol_flag[2] = 0;
			MemMove(&Opt3.memorial_year[0],  &Opt2.memorial_year[0],  6);
			MemMove(&Opt3.memorial_month[0], &Opt2.memorial_month[0], 6);
			MemMove(&Opt3.memorial_day[0],   &Opt2.memorial_day[0],   6);
			MemMove(&Opt3.memorial_col1[0],  &Opt2.memorial_col1[0],  6);
			MemMove(&Opt3.memorial_col2[0],  &Opt2.memorial_col1[0],  6);
			Opt3.memorial_flag[3]     = 0;
			Opt3.memorial_hol_flag[3] = 0;
			Opt3.memorial_year[3]     = Opt3.st_year;
			Opt3.memorial_month[3]    = 1;
			Opt3.memorial_day[3]      = 1;
			Opt3.memorial_col1[3]     = 0;
			Opt3.memorial_col2[3]     = 0;
			MemMove(&Opt3.week_color[0],     &Opt2.week_color[0],     14);
			Opt3.hol_color            = Opt2.hol_color;
			Opt3.data_ver             = 3;
			Opt3.beam_opt             = 0;
			Opt3.beam_flag            = 0x03;
			Opt3.beam_st_year         = Opt2.st_year;
			Opt3.beam_st_month        = Opt2.st_month;
			Opt3.beam_en_year         = Opt2.en_year;
			Opt3.beam_en_month        = Opt2.en_month;
		}
	}
}

//--------------------------------------------------------
//@Ft@C̃gK[ɒlݒ
//  A value is set as the trigger of a "color file".
//--------------------------------------------------------
void SetColorFileCategory(short CategoryList, short CategoryTrigger, short Button) {
	ListType *lstTable;
	short ix;

	lstTable = (ListType *)GetObjectPtr(CategoryList);
	for ( ix=0; ix<10; ix++ ) {
		Trigger_file_table[ix] = Trigger_file_data[ix];
	}
	ColorFileNameGet();
	Trigger_file_no = 0;
	for (ix=0;ix<Col_data_no;ix++) {
		StrCopy(Trigger_file_data[Trigger_file_no], &Col_file[ix][0]);
		Trigger_file_no++;
	}

	LstSetListChoices(lstTable, Trigger_file_table, Trigger_file_no);
	LstSetHeight(lstTable, Trigger_file_no);

	if ( Trigger_file_no == 0 ) {
		CtlHideControl(GetObjectPtr(Button));
		CtlHideControl(GetObjectPtr(CategoryTrigger));
	} else {
		CtlShowControl(GetObjectPtr(Button));
		CtlShowControl(GetObjectPtr(CategoryTrigger));
	}
}

//--------------------------------------------------------
//@P̗j荞(̌̓Ԃ)
//  The day of the week on the 1st is investigated.(The number of the days of the month is investigated.) 
//--------------------------------------------------------
short GetDayOfTheWeek(short year, short month, short *day_no) {
//year           N        (Year)
//month                  (Month)
//day_no         ̓  (The days of the month)
	long wk1, wk2;
	short oftheweek;
	long  month_s[12] = { 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 };
	long  month_n[12] = {31, 28, 31, 30,  31,  30,  31,  31,  30,  31,  30,  31 };
	//19040101   Friday

	wk1 = year;
	wk2 = (wk1 - 1904) * 365 + month_s[month-1] + (wk1 - 1901) / 4 + 5;
	wk2 = wk2 - (wk2 - 1) / 7 * 7;
	oftheweek = wk2;
	*day_no = month_n[month-1];
	if ((year == year / 4 * 4) && (month >= 3)) {
		oftheweek   = oftheweek + 1;
	}
	if ((year == year / 4 * 4) && (month == 2)) {
		*day_no = *day_no + 1;
	}
	oftheweek = oftheweek - (oftheweek - 1) / 7 * 7;
	if (oftheweek == 7) {
		oftheweek = 0;
	}
	return oftheweek;
}

//--------------------------------------------------------
//@mN̐}`
//  The figure of monochrome is eliminated.
//--------------------------------------------------------
void mono1e(short x, short y) {
//x              W      (X coordinates)
//y              W      (Y coordinates)
	short ib;
	for ( ib=0; ib<3; ib++ ) {
		WinEraseLine (x+ib+7, y, x+ib+7, y+7);
	}
}

//--------------------------------------------------------
//@mN̐}``
//  The figure of monochrome is described.
//--------------------------------------------------------
void mono2(short x, short y, short no, short type_no) {
//x          W      (X coordinates)
//y          W      (Y coordinates)
//no         F̔ԍ  (The number of the color)
//type_no    =1 |bvAbvXg  =2 ݂̐}`\  =3 Cʂœtg^bv  =4 F̐ݒ
//           =1 Pop-up list      =2 The selected color  =3 The date of a main screen  =4  Colors screen
	RectangleType r_col;
	short ib;
	short xs, ys, xe;
	switch (no) {
	case 1:
		r_col.topLeft.x = x;
		r_col.topLeft.y = y+1;
		switch ( type_no ) {
		case 1:
			r_col.extent.x  = 7;
			r_col.extent.y  = 7;
			break;
		case 2:
		case 4:
			r_col.extent.x  = 8;
			r_col.extent.y  = 8;
			break;
		case 3:
			r_col.topLeft.x = x;
			r_col.topLeft.y = y;
			r_col.extent.x  = 10;
			r_col.extent.y  = 8;
			break;
		}
		WinDrawRectangle (&r_col, 0);
		break;
	case 2:
	case 7:
		switch ( type_no ) {
		case 1:
		case 4:
			xs = x;
			xe = xs + 7;
			ys = y + 1;
			break;
		case 2:
			xs = x + 1;
			xe = xs + 7;
			ys = y + 1;
			break;
		case 3:
			xs = x;
			xe = xs + 9;
			ys = y;
			break;
		}
		WinDrawLine (xs, ys,   xe, ys);
		WinDrawLine (xe, ys,   xe, ys+7);
		WinDrawLine (xe, ys+7, xs, ys+7);
		WinDrawLine (xs, ys+7, xs, ys);
		if ( no == 7 ) {
			WinDrawLine (xs, ys+7, xe, ys);
			if ( type_no == 3 ) {
				WinDrawLine (xs+1, ys+7, xe, ys+1);
			}
		}
		break;
	case 3:
		switch ( type_no ) {
		case 1:
		case 4:
		case 2:
			xs = x + 6;
			ys = y + 6;
			break;
		case 3:
			xs = x + 9;
			ys = y + 4;
			break;
		}
		for ( ib=0; ib<5; ib++ ) {
			WinDrawLine (xs-ib, ys-ib, xs, ys-ib);
		}
		break;
	case 4:
		switch ( type_no ) {
		case 1:
		case 4:
		case 2:
			xs = x + 6;
			ys = y + 3;
			break;
		case 3:
			xs = x + 9;
			ys = y + 3;
			break;
		}
		for ( ib=0; ib<5; ib++ ) {
			WinDrawLine (xs-ib, ys+ib, xs, ys+ib);
		}
		break;
	case 5:
		switch ( type_no ) {
		case 1:
		case 4:
		case 2:
			xs = x + 1;
			ys = y + 3;
			break;
		case 3:
			xs = x;
			ys = y + 3;
			break;
		}
		for ( ib=0; ib<5; ib++ ) {
			WinDrawLine (xs+ib, ys+ib, xs, ys+ib);
		}
		break;
	case 6:
		switch ( type_no ) {
		case 1:
		case 4:
		case 2:
			xs = x + 1;
			ys = y + 4;
			break;
		case 3:
			xs = x;
			ys = y + 4;
			break;
		}
		for ( ib=0; ib<5; ib++ ) {
			WinDrawLine (xs+ib, ys-ib, xs,ys-ib);
		}
		break;
	}
}

//--------------------------------------------------------
//@J[XgCxgnhO
//  Event handling of color list.
//--------------------------------------------------------
void ColorList (short index, RectangleType *boundsP, short max_no, short col_data_no) {
//index          Xg̏  (Turn of a list)
//boundsP        `̈ʒu    (A rectangular position)
//max_no         Xg̐    (The number of lists)
//col_data_no    F̔ԍ     (The number of a color)

//LOʂł́AXg̐VƂ͌Ȃ̂ŁAmax_noAcol_data_no  Kv
//In a memorial day screen, the number of lists is not necessarily 7. Max_no and col_data_no are required.
	char  *number;
	short numberLen;
	short gPhoneX;
	RectangleType r_col;

	if ( index == max_no + 1 ) {
		gPhoneX   = 2;
		number    = ColorDefString;
		numberLen = StrLen(number);
//		WinDrawTruncChars(number, numberLen, gPhoneX, boundsP->topLeft.y,
//						  boundsP->extent.x + boundsP->topLeft.x - gPhoneX);
		WinDrawChars(number, numberLen, gPhoneX, boundsP->topLeft.y);
	} else if ( index == 0 ) {
		gPhoneX   = 2;
		number    = ColorNormalString;
		numberLen = StrLen(number);
//		WinDrawTruncChars(number, numberLen, gPhoneX, boundsP->topLeft.y,
//						  boundsP->extent.x + boundsP->topLeft.x - gPhoneX);
		WinDrawChars(number, numberLen, gPhoneX, boundsP->topLeft.y);
	} else {
		gPhoneX   = 10;
		number    = Color_def[col_data_no].text;
		numberLen = StrLen(number);
//		WinDrawTruncChars(number, numberLen, gPhoneX, boundsP->topLeft.y,
//						  boundsP->extent.x + boundsP->topLeft.x - gPhoneX);
		WinDrawChars(number, numberLen, gPhoneX, boundsP->topLeft.y);

		r_col.topLeft.x = 1;
		r_col.topLeft.y = boundsP->topLeft.y + 1;
		r_col.extent.x  = 8;
		r_col.extent.y  = 8;

		if (OS_Color_Support == 1) {//Color?
			WinSetBackColor(Color_def[col_data_no].color1_b);
			WinSetForeColor(Color_def[col_data_no].color1_b);
			WinFillRectangle(&r_col, 0);
			WinSetBackColor(0);
			WinSetForeColor(215);
		} else {
			mono2(r_col.topLeft.x, r_col.topLeft.y, col_data_no+1, 1);
		}
	}
}

//--------------------------------------------------------
//@݂̐FR[h\
//  The present color code is displayed. 
//--------------------------------------------------------
void ColorRectDisp2 (short ia, RectangleType r_col){
//ia             Xg̏  (Turn of a list)
//r_col          `̈ʒu    (A rectangular position)
	short ic;

	if ( ia != 0 && ia != 99 ) {//=99͕\ĂȂ  ^ʂ̍Փł̂ݎgp  (99 is a state which is not displayed. "Model screen" only use.)
		if (OS_Color_Support == 1) {//Color?
			WinSetBackColor(Color_def[ia-1].color1_b);
			WinSetForeColor(Color_def[ia-1].color1_b);
			WinFillRectangle(&r_col, 0);
			WinSetBackColor(0);
			WinSetForeColor(215);
		} else {
			for ( ic=0; ic<9; ic++ ) {
				WinEraseLine (r_col.topLeft.x+ic, r_col.topLeft.y, r_col.topLeft.x+ic, r_col.topLeft.y+9);
			}
			mono2(r_col.topLeft.x, r_col.topLeft.y, ia, 2);
		}
	} else {
		if (OS_Color_Support == 1) {//Color?
			WinSetBackColor(0);
			WinSetForeColor(0);
			WinFillRectangle(&r_col, 0);
			WinSetBackColor(0);
			WinSetForeColor(215);
		} else {
			for ( ic=0; ic<9; ic++ ) {
				WinEraseLine (r_col.topLeft.x+ic, r_col.topLeft.y, r_col.topLeft.x+ic, r_col.topLeft.y+9);
			}
		}
		WinDrawLine (r_col.topLeft.x, r_col.topLeft.y, r_col.topLeft.x+r_col.extent.x-1, r_col.topLeft.y+r_col.extent.y-1);
		WinDrawLine (r_col.topLeft.x+r_col.extent.x-1, r_col.topLeft.y, r_col.topLeft.x+r_col.extent.x-1, r_col.topLeft.y+r_col.extent.y-1);
		WinDrawLine (r_col.topLeft.x, r_col.topLeft.y, r_col.topLeft.x, r_col.topLeft.y+r_col.extent.y-1);
	}
}

//--------------------------------------------------------
//@IuWFNg̃|C^荞
//  The pointer of an object is got. 
//--------------------------------------------------------
void *GetObjectPtr (unsigned short objectID){
	FormPtr frm;

	frm = FrmGetActiveForm ();
	return (FrmGetObjectPtr(frm,FrmGetObjectIndex(frm,objectID)));
}
