//*****************************************************************************
//* Copyright (c) 2002-2004 Miday Workshop All rights reserved.
//*
//* File: MainWin.c
//*****************************************************************************

//general Palm OS includes
#include <PalmOS.h>
#include <TxtGlue.h>
#include <SonyCLIE.h>

//private includes
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//private value
#define X_AREAS 1
#define X_AREAD 80
#define Y_AREAS 38
#define Y_AREAD 67
#define X_SEL   11
#define Y_SEL   9

static RectangleType Select_r;
static unsigned long Yasumic;
static short Area1, Area2, Point_no, Day;
static short Undo_Area1, Undo_Area2, Undo_Day, Undo_Color;

#pragma mark ----

//--------------------------------------------------------
//@lQ̕ɕϊ
//  A numerical value is changed into the character string of double figures.
//--------------------------------------------------------
static void StrIToA2Byte(char *wk_char, long wk_number) {
	StrIToA(wk_char, wk_number);
	if ( wk_number <= 9 ) {
		wk_char[1] = wk_char[0];
		wk_char[0] = ' ';
	}
	wk_char[2] = '\0';
}

//--------------------------------------------------------
//@Wǂ̘gɑ邩`FbN
//  The frame with which coordinates belong is looked for.
//--------------------------------------------------------
static short PontCheck(short x, short y, RectangleType* r ) {
	short ia, xa, xb, ya, yb, kc, kd, ke;

	kd = Cu_Month;
	ke = Cu_Year;
	
	for ( ia=0; ia<4; ia++ ) {
		if ( ia == 0 || ia == 2 ) {
			xb    = X_AREAS;
			Area1 = 0;
		} else {
			xb    = X_AREAS + X_AREAD;
			Area1 = 1;
		}
		if ( ia == 0 || ia == 1 ) {
			yb    = Y_AREAS;
			Area2 = 0;
		} else {
			yb    = Y_AREAS + Y_AREAD;
			Area2 = 1;
		}
		if ((x>=xb && x<=xb+X_SEL*7-1) && (y>=yb && y<=yb+Y_SEL*6-1)){
			if ( ((x-xb) / X_SEL * X_SEL == (x-xb)) || ((y-yb) / Y_SEL * Y_SEL == (y-yb))) return 999;
			xa = (x-xb) / X_SEL;
			ya = (y-yb) / Y_SEL;
			r->topLeft.x = (xa * X_SEL) + xb + 1;
			r->topLeft.y = (ya * Y_SEL)  + yb + 1;
			r->extent.x  =  10;
			r->extent.y  =  8;
			kd = kd + ia;
			if ( kd > 12 ) {
				kd = kd - 12;
				ke = ke + 1;
			}
			Day = ya * 7 + xa - (GetDayOfTheWeek(ke, kd, &kc)-1);
			if ( Day < 0 || Day > kc ) Day = 0;
			return ya + (xa) * 7 + 1;
		}
	}
	return 999;
}

//--------------------------------------------------------
//@tg̐F𒲂ׂ
//  The color of the date frame is investigated.
//--------------------------------------------------------
static short ColorCheck(char color_code) {
	short ia;

	for ( ia=0; ia<Max_Color_no; ia++ ) {
		if ( Color_table_bit[ia] == ( color_code & Color_table_bit[ia] ) ) {
			return ia + 1;
		}
	}
	return 0;
}

//--------------------------------------------------------
//@xf[^\
//  Initial setting of a holiday data display.
//--------------------------------------------------------
static void Md_proc1(){
	Yasumic = 0;//1  (The first day)
}

//--------------------------------------------------------
//@xf[^\ihԂj
//  Holiday data display processing (painting out).
//--------------------------------------------------------
static void Md_proc22(short drawX, short drawY, short no){
//drawX          W               (X coordinates)
//drawY          W               (Y coordinates)
//no             Ŝǂ̌    (Which month for four months)
	RectangleType	r;
	short cu_color;

	cu_color = ColorCheck( Yasumi_dis[no][Yasumic] );
	if ( cu_color != 0 ) {
		if (OS_Color_Support == 1) {//Color?
			WinSetForeColor(Color_def[cu_color-1].color1_b);
			r.topLeft.x = drawX;
			r.topLeft.y = drawY+2;
			r.extent.x = X_SEL;
			r.extent.y = Y_SEL;
			WinPaintRectangle (&r, 0);
			WinSetForeColor(215);
		} else {//Monochrome
			if (cu_color != 0 ) {//xH  (Holiday?)
				r.topLeft.x = drawX;
				r.topLeft.y = drawY+2;
				mono2 (r.topLeft.x+1, r.topLeft.y, cu_color, 3);
			}
		}
	} else {//H  (Weekday?)
		if (OS_Color_Support == 1) {//Color?
			WinSetTextColor(215);
			WinSetBackColor(0);
		}
	}
}

//--------------------------------------------------------
//@xf[^\ihԂOj
//  Holiday data display processing (The pretreatment of painting out).
//--------------------------------------------------------
static void Md_proc21(char *wk_char, short drawX, short drawY, short no){
//wk_char        \镶      (The character string to display)
//drawX          W               (X coordinates)
//drawY          W               (Y coordinates)
//no             Ŝǂ̌    (Which month for four months)
	short cu_color;

	cu_color = ColorCheck( Yasumi_dis[no][Yasumic] );
	if ( cu_color != 0 ) {
		if (OS_Color_Support == 1) {//Color?
		} else {
			WinDrawChars (wk_char, 2, drawX, drawY);
		}
	} else {
		if (OS_Color_Support == 1) {//Color?
			WinSetTextColor(215);
			WinSetBackColor(0);
		}
		WinDrawChars (wk_char, 2, drawX, drawY);
	}
}

//--------------------------------------------------------
//@xf[^\ihԂ㏈j
//  Holiday data display processing (Post-processing of painting out).
//--------------------------------------------------------
static void Md_proc23(char *wk_char, short drawX, short drawY, short no){
//wk_char        \镶      (The character string to display)
//drawX          W               (X coordinates)
//drawY          W               (Y coordinates)
//no             Ŝǂ̌    (Which month for four months)
	short cu_color;

	cu_color = ColorCheck( Yasumi_dis[no][Yasumic] );
	if ( cu_color != 0 ) {
		if (OS_Color_Support == 1) {//Color?
			WinSetTextColor(Color_def[cu_color-1].color1_b);
			WinSetBackColor(0);
			WinEraseChars (wk_char, 2, drawX, drawY);
		} else {
			if ( cu_color == 1 ) {//ԁH  (=Monochrome && Color code=1)
				WinEraseChars (wk_char, 2, drawX, drawY);
			}
		}
	}
}

//--------------------------------------------------------
//@xf[^\㏈
//  Post-processing of a holiday data display.
//--------------------------------------------------------
static void Md_proc3(){
	Yasumic = Yasumic + 1; 
	if (OS_Color_Support == 1) {//Color?
		WinSetTextColor(215);//hԂ߂  (Painting out is returned.)
		WinSetBackColor(0);
	}
}

//--------------------------------------------------------
//@J_[f[^\
//  Calendar data is displayed.
//--------------------------------------------------------
static void DrawData(short year, short month){
	short i, j, k, ka, kb, kc, kd, ke, n;
	long na;
	char wk_char[3];

	wk_char[2] = '\0';
	for (n=0; n<3; n++){
		ke = year;
		kd = month;
		for (kb=0; kb<2; kb++){
			for (ka=0; ka<2; ka++){
				Md_proc1();
				i = GetDayOfTheWeek(ke, kd, &kc);
				j = 0;
				for (k=0; k<kc; k++){
					na = k + 1;
					if ( n != 1 ) {
						StrIToA2Byte(wk_char, na);
					}
					switch ( n ) {
					case 0:
						Md_proc21(wk_char, i*X_SEL+X_AREAS+(ka*X_AREAD)+1, j*Y_SEL+Y_AREAS+(kb*Y_AREAD)-1, kb*2+ka);
						break;
					case 1:
						Md_proc22(i*X_SEL+X_AREAS+(ka*X_AREAD), j*Y_SEL+Y_AREAS+(kb*Y_AREAD)-1, kb*2+ka);
						break;
					case 2:
						Md_proc23(wk_char, i*X_SEL+X_AREAS+(ka*X_AREAD)+1, j*Y_SEL+Y_AREAS+(kb*Y_AREAD)-1, kb*2+ka);
						break;
					}
					Md_proc3();
					i = i + 1;
					if ( i == 7 ) {
						i = 0;
						j = j + 1;
					}
				}
				kd = kd + 1;
				if ( kd > 12 ) {
					kd = kd - 12;
					ke = ke + 1;
				}
			}
		}
	}

	ke = year;
	kd = month;
	for (kb=0; kb<2; kb++){
		for (ka=0; ka<2; ka++){
			WinDrawChars (&Monthname[(kd-1)*5], 5, 10+(ka*25), 16+(kb*10));
			kd = kd + 1;
			if ( kd > 12 ) {
				kd = kd - 12;
				ke  = ke + 1;
			}
		}
	}

	for (ka=0; ka<2; ka++){
		for (kb=0; kb<2; kb++){
			for (i=0; i<8; i++){//c  (Vertical line)
				WinDrawLine ((i)*X_SEL+X_AREAS+(ka*X_AREAD), Y_AREAS+(kb*Y_AREAD),
				             (i)*X_SEL+X_AREAS+(ka*X_AREAD), Y_AREAS+(kb*Y_AREAD)+Y_SEL*6);
			}

			for (j=0; j<7; j++){//  (Horizontal line)
				WinDrawLine (X_AREAS+(ka*X_AREAD),         j*Y_SEL+Y_AREAS+(kb*Y_AREAD),
				             X_AREAS+(ka*X_AREAD)+X_SEL*7, j*Y_SEL+Y_AREAS+(kb*Y_AREAD));
			}
		}
	}
	for (ka=0; ka<2; ka++){
		for (k=0; k<7; k++){
			if ( Lang == 1 ) {
				WinDrawChars (&Weekname[k],   1, k*X_SEL+(ka*80)+4, 93);
			} else {
				WinDrawChars (&Weekname[k*2], 2, k*X_SEL+(ka*80)+3, 93);
			}
		}
	}
}

//--------------------------------------------------------
//@J[XgCxgnhO
//  Event handling of "color list".
//--------------------------------------------------------
static void MainWinColorList(short index, RectangleType *boundsP, char **itemsText) {
	ColorList (index, boundsP, Color_win_max_color, index-1);
}

//--------------------------------------------------------
//@݂̐FR[h\
//  The present color code is displayed. 
//--------------------------------------------------------
static void ColorRectDisp(short ia){
//ia             FR[h   (The number of the Color code)
	RectangleType r_col;

	r_col.topLeft.x = 112;
	r_col.topLeft.y = 3;
	r_col.extent.x  = 8;
	r_col.extent.y  = 8;
	ColorRectDisp2 (ia, r_col);
}

//--------------------------------------------------------
//@ʕ\ݒ
//  Initial setting.
//--------------------------------------------------------
static void MainWinInit(){
	FontID fontsize;

	WinSetUnderlineMode(noUnderline);
	fontsize = FntSetFont(stdFont);

	lstTable = (ListType *)GetObjectPtr(MainWinColorCategoryList);
	LstSetListChoices(lstTable, Color_table, Color_win_max_color+2);
	LstSetHeight(lstTable, Color_win_max_color+2);
	LstSetSelection(lstTable, 1);
	CtlSetLabel(GetObjectPtr(MainWinColorCategoryTrigger), LstGetSelectionText(lstTable, 0));
	LstSetDrawFunction(GetObjectPtr(MainWinColorCategoryList), MainWinColorList);
}

//--------------------------------------------------------
//@^Cg\
//  Title display processing.
//--------------------------------------------------------
static void DrawTitle(short year, short month) {
	char work[20], work2[20];
	char *title;
	short title_len;
	MemHandle StringH;
	char *StringP;

	StrIToA(work, year);
	StrCopy(work2,work);
	StringH = DmGetResource(strRsc, StringYEAR2);
	StringP = MemHandleLock(StringH);
	StrCat(work2, StringP);
	MemHandleUnlock(StringH);
	StrIToA2Byte(work, month);
	StrCat(work2,work);
	if ( Lang == 2 ) {
		StringH = DmGetResource(strRsc, StringMONTH);
		StringP = MemHandleLock(StringH);
		StrCat(work2, StringP);
		MemHandleUnlock(StringH);
	}

	title_len = StrLen(work2);
	title = MemPtrNew (title_len+1);
	StrNCopy(title,work2,title_len+1);
	FrmCopyTitle (FrmGetActiveForm (), title);
	MemPtrFree(title);
}

//--------------------------------------------------------
//@ʂ̃f[^zɓo^
//  The data of a screen is registered into area.
//--------------------------------------------------------
static void SetRedDatasOfArray() {
	short ia, ka, kb;
	for ( kb=0; kb<2; kb++ ) {
		for ( ka=0; ka<2; ka++ ) {
			ia = SetRedDataOfArray(Yasumi_year_dis[kb*2+ka], Yasumi_month_dis[kb*2+ka],
			                       &Yasumi_dis[kb*2+ka][0], Yasumi_no_dis[kb*2+ka]);
		}
	}
}

//--------------------------------------------------------
//@ʂ̃f[^zɓo^Aʂ
//  The data of a screen is registered into area and a screen is eliminated.
//--------------------------------------------------------
static void EraseWindow() {
	RectangleType	rect;

	rect.topLeft.x = 0;
	rect.topLeft.y = 0;
	rect.extent.x  = 160;
	rect.extent.y  = 160;
	RctInsetRectangle( &rect, -1);
	WinEraseRectangle (&rect, 0);
	SetRedDatasOfArray();
}

//--------------------------------------------------------
//@ʂɃf[^\
//  Data is displayed on a screen.
//--------------------------------------------------------
static void DrawWindow() {
	short ka, kb, kd, ke;

	DrawTitle(Cu_Year, Cu_Month);
	FrmDrawForm (frm);

	ke = Cu_Year;
	kd = Cu_Month;
	for ( kb=0; kb<2; kb++ ) {
		for ( ka=0; ka<2; ka++ ) {
			Yasumi_year_dis[kb*2+ka]  = ke;
			Yasumi_month_dis[kb*2+ka] = kd;
			GetRedDataOfArray(ke, kd, &Yasumi_dis[kb*2+ka][0], &Yasumi_no_dis[kb*2+ka]);
			kd = kd + 1;
			if ( kd > 12 ) {
				kd = kd - 12;
				ke = ke + 1;
			}
		}
	}

	ColorRectDisp (Color_no);
	DrawData(Cu_Year, Cu_Month);
}

//Version 3.2 Add Start
//--------------------------------------------------------
//@N֖߂
//  It returns to a starting agency.
//--------------------------------------------------------
static void return_agency() {
	DmSearchStateType state;
	LocalID dbID;

	if ( Dy_PrefGetData.From == 2 ) {//IN  (Dynamic starting?)
		Dy_PrefSetData.CrID  = Dy_PrefGetData.CrID;
		Dy_PrefSetData.From  = 1;
		Dy_PrefSetData.Year  = Dy_PrefGetData.Year;
		Dy_PrefSetData.Month = Dy_PrefGetData.Month;
		MemMove(&Dy_PrefSetData.Other[0], &Dy_PrefGetData.Other[0], 22);
		if ( DmGetNextDatabaseByTypeCreator( true, &state, 'appl', Dy_PrefGetData.CrID, true, &cardNo , &dbID) == 0 ) {
			PrefSetAppPreferences (Df_CreaID, Dy_to_ID, Dy_to_VerNum, &Dy_PrefSetData, sizeof (DY_PREFDATA), true);
			SysUIAppSwitch( cardNo, dbID, sysAppLaunchCmdNormalLaunch, NULL);
		}
	}
}
//Version 3.2 Add End

//--------------------------------------------------------
//@CxgnhO
//  Event handling.
//--------------------------------------------------------
Boolean MainWinHandleEvent (EventType * event){
	Boolean handled = false;
	char  wk_char[3];
	short list_no, cn_color, cu_color, j, kd, ke, ix, iy;
	unsigned long kl;

	frm = FrmGetFormPtr (MainWin);

	if (event->eType == penDownEvent){
		if ((Point_no = PontCheck(event->screenX, event->screenY, &Select_r )) != 999 ) {
			Dataupdateflag = 1;

			kd = Cu_Month;
			ke = Cu_Year;
			kd = kd + Area1 + Area2 * 2;
			if ( kd > 12 ) {
				kd = kd - 12;
				ke = ke + 1;
			}
			if ( Day != 0 ) {
				kl = Day - 1;
				cu_color = ColorCheck(Yasumi_dis[Area1 + Area2 * 2][kl] );
				if ( Undo_Area1 == Area1 && Undo_Area2 == Area2 && Undo_Day == Day ) {
					cn_color = Undo_Color;
				} else {
					cn_color = Color_no;
				}
				Undo_Area1 = Area1;
				Undo_Area2 = Area2;
				Undo_Day   = Day;
				Undo_Color = cu_color;
				switch ( cn_color ) {//ݑĨJ[  (The color of the present)
				case 0://Weekday
					if ( cu_color != 0 ) {
						if (OS_Color_Support == 1) {//Color?
							WinSetForeColor(0);
							WinPaintRectangle (&Select_r, 0);
							WinSetForeColor(215);

							WinSetTextColor(215);
							WinSetBackColor(0);
						} else {
							mono1e (Select_r.topLeft.x, Select_r.topLeft.y);
						}
						StrIToA2Byte(wk_char, Day);
						WinDrawChars (wk_char, 2,  Select_r.topLeft.x, Select_r.topLeft.y-2);

						for (j=0; j<7; j++){//  (Horizontal line)
							WinDrawLine (X_AREAS+(Area1*X_AREAD),         j*Y_SEL+Y_AREAS+(Area2*Y_AREAD),
							             X_AREAS+(Area1*X_AREAD)+X_SEL*7, j*Y_SEL+Y_AREAS+(Area2*Y_AREAD));
						}

						Yasumi_dis[Area1 + Area2 * 2][kl] = 0;

						if ( Day > 7 ) {
							kl = Day - 8;

							cu_color = ColorCheck( Yasumi_dis[Area1 + Area2 * 2][kl] );
							if ( cu_color != 0 ) {//TԑO̓ɃJ[͕tĂH  (Is a day one week ago a holiday?)
								Select_r.topLeft.y = Select_r.topLeft.y - 9;
								if (OS_Color_Support == 1) {//Color?
									WinSetForeColor(Color_def[cu_color-1].color1_b);
									WinPaintRectangle (&Select_r, 0);
									WinSetForeColor(215);

									WinSetTextColor(Color_def[cu_color-1].color1_b);
									WinSetBackColor(0);
									StrIToA2Byte(wk_char, Day-7);
									WinEraseChars (wk_char, 2,  Select_r.topLeft.x, Select_r.topLeft.y-2);
								} else {//Monochrome?
									if ( cu_color == 1 || cu_color == 2 || cu_color == 4 ||
									     cu_color == 5 || cu_color == 7 ) {//TԑO̓̃J[͉H  (What is the sign of a day one week ago?)
										Select_r.topLeft.y = Select_r.topLeft.y - 9;
										mono2 (Select_r.topLeft.x, Select_r.topLeft.y, cu_color, 3);
										StrIToA2Byte(wk_char, Day-7);
										if ( cu_color == 1 ) {
											WinEraseChars (wk_char, 2,  Select_r.topLeft.x, Select_r.topLeft.y-2);
										}
									}
								}
							}
						}
					}
					break;
				case 1://Holiday
				case 2:
				case 3:
				case 4:
				case 5:
				case 6:
				case 7:
					if ( cu_color != cn_color ) {
						if (OS_Color_Support == 1) {//Color?
							WinSetForeColor(Color_def[cn_color-1].color1_b);
							WinPaintRectangle (&Select_r, 0);
							WinSetForeColor(215);

							WinSetTextColor(Color_def[cn_color-1].color1_b);
							WinSetBackColor(0);
						}
						StrIToA2Byte(wk_char, Day);

						if (OS_Color_Support == 1) {//Color?
							WinEraseChars (wk_char, 2,  Select_r.topLeft.x, Select_r.topLeft.y-2);
						} else {//Monochrome 
							mono1e (Select_r.topLeft.x, Select_r.topLeft.y);
							if ( cn_color != 1 ) {
								WinDrawChars (wk_char, 2,  Select_r.topLeft.x, Select_r.topLeft.y-2);
							}
							mono2 (Select_r.topLeft.x, Select_r.topLeft.y, cn_color, 3);
							if ( cn_color == 1 ) {
								WinEraseChars (wk_char, 2,  Select_r.topLeft.x, Select_r.topLeft.y-2);
							}
						}
						for (j=0; j<7; j++){//  (Horizontal line)
							WinDrawLine (X_AREAS+(Area1*X_AREAD),         j*Y_SEL+Y_AREAS+(Area2*Y_AREAD),
							             X_AREAS+(Area1*X_AREAD)+X_SEL*7, j*Y_SEL+Y_AREAS+(Area2*Y_AREAD));
						}

						if (OS_Color_Support != 1) {//Monochrome 
							if ( Day > 7 ) {
								kl = Day-8;
								cu_color = ColorCheck( Yasumi_dis[Area1 + Area2 * 2][kl] );
								if ( cu_color == 1 || cu_color == 2 || cu_color == 4 ||
								     cu_color == 5 || cu_color == 7 ) {//TԑO̓̃J[͉H  (What is the sign of a day one week ago?)
									Select_r.topLeft.y = Select_r.topLeft.y - 9;
									mono2 (Select_r.topLeft.x, Select_r.topLeft.y, cu_color, 3);
									StrIToA2Byte(wk_char, Day-7);
									if ( cu_color == 1 ) {
										WinEraseChars (wk_char, 2,  Select_r.topLeft.x, Select_r.topLeft.y-2);
									}
								}
							}
						}
					}
					kl = Day-1;
					Yasumi_dis[Area1 + Area2 * 2][kl] = Color_table_bit[cn_color-1];
					break;
				}
			}
			handled = true;
		} else {
			Undo_Area1 = -1;
			if (event->screenX>=112 && event->screenX<=120 && event->screenY>=0 && event->screenY<=11) {//FgI  (The rectangle beside a trigger?)
				list_no = LstPopupList(GetObjectPtr(MainWinColorCategoryList));
				if ( list_no == Color_win_max_color + 1) {
					SetRedDatasOfArray();
					Color_call_win = 1;
					FrmGotoForm (ColorDefine);
				} else if ( list_no >= 0 ) {
					Color_no = list_no;
					ColorRectDisp(Color_no);
				}
			}
		}

	} else if (event->eType == penUpEvent){
			if ((Point_no = PontCheck(event->screenX, event->screenY, &Select_r )) != 999 ) {
			}

	} else if (event->eType == keyDownEvent){
		Undo_Area1 = -1;
		if (EvtKeydownIsVirtual(event)) {
			if (event->data.keyDown.chr == vchrJogUp || //WO  (Jog Up)
			    event->data.keyDown.chr == vchrPageUp) {//{^    (Page Up)
				EraseWindow();
				Cu_Month = Cu_Month - 4;
				if ( Cu_Month < 1 ) {
					Cu_Month = Cu_Month + 12;
					Cu_Year  = Cu_Year - 1;
				}
				DrawWindow();
			} else if (event->data.keyDown.chr == vchrJogDown || //WO  (Jog Down)
			           event->data.keyDown.chr == vchrPageDown) {//{^    (Page Down)
				EraseWindow();
				Cu_Month = Cu_Month + 4;
				if ( Cu_Month > 12 ) {
					Cu_Month = Cu_Month - 12;
					Cu_Year  = Cu_Year + 1;
				}
				DrawWindow();
			} else if (event->data.keyDown.chr == vchrJogPush ||//WO          (Jog Push)
			           event->data.keyDown.chr == vchrJogPushRepeat ||//WO   (Jog Push Repeat)
			           event->data.keyDown.chr == vchrJogPushedUp ||//WO     (Jog Push Up)
			           event->data.keyDown.chr == vchrJogPushedDown ) {//WO  (Jog Push Down)
			}
		}

	} else if (event->eType == popSelectEvent){
		Undo_Area1 = -1;
		switch (event->data.ctlSelect.controlID){
		case MainWinColorCategoryTrigger:
			lstTable = (ListType *)GetObjectPtr(MainWinColorCategoryList);
			if ( LstGetSelection(lstTable) == Color_win_max_color + 1 ) {
				SetRedDatasOfArray();
				Color_call_win = 1;
				FrmGotoForm (ColorDefine);
			} else if ( LstGetSelection(lstTable) >= 0 ) {
				Color_no = LstGetSelection(lstTable);
				ColorRectDisp(Color_no);
			}
//			handled = true;
			break;
		}
		
	} else if (event->eType == ctlSelectEvent){
		Undo_Area1 = -1;
		switch (event->data.ctlSelect.controlID){
		case MainWinModelButton:
			SetRedDatasOfArray();
			Back_md_flag = 0;
			FrmGotoForm (Model);
			break;
		case MainWinSaveButton:
			if ( FrmAlert(AltSave) == 0 ) {
				SetRedDatasOfArray();
				iy = 0;
				if ( Max_over_color_flag != 0 ) {
					if ( FrmAlert(AltColorOverSave) != 0 ) {
						iy = 1;
					}
				}
				if ( Max_over_text_flag != 0 ) {
					if ( FrmAlert(AltTextOverSave) != 0 ) {
						iy = 1;
					}
				}
				if ( iy == 0 ) {
					ix = Md_SetDatabase(1, Dt_FileName);
					PrefSetAppPreferences (Df_CreaID, 2, Md_Version, &Opt3, sizeof(OPTIONS3), true);
				}
				Stop_flag = 1;
				return_agency();    //Version 3.2 Add
			}
			break;
		case MainWinCancelButton:
			if ( Dataupdateflag == 1 ) {
				if ( FrmAlert(AltCancel) == 0 ) {
					Stop_flag = 1;
					return_agency();    //Version 3.2 Add
				}
			} else {
				Stop_flag = 1;
				return_agency();    //Version 3.2 Add
			}
			break;
		}

	}else if (event->eType == ctlRepeatEvent){
		Undo_Area1 = -1;
		switch (event->data.ctlRepeat.controlID){
		case MainWinPrevButton:
			EraseWindow();
			Cu_Month = Cu_Month - 4;
			if ( Cu_Month < 1 ) {
				Cu_Month = Cu_Month + 12;
				Cu_Year  = Cu_Year - 1;
			}

			DrawWindow();
			break;
		case MainWinNextButton:
			EraseWindow();
			Cu_Month = Cu_Month + 4;
			if ( Cu_Month > 12 ) {
				Cu_Month = Cu_Month - 12;
				Cu_Year  = Cu_Year + 1;
			}
			DrawWindow();
			break;
		}

	}else if (event->eType == menuEvent){
		Undo_Area1 = -1;
		if ( event->data.menu.itemID != Option11AboutCmd &&
		     event->data.menu.itemID != Option12AboutCmd ) {
			SetRedDatasOfArray();
		}

		switch (event->data.menu.itemID){
		case Option11ColorDefCmd:
		case Option12ColorDefCmd:
			Color_call_win = 1;
			FrmGotoForm (ColorDefine);
			break;
		case Option11ModelCmd:
		case Option12ModelCmd:
			Back_md_flag = 0;
			FrmGotoForm(Model);
			break;
		case Option11PrefCmd:
		case Option12PrefCmd:
			FrmGotoForm(Preferences);
			break;
		case Option11ToolsCmd:
		case Option12ToolsCmd:
			FrmGotoForm(Tools);
			break;
		case Option11BeamSendCmd:
		case Option12BeamSendCmd:
			Beam_trnce_flag = 1;
			FrmPopupForm(BeamWin);
			break;
//Version 3.2 Add Start
		case Option12BluetoothSendCmd:
			Beam_trnce_flag = 3;
			FrmPopupForm(BeamWin);
			break;
//Version 3.2 Add End
		case Option11AboutCmd:
		case Option12AboutCmd:
			FrmPopupForm(AboutDialog);
			break;
		}

	}else if (event->eType == frmOpenEvent){
		FrmSetMenu(frm, Option11MenuBar+Bluetooth_libflag*(Option12MenuBar-Option11MenuBar));
		Undo_Area1 = -1;
		MainWinInit();
		if ( Beam_trnce_flag == 2 || Beam_trnce_flag == 4 ) {
			FrmPopupForm(BeamWin);
			Beam_trnce_flag = 0;
		}
		DrawWindow();
		handled = true;

	}else if (event->eType == frmUpdateEvent){
		if ( MainWinRedraw == 1 ) {
			DrawData(Cu_Year, Cu_Month);
			MainWinRedraw = 0;
		}
	}

	return (handled);
}
