//*****************************************************************************
//* Copyright (c) 2002-2004 Miday Workshop All rights reserved.
//*
//* File: Model.c
//*****************************************************************************

//general Palm OS includes
#include <PalmOS.h>
#include <TxtGlue.h>
#include <SonyCLIE.h>

//private includes
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//private value
#define X_WEEKS 46
#define Y_WEEKS 38
#define Y_WEEKD 13
#define X_HOLS 104
#define Y_HOLS 132
#define X_SELC 8
#define Y_SELC 8

#define X_WEEK_CHAR 80
#define Y_WEEK_CHAR 35
#define X_HOL_CHAR 128
#define Y_HOL_CHAR 129

static short ModelWeekColorCategoryLists[8] = 
	{ ModelSunColorCategoryList, ModelMonColorCategoryList,
	  ModelTueColorCategoryList, ModelWedColorCategoryList,
	  ModelThuColorCategoryList, ModelFriColorCategoryList,
	  ModelSatColorCategoryList, ModelNatColorCategoryList };
static short ModelWeekColorCategoryTriggers[8] =
	{ ModelSunColorCategoryTrigger, ModelMonColorCategoryTrigger,
	  ModelTueColorCategoryTrigger, ModelWedColorCategoryTrigger,
	  ModelThuColorCategoryTrigger, ModelFriColorCategoryTrigger,
	  ModelSatColorCategoryTrigger, ModelNatColorCategoryTrigger };

static short Back_st_year, Back_st_month, Back_en_year, Back_en_month, Back_week_color[WEEK_DAYS_NO], Back_hol_color;

//--------------------------------------------------------
//@J[XgCxgnhO
//  Event handring of "color list".
//--------------------------------------------------------
static void ModelColorList (short index, RectangleType *boundsP, char **itemsText) {
	ColorList (index, boundsP, Color_win_max_color, index-1);
}

//--------------------------------------------------------
//@݂̐FR[h\
//  The present color code is displayed. 
//--------------------------------------------------------
static void ColorRectDisp (short ia, short ib){
//ia             FR[h     (The number of the Color code)
//ib             j̔ԍ   (DayOfTheWeek)
	RectangleType r_col;

	if ( ib < WEEK_DAYS_NO ) {
//j̏ꍇ  (Weekday)
		r_col.topLeft.x = X_WEEKS;
		r_col.topLeft.y = ib*Y_WEEKD+Y_WEEKS;
	} else {
//j̏ꍇ  (Holiday)
		r_col.topLeft.x = X_HOLS;
		r_col.topLeft.y = Y_HOLS;
	}
	r_col.extent.x  = X_SELC;
	r_col.extent.y  = Y_SELC;
	ColorRectDisp2 (ia, r_col);
}

//--------------------------------------------------------
//@gK[\̈悩`FbN
//  It checks in "trigger display domain".
//--------------------------------------------------------
static short ColorRectCheck (short ix, short iy){
	short ia;

//j  (Weekday)
	if (ix>=X_WEEKS && ix<=X_WEEKS+X_SELC) {
		for ( ia=0; ia<WEEK_DAYS_NO; ia++ ) {
			if (iy>=Y_WEEKS+ia*Y_WEEKD && iy<=Y_WEEKS+Y_SELC+ia*Y_WEEKD) {
				return ia;
			}
		}
	}
//j  (Holiday)
	if (ix>=X_HOLS && ix<=X_HOLS+X_SELC && iy>=Y_HOLS && iy<=Y_HOLS+Y_SELC) {
		return WEEK_DAYS_NO;
	}
	return 99;
}

//--------------------------------------------------------
//@ݒ
//  Initial setting.
//--------------------------------------------------------
static void ModelInit (){
	FontID fontsize;
	char work[20];
	short start_year, ix;

	start_year = Start_year;

	WinSetUnderlineMode(noUnderline);
	fontsize = FntSetFont(stdFont);

	//㕔̔N  (Year)
	for ( ix=0; ix<Year_no; ix++ ) {
		Start_Year_table[ix] = Start_Year_data[ix];
		End_Year_table[ix]   = End_Year_data[ix];
	}

	for (ix=0;ix<Year_no;ix++) {
		StrIToA(work, start_year+ix);
		StrCat(work, Year_suffix);
		StrCopy(Start_Year_data[ix],  work);
		StrCopy(End_Year_data[ix],    work);
	}

	lstTable = (ListType *)GetObjectPtr(ModelStartYearCategoryList);
	LstSetListChoices(lstTable, Start_Year_table, Year_no);
	LstSetHeight(lstTable, Year_no);
	if ( Opt3.st_year-Start_year >= 0 && Opt3.st_year-Start_year <= 9 ) {
		LstSetSelection(lstTable, Opt3.st_year-Start_year);
		CtlSetLabel(GetObjectPtr(ModelStartYearCategoryTrigger),LstGetSelectionText(lstTable, Opt3.st_year-Start_year));
	} else {
		LstSetSelection(lstTable, 2);
		CtlSetLabel(GetObjectPtr(ModelStartYearCategoryTrigger),LstGetSelectionText(lstTable, 2));
	}

	lstTable = (ListType *)GetObjectPtr(ModelEndYearCategoryList);
	LstSetListChoices(lstTable, End_Year_table, Year_no);
	LstSetHeight(lstTable, Year_no);
	if ( Opt3.en_year-Start_year >= 0 && Opt3.en_year-Start_year <= 9 ) {
		LstSetSelection(lstTable, Opt3.en_year-Start_year);
		CtlSetLabel(GetObjectPtr(ModelEndYearCategoryTrigger),LstGetSelectionText(lstTable, Opt3.en_year-Start_year));
	} else {
		LstSetSelection(lstTable, 2);
		CtlSetLabel(GetObjectPtr(ModelEndYearCategoryTrigger),LstGetSelectionText(lstTable, 2));
	}

	//㕔̌  (Month)
	for ( ix=0; ix<Month_no; ix++ ) {
		Start_Month_table[ix]    = Start_Month_data[ix];
		End_Month_table[ix]      = End_Month_data[ix];
	}

	for (ix=0;ix<Month_no;ix++) {
		StrIToA(work, ix+1);
		StrCat(work, Month_suffix);
		StrCopy(Start_Month_data[ix],  work);
		StrCopy(End_Month_data[ix],    work);
	}
	lstTable = (ListType *)GetObjectPtr(ModelStartMonthCategoryList);
	LstSetListChoices(lstTable, Start_Month_table, Month_no);
	LstSetHeight(lstTable, Month_no);
	LstSetSelection(lstTable, Opt3.st_month-1);
	CtlSetLabel(GetObjectPtr(ModelStartMonthCategoryTrigger),LstGetSelectionText(lstTable, Opt3.st_month-1));

	lstTable = (ListType *)GetObjectPtr(ModelEndMonthCategoryList);
	LstSetListChoices(lstTable, End_Month_table, Month_no);
	LstSetHeight(lstTable, Month_no);
	LstSetSelection(lstTable, Opt3.en_month-1);
	CtlSetLabel(GetObjectPtr(ModelEndMonthCategoryTrigger),LstGetSelectionText(lstTable, Opt3.en_month-1));

	//jƏj  (Weekday and Holiday)
	for (ix=0;ix<WEEK_DAYS_NO;ix++) {
		lstTable = (ListType *)GetObjectPtr(ModelWeekColorCategoryLists[ix]);
		LstSetSelection(lstTable, Opt3.week_color[0]);
		CtlSetLabel(GetObjectPtr(ModelWeekColorCategoryTriggers[ix]), LstGetSelectionText(lstTable, Opt3.week_color[0]));
	}

	lstTable = (ListType *)GetObjectPtr(ModelNatColorCategoryList);
	if ( Opt3.hol_color != 99 ) {
		CtlSetValue(GetObjectPtr(ModelNatHolidayCheckBox),1);
		LstSetSelection(lstTable, Opt3.hol_color);
		CtlSetLabel(GetObjectPtr(ModelNatColorCategoryTrigger), LstGetSelectionText(lstTable, Opt3.hol_color));
		CtlSetEnabled(GetObjectPtr(ModelNatColorCategoryTrigger),  true);
	} else {
		CtlSetValue(GetObjectPtr(ModelNatHolidayCheckBox),0);
		LstSetSelection(lstTable, 0);
		CtlSetLabel(GetObjectPtr(ModelNatColorCategoryTrigger), LstGetSelectionText(lstTable, 0));
		CtlSetEnabled(GetObjectPtr(ModelNatColorCategoryTrigger),  false);
	}

	for (ix=0;ix<WEEK_DAYS_NO+1;ix++) {
		lstTable = (ListType *)GetObjectPtr(ModelWeekColorCategoryLists[ix]);
		LstSetListChoices(lstTable, Color_table, Color_win_max_color+2);
		LstSetHeight(lstTable, Color_win_max_color+2);
		if ( ix<WEEK_DAYS_NO ) {
			LstSetSelection(lstTable, Opt3.week_color[ix]);
		} else {
			LstSetSelection(lstTable, Opt3.hol_color);
		}

		CtlSetLabel(GetObjectPtr(ModelWeekColorCategoryTriggers[ix]), LstGetSelectionText(lstTable, 0));

		LstSetDrawFunction(GetObjectPtr(ModelWeekColorCategoryLists[ix]), ModelColorList);
	}
}

//--------------------------------------------------------
//@xf[^ݒ菈
//  Setting of holiday data.
//--------------------------------------------------------
static void Hol_data_set(short flag) {
//flag           =0   =1 ǉ    (=0 Init  =1 Add)
	unsigned char Yasumi_red_t[31];
	short sai_no, sai_day[10], Yasumik_t;
	short ia, ib, id, ie, ig, ih, ix;

	if ( flag == 0 ) {//{^H  (Init?)
		Yasumi_no = 0;
	}

	for ( ia=Opt3.st_year; ia<=Opt3.en_year; ia++ ) {
		for ( ib=0; ib<12; ib++ ) {
			if (ia == Opt3.st_year && ib+1 < Opt3.st_month) continue;
			if (ia == Opt3.en_year && ib+1 > Opt3.en_month) break;

			GetRedDataOfArray(ia, ib+1, &Yasumi_red_t[0], &Yasumik_t);
			id = GetDayOfTheWeek(ia, ib+1, &ie);
			for ( ig=0; ig<ie; ig++ ) {
				if ( Opt3.week_color[id] != 0 ) {
					Yasumi_red_t[ig] = Color_table_bit[Opt3.week_color[id]-1];
				}
				id++;
				if ( id >= WEEK_DAYS_NO ) id = 0;
			}
			if ( Opt3.hol_color != 0 && Opt3.hol_color != 99 ) {
				GetHoliday( ia, ib+1, &sai_no, sai_day );
				for ( ig=0; ig<sai_no; ig++ ) {
					Yasumi_red_t[sai_day[ig]-1] = Color_table_bit[Opt3.hol_color-1];
				}
			}
			for ( ih=0; ih<4; ih++ ) {
				if ( Opt3.memorial_flag[ih] != 0 ) {
					if ((ia == Opt3.memorial_year[ih] || Opt3.memorial_year[ih] == 2999) && ib+1 == Opt3.memorial_month[ih] ) {
						if ( Yasumi_red_t[Opt3.memorial_day[ih]-1] == 0 ) {
							Yasumi_red_t[Opt3.memorial_day[ih]-1] = Color_table_bit[Opt3.memorial_col2[ih]-1];
						} else {
							Yasumi_red_t[Opt3.memorial_day[ih]-1] = Color_table_bit[Opt3.memorial_col1[ih]-1];
						}
					}
				}
			}
			ix = SetRedDataOfArray(ia, ib+1, &Yasumi_red_t[0], Yasumik_t);
		}
	}
}

//--------------------------------------------------------
//@tB[`̈f[^ݒ菈
//  Data setting of a feature.
//--------------------------------------------------------
static void Feature_Data_Set() {
	char work[20];
	MemHandle StringH;
	char      *StringP;
	short ia;

	StringH = DmGetResource(strRsc, StringEVERYYEAR);
	StringP = MemHandleLock(StringH);
	StrCopy(work, StringP);
	MemHandleUnlock(StringH);

	lstTable = (ListType *)GetObjectPtr(ModelStartYearCategoryList);
	Opt3.st_year  = LstGetSelection(lstTable) + Start_year;
	lstTable = (ListType *)GetObjectPtr(ModelStartMonthCategoryList);
	Opt3.st_month = LstGetSelection(lstTable) + 1;
	lstTable = (ListType *)GetObjectPtr(ModelEndYearCategoryList);
	Opt3.en_year  = LstGetSelection(lstTable) + Start_year;
	lstTable = (ListType *)GetObjectPtr(ModelEndMonthCategoryList);
	Opt3.en_month = LstGetSelection(lstTable) + 1;

	for ( ia=0; ia<WEEK_DAYS_NO; ia++ ) {
		Opt3.week_color[ia] = LstGetSelection(GetObjectPtr(ModelWeekColorCategoryLists[ia]));
	}
	if ( CtlGetValue(GetObjectPtr(ModelNatHolidayCheckBox)) == 1 ) {
		Opt3.hol_color = LstGetSelection(GetObjectPtr(ModelNatColorCategoryList));
	} else {
		Opt3.hol_color = 99;
	}
}

//--------------------------------------------------------
//@CxgnhO
//  Event handling.
//--------------------------------------------------------
Boolean ModelHandleEvent (EventType * event){
	Boolean handled = false;
	short label_Len, list_no, area_no, iz;
	char  *label_char;

	frm = FrmGetFormPtr (Model);

	if (event->eType == penDownEvent){
		area_no = ColorRectCheck(event->screenX, event->screenY);
		if ( (area_no != 99 && area_no != WEEK_DAYS_NO ) || (area_no == WEEK_DAYS_NO && Opt3.hol_color != 99) ) {//FgI
			list_no = LstPopupList(GetObjectPtr(ModelSunColorCategoryList+area_no*3));
			if ( list_no == Color_win_max_color + 1 ) {
				Color_call_win = 2;
				FrmGotoForm (ColorDefine);
			} else if ( list_no >= 0 ) {
				if ( area_no < WEEK_DAYS_NO ) {
					Opt3.week_color[area_no] = list_no;
				} else {
					Opt3.hol_color = list_no;
				}
				ColorRectDisp (list_no, area_no);

				if ( Opt3.hol_count_flag == 1 ) {
					if ( list_no == 0 ) {
						label_char = WeekString;
					} else {
						if ( Color_def[list_no-1].hol_flag == 0 ) {
							label_char = WeekString;
						} else {
							label_char = HolDefString;
						}
					}
				}
				label_Len = StrLen(label_char);

				if ( area_no < WEEK_DAYS_NO ) {
					WinDrawChars(label_char, label_Len, X_WEEK_CHAR, Y_WEEK_CHAR+area_no*Y_WEEKD);
				} else {
					WinDrawChars(label_char, label_Len, X_HOL_CHAR, Y_HOL_CHAR);
				}
			}
		}

	} else if (event->eType == penUpEvent){

	} else if (event->eType == keyDownEvent){
//		if (EvtKeydownIsVirtual(event)) {
//			if (event->data.keyDown.chr == vchrJogUp || //WO
//			    event->data.keyDown.chr == vchrPageUp) {//{^
//			} else if (event->data.keyDown.chr == vchrJogDown || //WO
//			           event->data.keyDown.chr == vchrPageDown) {//{^
//			} else if (event->data.keyDown.chr == vchrJogPush ||//WO
//			           event->data.keyDown.chr == vchrJogPushRepeat ||//WO
//			           event->data.keyDown.chr == vchrJogPushedUp ||//WO
//			           event->data.keyDown.chr == vchrJogPushedDown ) {//WO
//			}
//		}

	} else if (event->eType == popSelectEvent){
		area_no = 99;
		switch (event->data.ctlSelect.controlID){
		case ModelSunColorCategoryTrigger:
			area_no = 0; break;
		case ModelMonColorCategoryTrigger:
			area_no = 1; break;
		case ModelTueColorCategoryTrigger:
			area_no = 2; break;
		case ModelWedColorCategoryTrigger:
			area_no = 3; break;
		case ModelThuColorCategoryTrigger:
			area_no = 4; break;
		case ModelFriColorCategoryTrigger:
			area_no = 5; break;
		case ModelSatColorCategoryTrigger:
			area_no = 6; break;
		case ModelNatColorCategoryTrigger:
			area_no = 7; break;
		}
		if ( area_no != 99 ) {
			lstTable = (ListType *)GetObjectPtr(ModelSunColorCategoryList+area_no*3);
			if ( LstGetSelection(lstTable) == Color_win_max_color + 1 ) {
				Color_call_win = 2;
				FrmGotoForm (ColorDefine);
			} else if ( LstGetSelection(lstTable) >= 0 ) {
				if ( area_no < WEEK_DAYS_NO ) {
					Opt3.week_color[area_no] = LstGetSelection(lstTable);
				} else {
					Opt3.hol_color = LstGetSelection(lstTable);
				}
				ColorRectDisp (LstGetSelection(lstTable), area_no);

				if ( Opt3.hol_count_flag == 1 ) {
					if ( LstGetSelection(lstTable) == 0 ) {
						label_char = WeekString;
					} else {
						if ( Color_def[LstGetSelection(lstTable)-1].hol_flag == 0 ) {
							label_char = WeekString;
						} else {
							label_char = HolDefString;
						}
					}
				}
				label_Len = StrLen(label_char);

				if ( area_no < WEEK_DAYS_NO ) {
					WinDrawChars(label_char, label_Len, X_WEEK_CHAR, Y_WEEK_CHAR+area_no*Y_WEEKD);
				} else {
					WinDrawChars(label_char, label_Len, X_HOL_CHAR, Y_HOL_CHAR);
				}
			}

		}

	} else if (event->eType == ctlSelectEvent){
		switch (event->data.ctlSelect.controlID){
		case ModelMemorialButton:
			Back_me_flag = 0;
			Feature_Data_Set();
			FrmGotoForm (MemorialWin);
			break;
		case ModelInitButton:
			Feature_Data_Set();
			if ( ( Opt3.st_year > Opt3.en_year ) || ( Opt3.st_year == Opt3.en_year && Opt3.st_month > Opt3.en_month) ) {
				FrmAlert(AltRangeError);
				break;
			}
			Dataupdateflag = 1;
			Hol_data_set(0);
			FrmGotoForm (MainWin);
			break;
		case ModelAddButton:
			Feature_Data_Set();
			if ( ( Opt3.st_year > Opt3.en_year ) || ( Opt3.st_year == Opt3.en_year && Opt3.st_month > Opt3.en_month) ) {
				FrmAlert(AltRangeError);
				break;
			}
			Dataupdateflag = 1;
			Hol_data_set(1);
			FrmGotoForm (MainWin);
			break;
		case ModelDeleteButton:
			Feature_Data_Set();
			if ( ( Opt3.st_year > Opt3.en_year ) || ( Opt3.st_year == Opt3.en_year && Opt3.st_month > Opt3.en_month) ) {
				FrmAlert(AltRangeError);
				break;
			}
			if ( FrmAlert(AltDelete) == 0 ) {
				DeleteRedDataOfArray(LstGetSelection((ListType *)GetObjectPtr(ModelStartYearCategoryList)) + Start_year,
				                     LstGetSelection((ListType *)GetObjectPtr(ModelStartMonthCategoryList)) + 1,
				                     LstGetSelection((ListType *)GetObjectPtr(ModelEndYearCategoryList)) + Start_year,
				                     LstGetSelection((ListType *)GetObjectPtr(ModelEndMonthCategoryList)) + 1);
				Dataupdateflag = 1;
				FrmGotoForm (MainWin);
			}
			break;
		case ModelCancelButton:
			Opt3.st_year  = Back_st_year;
			Opt3.st_month = Back_st_month;
			Opt3.en_year  = Back_en_year;
			Opt3.en_month = Back_en_month;
			MemMove( &Opt3.week_color[0], &Back_week_color[0], 14 );
			Opt3.hol_color = Back_hol_color;

			FrmGotoForm (MainWin);
			break;

		case ModelNatHolidayCheckBox:
			iz = CtlGetValue(GetObjectPtr(ModelNatHolidayCheckBox));
			if ( iz == 0 ) {
				Opt3.hol_color = 99;
				CtlSetEnabled(GetObjectPtr(ModelNatColorCategoryTrigger),  false);
				CtlSetValue(GetObjectPtr(ModelNatHolidayCheckBox),0);
				LstSetSelection(lstTable, 0);
				CtlSetLabel(GetObjectPtr(ModelNatColorCategoryTrigger), LstGetSelectionText(lstTable, 0));
			} else {
				Opt3.hol_color = 0;
				CtlSetEnabled(GetObjectPtr(ModelNatColorCategoryTrigger),  true);
			}
			break;
		}

	}else if (event->eType == menuEvent){
		switch (event->data.menu.itemID){
		case Option2ColorDefCmd:
			Color_call_win = 2;
			FrmGotoForm (ColorDefine);
			break;
		case Option2MemorialCmd:
			Back_me_flag = 0;
			FrmGotoForm (MemorialWin);
			break;
		case Option2AboutCmd:
			FrmPopupForm(AboutDialog);
			break;
		}

	}else if (event->eType == frmOpenEvent){
		if ( Back_md_flag == 0 ) {
			Back_st_year  = Opt3.st_year;
			Back_st_month = Opt3.st_month;
			Back_en_year  = Opt3.en_year;
			Back_en_month = Opt3.en_month;
			MemMove( &Back_week_color[0], &Opt3.week_color[0], 14 );
			Back_hol_color = Opt3.hol_color;
		}
		Back_md_flag = 0;

		ModelInit ();
		FrmDrawForm (frm);
		WinDrawLine (  0, 30, 160,  30);
		WinDrawLine (105, 30, 105, 126);
		WinDrawLine (  0,126, 160, 126);
		for ( iz=0; iz<WEEK_DAYS_NO; iz++ ) {//SUN-SAT
			ColorRectDisp (Opt3.week_color[iz], iz);
			if ( Opt3.hol_count_flag == 1 ) {
				if ( Opt3.week_color[iz] == 0 ) {
					label_char = WeekString;
				} else {
					if ( Color_def[Opt3.week_color[iz]-1].hol_flag == 0 ) {
						label_char = WeekString;
					} else {
						label_char = HolDefString;
					}
				}
				label_Len = StrLen(label_char);
				WinDrawChars(label_char, label_Len, X_WEEK_CHAR, Y_WEEK_CHAR+iz*Y_WEEKD);
			}
		}
		ColorRectDisp (Opt3.hol_color, WEEK_DAYS_NO);
		if ( Opt3.hol_count_flag == 1 ) {
			if ( Opt3.hol_color == 0 ) {
				label_char = WeekString;
			} else {
				if ( Color_def[Opt3.hol_color-1].hol_flag == 0 ) {
					label_char = WeekString;
				} else {
					label_char = HolDefString;
				}
			}
			label_Len = StrLen(label_char);
			WinDrawChars(label_char, label_Len, X_HOL_CHAR, Y_HOL_CHAR);
		}
		handled = true;

	}else if (event->eType == frmUpdateEvent){
	}

	return (handled);
}
