//*****************************************************************************
//* Copyright (c) 2001-2004 Miday Workshop All rights reserved.
//*
//* File: get_hol_J.c
//*****************************************************************************

extern short GetDayOfTheWeek(short year, short month, short *day_no);
extern void GetHoliday( short year, short month, short *hol_no, short hol_day[] );

//--------------------------------------------------------
//@Nw肵čՓo
//  The national holiday of the month is calculated.
//--------------------------------------------------------
void GetHoliday( short year, short month, short *hol_no, short hol_day[] ) {
//year           N        (Year)
//month                  (Month)
//hol_no         Փ̐  (The number of national holidays)
//hol_day        Փ      (national holidays)
	short start_day, ia, dum;

	*hol_no = 0;
	start_day = GetDayOfTheWeek(year, month, &dum);
	switch (month) {
	case 1:
		*hol_no = 2;
		ia = 0;
		hol_day[ia] = 1;     	//U
		if ( start_day == 0 ) hol_day[ia] = 2;

		ia = 1;
		if (start_day < 2) {	//l̓
			hol_day[ia] = 9 - start_day;
		} else {
			hol_day[ia] = 16 - start_day;
		}
		break;
	case 2:
		*hol_no = 1;
		ia = 0;
		hol_day[ia] = 11;	//LO
		if ( start_day == 4 ) hol_day[0] = 12;
		break;
	case 3:
		*hol_no = 1;
		ia = 0;
		if ( year < 1980 ) {	//t̓
			hol_day[ia] = 20.8357 + 0.242194 * (year-1980)- (year-1983) / 4;
		} else {
			hol_day[ia] = 20.8431 + 0.242194 * (year-1980)- (year-1980) / 4;
		}
		if ( hol_day[ia] <= 21 ) {
			if ( start_day == (22 - hol_day[ia]) ) hol_day[ia]++;
		} else {
			if ( start_day == (29 - hol_day[ia]) ) hol_day[ia]++;
		}
		break;
	case 4:
		*hol_no = 1;
		ia = 0;
		hol_day[ia] = 29;	//݂ǂ̓
		if ( start_day == 0 ) hol_day[ia] = 30;
		break;
	case 5:
		*hol_no = 3;
		hol_day[0] = 3;		//@LO
		hol_day[1] = 4;		//̋x
		hol_day[2] = 5;		//q̓
		if ( start_day == 3 ) hol_day[2] = 6;
		break;
	case 7:
		*hol_no = 1;
		ia = 0;
		if ( year < 2003 ) {
			hol_day[ia] = 20;	//C̓
			if ( start_day == 2 ) hol_day[ia] = 21;
		} else {
			if (start_day < 2) {	//C̓
				hol_day[ia] = 16 - start_day;
			} else {
				hol_day[ia] = 23 - start_day;
			}
		}
		break;
	case 9:
		*hol_no = 2;
		ia = 0;
		if ( year < 2003 ) {
			hol_day[ia] = 15;	//hV̓
			if ( start_day == 0 ) hol_day[ia] = 16;
		} else {
			if (start_day < 2) {	//hV̓
				hol_day[ia] = 16 - start_day;
			} else {
				hol_day[ia] = 23 - start_day;
			}
		}

		ia = 1;
		if ( year < 1980 ) {	//H̓
			hol_day[ia] = 23.2588 + 0.242194 * (year-1980)- (year-1983) / 4;
		} else {
			hol_day[ia] = 23.2488 + 0.242194 * (year-1980)- (year-1980) / 4;
		}
		if ( hol_day[ia] <= 21 ) {
			if ( start_day == (22 - hol_day[ia]) ) hol_day[ia]++;
		} else {
			if ( start_day == (29 - hol_day[ia]) ) hol_day[ia]++;
		}

		if ( hol_day[1] - hol_day[0] == 2 ) {  	//̋x
			*hol_no   = 3;
			hol_day[2] = hol_day[1];
			hol_day[1] = hol_day[0] + 1;
		}
		break;
	case 10:
		*hol_no = 1;
		ia = 0;
		if (start_day < 2) {	//̈̓
			hol_day[ia] = 9 - start_day;
		} else {
			hol_day[ia] = 16 - start_day;
		}
		break;
	case 11:
		*hol_no = 2;
		ia = 0;
		hol_day[ia] = 3;	//̓
		if ( start_day == 5 ) hol_day[ia] = 4;

		ia = 1;
		hol_day[ia] = 23;	//ΘJӂ̓
		if ( start_day == 6 ) hol_day[ia] = 24;
		break;
	case 12:
		*hol_no = 1;
		ia = 0;
		hol_day[ia] = 23;	//Vca
		if ( start_day == 6 ) hol_day[ia] = 24;
		break;
	default:
		*hol_no = 0;
		break;
	}
}
